unit StringUtils;
//ok pour D2010
//19/1/08 : ajout transmission paramtres dans StrTrier et TProcTri
//l'unit comporte qq portions de code rcupr d'units delphi (sort)

interface

uses Windows, Classes, Graphics, ShellApi, SysUtils, Utils, Forms, Menus;

const
  k_LF = #10;
  k_CR = #13;
  k_CRLF = #13#10;
  k_CRLF2 = k_CRLF+k_CRLF;
  k_TAB  = #9;
  k_PageFeed = #12;
  k_VT = #11;
  k_textptrlen = 8; //nb car d'un pointeur traduit en texte - devrait correspondre  sizeof(pointer)*2

type
  TProcTri = function(S1,S2:string; datatri:pointer=nil):integer; // -1 si S1<S2 , 0 si = , 1 si S1>S2
//penser  utiliser AnsiCompareStr(S1,S2) et CompareValue( StrToFloatDef(S1,0) , StrToFloatDef(S2,0) )
  TProcInfo = procedure(info:string);

function Compacter(S:string):string;
procedure DecStr(var S:string;n:integer);//rduit la longueur de S
function StrDef(S,def:string):string;//si S est vide, renvoie def, sinon S
function PosLast(Substr,S:string):integer;
function compacterStr(src:string;sep:char):string; //supprime les lignes blanches
function decode_chaine(var S:string):boolean;
procedure SetProcInfo(procinfo_:TProcInfo);
function StringFromFile(const PF:string;share:word=fmShareDenyNone{Compat modif 30/11/07, trop de msgerr}):string;
//function StringFromFile(const PF:string;share:word=fmShareCompat):string;
procedure StringToFile(S:string; const PF:string);
procedure FileAddString(S:string; const PF:string);
function StringPrmSvte(var prms:string;ignligvide:boolean=false):string;
function StringPurgerComm(prms:string;suppligvide:boolean=false):string; //voir aussi LigValeur, StrValeur
procedure AddMenuItemsFromStrings(Fowner:TForm;Mn:TMenu;strs:string;MIclick: TNotifyEvent);
function CharsInString(chars,str:string):boolean;
function MajuDebTexte(txt:string):string;
function extraireChaine(posdeb:integer;sep:string;src:string):string;//dbut fix par posdeb, fin par dernier car avant sep, ou fin ligne
procedure desaccentuer(var S:string);
function StrDesaccentuer(S:string):string;
function TryOpen(PF:string):boolean;//vrifie si le fichier peut tre ouvert (teste ainsi s'il n'est pas ouvert dans une autre application)

function LireEtOterDebutStr(var src:string;nbcar:integer):string;
//fonctions sur chaines prcdes de leur taille
function LireLongString(var S:string):string;
function StringToLongString(S:string):string;
function StringToDelimString(S:string;noCRLF:boolean=false):string;
function LireDelimString(var S:string;noCRLF:boolean=false):string;
//fonctions d'origine sur Str avec sparateur char
function NbrSep(s:string;sep:char):integer;
function NbrStr(s:string;sep:char):integer;
function LireEtOterStr0(var src:string;sep:char):string;
function LireEtOterDernier(var src:string;sep:char):string;
function extraireStr(num:integer;src:string;sep:char):string;  //num=0..
function remplacerStr(num:integer;nv,src:string;sep:char):string;
function extraire(num:integer;src:string;sep:char):string;
function remplacer(num:integer;nv,src:string;sep:char):string;
function insererStr(num:integer;nv,src:string;sep:char):string;
function ajouterStr(nv,src:string;sep:char;sansdoublon:boolean=false):string;
function OterStr(num:integer;src:string;sep:char):string;
function PosStr(SubStr,Str,sep:string):integer;//position dans la liste (0...) : n de la string EGALE A rchstr
function PosLig(rchstr,src:string):integer; //0.., -1 si inconnu : n de la ligne EGALE A rchstr
function StringToTabString(S:string):string;//limine les blancs d'extrmit et remplace les groupes de blancs par un tab
//fonctions sur Str, pour traiter str comme stringlist
function StrNbrSep(s,sep:string;jusque:integer=0):integer;
function StrNbrStr(s,sep:string):integer;
function StrLireEtOterStr0(var src:string;sep:string):string;
function StrLireEtOterDernier(var src:string;sep:string):string;
function StrExtraire(num:integer;src,sep:string):string;
function StrRemplacer(num:integer;nv,src,sep:string):string;
function StrInserer(num:integer;nv,src,sep:string;remplacer:boolean=false):string;
function StrAjouter(nv,src,sep:string;sansdoublon:boolean=false):string;
function StrSupp(num:integer;src,sep:string):string;
function StrPos(rchstr,src,sep:string):integer; //0.., -1 si inconnu : n de la 1re string CONTENANT rchstr
function StrIndexOfPos(pos:integer;src,sep:string):integer; //0.., pos pointe un caractre de la chaine
procedure StrTrier(var src:string;sep:string; ProcTri:TProcTri=nil; datatri:pointer=nil);
function StrValeur(nom,src,sep:string;ignorecase:boolean=false;sepNV:char='='):string;
//fonctions sur lignes, idem Str, avec sep=k_CRLF
function LigNbrSep(s:string):integer;
function LigNbrStr(s:string):integer;
function LigLireEtOter(var src:string):string;
function LigLireEtOterDernier(var src:string;sep:char):string;
function LigExtraire(num:integer;src:string):string;
function LigRemplacer(num:integer;nv,src:string):string;
function LigInserer(num:integer;nv,src:string):string;
function LigAjouter(nv,src:string;sansdoublon:boolean=false):string;
function LigSupp(num:integer;src:string):string;
function LigPos(rchstr,src:string):integer; //0.., -1 si inconnu : n de la 1re ligne CONTENANT rchstr
function LigIndexOfPos(pos:integer;src:string):integer; //0.., pos pointe un caractre de la chaine
procedure LigTrier(var src:string; ProcTri:TProcTri=nil; datatri:pointer=nil);
function LigValeur(nom,src:string;ignorecase:boolean=false;sepNV:char='='):string;
//traducteurs
function  hex_str(var v;nboct:integer):string;
function int2hex(vali:integer):string;
function hex2int(S:string):integer;
function PtrToStr(p:pointer):string;//!!! n'utiliser qu'avec StrToPtr, car inverse le sens (le quartet bas est dans buf[0])
function StrToPtr(S:string):pointer;
function StrToPointer(S:string):pointer;
function PointerToStr(p:pointer):string;
function LireStrTab(var S:string):string;
function FinDeLigne(S:string):boolean;//true si S commence par CRLF
//S avec sparateurs tab
function getS(var S:string):string;
function getD(var S:string):double;
function getI(var S:string):integer;
function getP(var S:string):pointer;
function getB(var S:string):boolean;
//S avec sparateurs eSpace
function SgetS(var S:string):string;
function SgetD(var S:string):double;
function SgetI(var S:string):integer;
function SgetP(var S:string):pointer;
function SgetB(var S:string):boolean;
//S avec sparateurs crlf
function LgetS(var S:string):string;
function LgetD(var S:string):double;
function LgetI(var S:string):integer;
function LgetP(var S:string):pointer;
function LgetB(var S:string):boolean;
//S avec sparateurs Groupe d'espaces
function GgetS(var S:string):string;
function GgetD(var S:string):double;
function GgetI(var S:string):integer;
function GgetP(var S:string):pointer;
function GgetB(var S:string):boolean;
function GgetNF(var S:string):string; //sp = Groupe d'esp, ou " si S commence par "

function LoCase(C:char):char;  //manque dans System..
procedure CoderDecoderTexte34(var clair,code:string;CD:char);overload;//codage 3 to 4
function CoderDecoderTexte34(src:string;CD:char):string;overload;
procedure CoderDecoderTexte12(var clair,code:string;CD:char);overload;//codage 1 to 2
function CoderDecoderTexte12(src:string;CD:char):string;overload;

IMPLEMENTATION

USES WinTypes, WinProcs, Dialogs,  Controls, FileCtrl, StrUtils, ShlObj, ClipBrd;


function Compacter(S:string):string;
begin
  result:=StringReplace(S,' ','',[rfReplaceAll]);
end;                            { de Compacter }
{
-------------------------------------------------------------------------------
}
procedure DecStr(var S:string;n:integer);
var
  i: integer;
begin
  i:=length(S);
  if i>0 then SetLength(S,i-n);
end;
{
-------------------------------------------------------------------------------
}
function StrDef(S,def:string):string;//si S est vide, renvoie def, sinon S
begin
  if S='' then result:=def else result:=S;
end;
{
-------------------------------------------------------------------------------
!!!!! dans les fonctions qui suivent, s ne finit jamais par un sparateur !!!!!

>> s'il y a un sparateur en fin, c'est que la dernire chaine est vide

fonctions remanies fin 12/05, une fonction de base acceptant une chaine comme sparateur
et 2 dclinaisons avec sparateur caractre et sparateur k_CRLF

 <chaine 0><sep><chaine 1><sep>...<chaine n-1><sep><chaine n>
 (cette chaine comporte n sparateurs et n+1 chaines)
 cas particuliers :
   '' (chaine vide) >> contient une chaine (vide)
   azerty           >> contient une chaine (= 'azerty')
   azerty<sep>      >> contient 2 chaines ('azerty' et une chaine vide)
-------------------------------------------------------------------------------
}
function StrNbrSep(s,sep:string;jusque:integer=0):integer;
var
  i,l: integer;
begin
  result:=0;
  if jusque=0 then jusque:=length(s);
  l:=length(sep);
  i:=1;
  repeat
    i:=PosEx(sep,s,i);
    if (i=0) or (i>jusque) then break;
    inc(i,l);
    inc(result);
  until false;
end;
function NbrSep(s:string;sep:char):integer;
begin
  result:=StrNbrSep(s,sep);
end;
function LigNbrSep(s:string):integer;
begin
  result:=StrNbrSep(s,k_CRLF);
end;

function StrNbrStr(s,sep:string):integer;
begin
  result:=0;
  if s='' then exit;
  result:=StrNbrSep(s+sep,sep);
end;
function NbrStr(s:string;sep:char):integer;
begin
  result:=StrNbrStr(s,sep);
end;
function LigNbrStr(s:string):integer;
begin
  result:=StrNbrStr(s,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function PosNum(num:integer;src,sep:string):integer;
//renvoie la position du dbut de la numime chaine, 0 si pas trouv
begin
  if num<0 then raise exception.Create('PosNum : index ngatif');
  result:=0;
  if src='' then exit;
  result:=1;
  repeat
    if num=0 then exit;
    result:=PosEx(sep,src,result);
    if result=0 then exit;//pas trouv
    inc(result,length(sep));
    dec(num);
  until false;
end;
{
-------------------------------------------------------------------------------
}
function StrLireEtOterStr0(var src:string;sep:string):string;
//la fonction extrait la 1re sous-chaine et renvoie la chaine tronque
var
  i: integer;
begin
  i:=Pos(sep,src);
  if i=0 then begin //1 seule chaine
    result:=src;
    src:='';
  end else begin
    result:=Copy(src,1,i-1);
    delete(src,1,i+length(sep)-1);
  end;
end;
function LireEtOterStr0(var src:string;sep:char):string;
begin
  result:=StrLireEtOterStr0(src,sep);
end;
function LigLireEtOter(var src:string):string;
begin
  result:=StrLireEtOterStr0(src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function StrLireEtOterDernier(var src:string;sep:string):string;
//la fonction extrait la dernire sous-chaine et renvoie la chaine tronque
var
  j,i,sepprec: integer;
begin
  sepprec:=0;
  repeat
    i:=PosEx(sep,src,sepprec+1);
    if i=0 then break;
    sepprec:=i;
  until false;
  if sepprec=0 then begin
    result:=src;
    src:='';
  end else begin
    j:=sepprec+length(sep);
    Result:=copy(src,j,length(src)-j+1);
    SetLength(src,sepprec-1);
  end;
end;
function LireEtOterDernier(var src:string;sep:char):string;
begin
  result:=StrLireEtOterDernier(src,sep);
end;
function LigLireEtOterDernier(var src:string;sep:char):string;
begin
  result:=StrLireEtOterDernier(src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function StrExtraire(num:integer;src,sep:string):string;
//la fonction extrait la num ime (0..) sous-chaine spare par <sep>, sans changer la source
var
  i,ir: integer;
begin
  result:='';
  if src<>'' then src:=src+sep;
  i:=PosNum(num,src,sep); //pos dbut chaine
  if i=0 then exit;//pas trouv
  ir:=PosEx(sep,src,i); //dbut sep
  result:=Copy(src,i,ir-i);
end;
function extraireStr(num:integer;src:string;sep:char):string;
begin
  result:=StrExtraire(num,src,sep);
end;
function LigExtraire(num:integer;src:string):string;
begin
  result:=StrExtraire(num,src,k_CRLF);
end;
function extraire(num:integer;src:string;sep:char):string;
begin
  result:=StrExtraire(num,src,sep);
end;
{
-------------------------------------------------------------------------------
}
//la fonction - remplace la num ime (0..) sous chaine de src par nv et renvoie le rsultat
//            - ajoute des sparateurs suivant ncessit si num > nb.chaines
//pour remplacer, inserer, ajouter, la chaine insre peut comporter des sparateurs
function remplacerStr(num:integer;nv,src:string;sep:char):string;
begin
  result:=StrInserer(num,nv,src,sep,true);
end;
function StrRemplacer(num:integer;nv,src,sep:string):string;
begin
  result:=StrInserer(num,nv,src,sep,true);
end;
function LigRemplacer(num:integer;nv,src:string):string;
begin
  result:=StrInserer(num,nv,src,k_CRLF,true);
end;
function remplacer(num:integer;nv,src:string;sep:char):string;
begin
  result:=StrInserer(num,nv,src,sep,true);
end;
{
-------------------------------------------------------------------------------
}
function StrInserer(num:integer;nv,src,sep:string;remplacer:boolean=false):string;
//insre ou remplace  l'index num
var
  n,i,ir,lsep: integer;
begin
  if num<0 then raise exception.Create('StrInserer : index ngatif');
  lsep:=length(sep);
  if src<>'' then src:=src+sep;//autant de sep que de chaines
  n:=StrNbrSep(src,sep); //=1 pour 1 chaine
  if num<n then begin //insertion
    i:=PosNum(num,src,sep);
    if remplacer then begin
      ir:=PosEx(sep,src,i);
      delete(src,i,ir+lsep-i);
    end;
    insert(nv+sep,src,i);
  end else begin //ajout  (si num=1, ajout en 2 position)
    for i:=n to num-1 do src:=src+sep;
    src:=src+nv+sep;
  end;
  result:=Copy(src,1,length(src)-lsep); //limine le dernier sep
end;
function insererStr(num:integer;nv,src:string;sep:char):string;
begin
  result:=StrInserer(num,nv,src,sep);
end;
function LigInserer(num:integer;nv,src:string):string;
begin
  result:=StrInserer(num,nv,src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function StrAjouter(nv,src,sep:string;sansdoublon:boolean=false):string;
begin
//  if (not sansdoublon) or (StrPos(nv,src,sep)=-1) then begin chang le 16 12 07
  if (not sansdoublon) or (PosStr(nv,src,sep)=-1) then begin
    if src='' then src:=nv else src:=src+sep+nv;
  end;
  result:=src;
end;
function ajouterStr(nv,src:string;sep:char;sansdoublon:boolean=false):string;
begin
  result:=StrAjouter(nv,src,sep,sansdoublon);
end;
function LigAjouter(nv,src:string;sansdoublon:boolean=false):string;
begin
  result:=StrAjouter(nv,src,k_CRLF,sansdoublon);
end;
{
-------------------------------------------------------------------------------
}
function StrCompacter(src:string;sep:string):string;
//supprime les lignes blanches
var
  i,l: integer;
begin
  l:=length(sep);
  repeat
    i:=Pos(sep+sep,src);
    if i>0 then delete(src,i,l) else break;
  until false;
  l:=length(src)-l;
  if l>0 then begin //vrifier si sep en fin
    if PosEx(sep,src,l)=l then SetLength(src,l-1);
  end;
  result:=src;
end;
function compacterStr(src:string;sep:char):string;
begin
  result:=StrCompacter(src,sep);
end;
function LigCompacter(src:string):string;
begin
  result:=StrCompacter(src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function StrSupp(num:integer;src,sep:string):string;
{la fonction ote la num ime (0..) sous-chaine de src (y compris le
sparateur de droite) et renvoie le rsultat}
var
  d,f,l,i: integer;
begin
  if num<0 then raise exception.Create('StrSupp : index ngatif');
  result:=src;
  l:=length(sep);
  src:=src+sep;//pour faciliter
  d:=1;
  while num>-1 do begin
    f:=PosEx(sep,src,d);
    if f=0 then raise exception.Create('StrSupp:index aprs la fin');
    if num=0 then begin //on est sur la bonne
      Delete(src,d,f-d+l); //(f-1)-d+1 +lgsep
      i:=length(src)-l;
      if i>0 then SetLength(src,i);
      result:=src;
      exit;
    end;
    d:=f+l;
    dec(num);
  end;
end;
function OterStr(num:integer;src:string;sep:char):string;
begin
  result:=StrSupp(num,src,sep);
end;
function LigSupp(num:integer;src:string):string;
begin
  result:=StrSupp(num,src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function PosStr(SubStr,Str,sep:string):integer;//position dans la liste (0...) : n de la string EGALE A rchstr
var
i,j: integer;
begin
  result:=0;
  SubStr:=sep+SubStr+sep;
  Str:=sep+Str+sep;
  i:=1;
  repeat
    if PosEx(SubStr,Str,i)=i then exit;
    i:=PosEx(sep,Str,i+1);//svt
    if i=0 then break;
    inc(result);
  until false;
  result:=-1;
end;
function PosLig(rchstr,src:string):integer; //0.., -1 si inconnu : n de la ligne EGALE A rchstr
begin
  result:=PosStr(rchstr,src,k_CRLF);
end;

function StrPos(rchstr,src,sep:string):integer; //0.., -1 si inconnu : n de la 1re string CONTENANT rchstr
var
p,i: integer;
begin
  result:=-1;
  p:=Pos(rchstr,src);
  if p=0 then exit;
  src:=src+sep;
  result:=0;
  i:=0;
  repeat
    i:=PosEx(sep,src,i+1);
    if i>p then exit;
    inc(result);
  until false;
end;
function LigPos(rchstr,src:string):integer; //0.., -1 si inconnu : n de la 1re ligne CONTENANT rchstr
begin
  result:=StrPos(rchstr,src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function StrIndexOfPos(pos:integer;src,sep:string):integer; //0.., pos pointe un caractre de la chaine
var
  ix: integer;
begin
  result:=-1;
  ix:=0;
  while ix<pos do begin
    ix:=PosEx(sep,src,ix+1);
    inc(result);
    if ix=0 then exit;
  end;
end;
function LigIndexOfPos(pos:integer;src:string):integer; //0..
begin
  result:=StrIndexOfPos(pos,src,k_CRLF);
end;
{
-------------------------------------------------------------------------------
}
function extraireChaine(posdeb:integer;sep:string;src:string):string;
var
ix: integer;
begin
  ix:=PosEx(sep,src,posdeb);
  if ix=0 then ix:=length(src)+1;
  result:=Copy(src,posdeb,ix-posdeb);
end;
{
-------------------------------------------------------------------------------
}
procedure StrTrier(var src:string;sep:string; ProcTri:TProcTri=nil; datatri:pointer=nil);
// -1 si S1<S2 , 0 si = , 1 si S1>S2
var
pos_,lg_:array of integer;

  procedure QuickSort(L, R: Integer);
    function Compare(i,j:integer):integer;
    var
      S1,S2: string;
    begin
      S1:=Copy(src,pos_[i],lg_[i]);
      S2:=Copy(src,pos_[j],lg_[j]);
      if Assigned(ProcTri)
      then result:=ProcTri(S1,S2,datatri)
      else begin
        if S1=S2 then result:=0
        else begin
          if S1<S2 then result:=-1 else result:=1;
        end;
      end;
    end;
    procedure ExchangeItems(i,j:integer);
    var
      k:integer;
    begin
      k:=pos_[i];pos_[i]:=pos_[j];pos_[j]:=k;
      k:=lg_[i];lg_[i]:=lg_[j];lg_[j]:=k;
    end;
  var
    I, J, P: Integer;
  begin
    repeat
      I := L;
      J := R;
      P := (L + R) shr 1;
      repeat
        while Compare(I, P) < 0 do Inc(I);
        while Compare(J, P) > 0 do Dec(J);
        if I <= J then
        begin
          ExchangeItems(I, J);
          if P = I then
            P := J
          else if P = J then
            P := I;
          Inc(I);
          Dec(J);
        end;
      until I > J;
      if L < J then QuickSort(L, J);
      L := I;
    until I >= R;
  end;
var
  i,j,n,ls,k: integer;
  src_: string;
begin
  n:=StrNbrStr(src,sep);
  if n<2 then exit;//rien ou 1 seule sans sep
  SetLength(pos_,n);
  SetLength(lg_,n);
  src_:=src+sep;
  ls:=length(sep);
  j:=1;
  for i:=0 to n-1 do begin
    pos_[i]:=j;
    k:=PosEx(sep,src_,j);
    lg_[i]:=k-j;
    j:=k+ls;
  end;
  QuickSort(0,n-1);
  src:='';
  for i:=0 to n-1 do src:=src+Copy(src_,pos_[i],lg_[i])+sep;
  SetLength(src, length(src)-ls);
end;
procedure LigTrier(var src:string; ProcTri:TProcTri=nil; datatri:pointer=nil);
begin
  StrTrier(src,k_CRLF,ProcTri,datatri);
end;
{
-------------------------------------------------------------------------------
}
function StrValeur(nom,src,sep:string;ignorecase:boolean=false;sepNV:char='='):string;
//retrouve <valeur> dans une liste constitue de <nom>=<valeur><sep>...
var
  p,i: integer;
begin
  result:='';
  nom:=sep+nom+sepNV;
  src:=sep+src+sep;
  if ignorecase
   then p:=Pos(lowercase(nom),lowercase(src))
   else p:=Pos(nom,src);
  if p=0 then exit;
  inc(p,length(nom));
  i:=PosEx(sep,src,p);
  result:=Copy(src,p,i-p);
end;
function LigValeur(nom,src:string;ignorecase:boolean=false;sepNV:char='='):string;
begin
  result:=StrValeur(nom,src,k_CRLF,ignorecase,sepNV);
end;
{
-------------------------------------------------------------------------------
}
function decode_chaine(var S:string):boolean;
{
chaines de type TURBO
car reconnus:  ' encadrement de texte, '' donne '
               # transforme un nombre en caractre
               $ prfixe un hexadcimal (2 car)
hors cotes '...', les caractres suivants sont traits comme suit:
               <espace(#32)> non significatif
               ; fin de chaine-commentaire suit
}
var
  Sr                 :string;
  b,n                :word;

function lire_ch:boolean;
var
  C                  :char;
begin
  lire_ch:=false;
  repeat
    inc(b);
    if b>n then exit;
    C:=S[b];
    if C='''' then begin
      inc(b);
      if (b>n) or (S[b]<>'''') then begin
        lire_ch:=true;
        exit;
      end;
    end;
    Sr:=Sr+C;{range le car ou un des '}
  until false;
end;                            { de lire_ch }
{
decode_chaine---------------------------------------------------------------
}
function num2char:boolean;
var
  C                  :char;
  hex,deb            :boolean;
  i                  :word;
label fin;
begin
  num2char:=false;
  i:=0;
  hex:=false;
  deb:=true;{pour 1er chiffre}
  inc(b);
  if b>n then exit;
  if S[b]='$' then begin
    hex:=true;
    inc(b);
    if b>n then exit;
  end;

  repeat
    C:=S[b];
    if hex then begin
      C:=UpCase(C);
      case C of
       'A'..'F':i:=i*16+(ord(C)-55);
       '0'..'9':i:=i*16+(ord(C)-48);
       else goto fin;
      end;
    end else begin
      if C in ['0'..'9']
      then i:=i*10+(ord(C)-48)
      else goto fin;
    end;
    deb:=false;
    if i>255 then exit;
    inc(b);
    if b>n then goto fin;
  until false;

fin:
  if deb then exit;
  Sr:=Sr+chr(i);
  num2char:=true;
end;                            { de num2char }

{
decode_chaine---------------------------------------------------------------
}
label err;
begin
  Sr:='';
  n:=length(S);
  b:=1;
  while b<=n do begin
    case S[b] of
     ' ':inc(b);
     ';':b:=n+1;
     '''':if not lire_ch then goto err;{b pointe le car svt '}
     '#':if not num2char then goto err;
     else goto err;
    end;
  end;
  S:=Sr;
  decode_chaine:=true;
  exit;
err:
  decode_chaine:=false;
end;                            { de decode_chaine }
{
-------------------------------------------------------------------------------
}
function PosLast(Substr,S:string):integer;
// trouve la derniere occurence - pas optimis
var
  lg: integer;
  P,Pr,Ps: PChar;
begin
  result:=0;
  S:=S+#0;
  lg:=length(Substr);
  Substr:=Substr+#0;
  Pr:=PChar(S);
  Ps:=PChar(Substr);
  repeat
    P:=AnsiStrPos(Pr,Ps);
    if P<>Nil then Pr:=P+lg;
  until P=Nil;
  if Pr=Nil then exit;
  result:=Pr-PChar(S)-lg+1;
end;
{
-------------------------------------------------------------------------------
}
const
procinfo:TProcInfo=nil;
procedure SetProcInfo(procinfo_:TProcInfo);
begin
  procinfo:=procinfo_;
end;
function StringFromFile(const PF:string;share:word=fmShareDenyNone{Compat modif 30/11/07, trop de msgerr}):string;
//07/2010 : pour passage  l'unicode, les chaines n'acceptent plus de #0 interne
//9/4/08 : 10 essais avant abandon
var
lf: int64;
st:TFileStream;
buf: array of byte;
essais,ori: integer;
Sansi: AnsiString;
Swide: WideString;
begin
//  showmessage(inttostr(length(ansistring(pf)))+' '+inttostr(length(widestring(pf))));
  if Assigned(procinfo) then procinfo('charge '+PF);
  try
    result:='';
    if not FileExists(PF) then exit;
    for essais:=1 to 10 do begin
      try
        st:=nil;
        st:=TFileStream.Create(PF,fmOpenRead+Share);
        try
          result:='';
          lf:=st.Size;
          if lf=0 then exit; //fichier vide
          SetLength(buf,lf+1); //ok pour buf=byte
          st.Read(buf[0],lf); //charge tout
{$ifdef VER210}
//delphi 2010
          buf[lf]:=0;//zro terminal
          if buf[0]=0 then begin  //marqueur jp pour chaine unicode
            Swide:=PWideChar( @buf[1] );//on saute le marqueur et on range comme unicode
            result:=Swide;//delphi traduit
          end else begin //chaine crite par D7
            Sansi:=PAnsiChar( @buf[0] );//on range comme ansi
            result:=Sansi;//delphi traduit
          end;
{$else}
//delphi 7
          SetLength(result,lf);
          Move(buf[0],result[1],lf);  //clipboard.astext:=result;
          if Pos(#0 , result)>0 then ShowMessage('contient 1 car #0 : '+PF);
{$endif}
        finally
          FreeAndNil(st);
        end;
        exit;
      except
        if essais=10 then raise else Windows.Sleep(100);
      end;
    end;
  finally
    if Assigned(procinfo) then procinfo('');
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure StringToFile(S:string; const PF:string);
//07/2010 : pour passage  l'unicode, les chaines n'acceptent plus de #0 interne
const
k_mrk : byte = 0;
var
ls: int64;
F: file;
begin
  if Pos(#0 , S)>0 then begin
    ShowMessage('caractre #0 interdit ; erreur criture fichier : '+PF);
    exit;
  end;
  if Assigned(procinfo) then procinfo('range '+PF);
  ls:=length(S);
  AssignFile(F,PF);
  Rewrite(F,1);
  try
//prpare l'criture de chaines unicode sous D2010
{$ifdef VER210}
//delphi 2010
    BlockWrite(F,k_mrk,1); //range un marqueur byte
    ...
{$else}
//delphi 7
    if ls>0 then BlockWrite(F,S[1],ls);
{$endif}
  finally
    CloseFile(F);
    if Assigned(procinfo) then procinfo('');
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure FileAddString(S:string; const PF:string);
var
  st:TFileStream;
begin
  if (S='') {or (not )} then exit;
  st:=nil;
  if FileExists(PF)
   then st:=TFileStream.Create(PF,fmOpenReadWrite+fmShareCompat)
   else st:=TFileStream.Create(PF,fmCreate);
  try
    st.Seek(0,soFromEnd);
    st.Write(S[1],length(S));
  finally
    FreeAndNil(st);
  end;
end;
{
-------------------------------------------------------------------------------
}
function StringPrmSvte(var prms:string;ignligvide:boolean=false):string;
//prms vient de la lecture d'un fichier texte de paramtrage
//la string prms contient des lignes de commentaire commenant par ;
//la function lit les lignes de prms et les ote, et renvoie la premire ligne non commentaire
//si ignligvide, les lignes constitues de [<espaces>]<CRLF> sont traites comme commentaire
//7/7/8 : accepte des espaces avant le ;
begin
  while prms<>'' do begin
    result:=LigLireEtOter(prms);
    if (Trim(result)+' ')[1]<>';' then begin
      if not ( ignligvide and (Trim(result)='') ) then exit;//sinon ignorer
    end;
  end;
  result:='';//fin de fichier
end;
{
-------------------------------------------------------------------------------
}
function StringPurgerComm(prms:string;suppligvide:boolean=false):string;
//prms vient de la lecture d'un fichier texte de paramtrage
//la string prms contient des lignes de commentaire commenant par ;
//la function renvoie prms expurge des lignes de commentaire
//si suppligvide, les lignes constitues de [<espaces>]<CRLF> sont traites comme commentaire, cad supprimes
//dans tous les cas, supprime les lignes vides en fin
begin
  result:='';
  while prms<>'' do result:=result+StringPrmSvte(prms,suppligvide)+k_CRLF;
  result:=Trim(result);
end;
{
-------------------------------------------------------------------------------
}
procedure AddMenuItemsFromStrings(Fowner:TForm;Mn:TMenu;strs:string;MIclick: TNotifyEvent);
var
  S: string;
  MI: TMenuItem;
begin
  repeat
    S:=Trim( LigLireEtOter(strs) );
    if S='' then exit;
    MI:=TMenuItem.Create(Fowner);
    MI.Caption:=S;
    MI.OnClick:=MIclick;
    Mn.Items.Add(MI);
  until false;
end;
{
-------------------------------------------------------------------------------
}
function LireEtOterDebutStr(var src:string;nbcar:integer):string;
begin
  result:=Copy(src,1,nbcar);
  Delete(src,1,nbcar);
end;
{
-------------------------------------------------------------------------------
}
function CharsInString(chars,str:string):boolean;
var
  i: integer;
begin
  result:=true;
  for i:=1 to length(chars) do if Pos(chars[i],str)>0 then exit;
  result:=false;
end;
{
-------------------------------------------------------------------------------
}
function MajuDebTexte(txt:string):string;
begin
  result:=txt;
  if length(txt)>0 then result[1]:=UpCase(result[1]);
end;
{
-------------------------------------------------------------------------------
}
function StringToTabString(S:string):string;//limine les blancs d'extrmit et remplace les groupes de blancs par un tab
begin
  S:=Trim(S);
  result:='';
  while S<>'' do begin
    result:=result+k_TAB+LireEtOterStr0(S,' ');
    S:=Trim(S);
  end;
  result:=Trim(result);
end;
{
-------------------------------------------------------------------------------
}
function LireLongString(var S:string):string;
//pas d'erreur si S est vide
var
  i: int64;
begin
  i:=StrToIntDef( LireEtOterStr0(S,' ') , 0);
  result:=Copy(S,1,i);
  delete(S,1,i);
end;
{
-------------------------------------------------------------------------------
}
function StringToLongString(S:string):string;
begin
  result:=IntToStr(length(S))+' '+S;
end;
{
-------------------------------------------------------------------------------
}
const
k_DebDelimStr = '< dlimstr ';
function StringToDelimString(S:string;noCRLF:boolean=false):string;
//cet algorithme permet de conserver le mme sparateur si la chaine est inchange
//produit :
// <dlim>
// S<dlim>
//...
var
  del,del1: string;
  C:char;
begin
//  16/1/08 i:=33; del:='< dlimstr ';
  C:='A'; del:= k_DebDelimStr;
  repeat
    del1:=del+C+' >';
    if Pos(del1,S)=0 then begin
      del:=del1;
      if noCRLF
        then result:=del+S+del
        else result:=del+k_CRLF+S+del+k_CRLF;
      exit;
    end;
    inc(C);
    if C>'Z' then begin   //16/1/08
      C:='A';
      del:=del+'_';
    end;
  until false;
end;
{
-------------------------------------------------------------------------------
}
function LireDelimString(var S:string;noCRLF:boolean=false):string;
//pas d'erreur si S est vide
var
  del: string;
begin
  if Pos(k_DebDelimStr,S)<>1 then begin //ancienne version
    del:=LigLireEtOter(S); //dlimiteur sur la ligne
    result:=StrLireEtOterStr0(S,del+k_CRLF);
  end else begin
    if noCRLF then begin
      del:=LireEtOterStr0(S,'>')+'>';
      result:=StrLireEtOterStr0(S,del);
    end else begin
      del:=LigLireEtOter(S);
      result:=StrLireEtOterStr0(S,del+k_CRLF);
    end;
  end;
end;
{
-------------------------------------------------------------------------------
}
function hex_str(var v;nboct:integer):string;
type
  STR2 = string[2];
  function Hex(i:byte):STR2;
  const
    XCode : array[0..15] of char = '0123456789ABCDEF';
  begin
    i:=Lo(i);
    Hex:=XCode[i div 16]+XCode[i mod 16];
  end;
var
  tab                :array of byte absolute v;
  b:byte;
  S                  :string[254];
  i                  :integer;
begin
  S:='';
{$IFOPT R+}
  {$DEFINE DOUNOPT}
  {$R-}
{$ENDIF}
  for i:=1 to nboct do begin
    b:=tab[i-1];
    S:=Hex(b)+S;
  end;
{$IFDEF DOUNOPT}
  {$UNDEF DOUNOPT}
  {$R+}
{$ENDIF}
  hex_str:=S;
end;                            { de hex_str }

function int2hex(vali:integer):string;
var
  i,j: integer;
begin
  result:='';
  for i:= 1 to sizeof(vali)*2 do begin
    j:=vali and $0F;
    vali:=vali shr 4;
    if j<10 then j:=ord('0')+j else j:=ord('A')+j-10;
    result:=chr(j)+result;
  end;
end;

function hex2int(S:string):integer;
var
  i,j: integer;
  C: char;
begin
  result:=0;
  for i:=1 to length(S) do begin
    C:=UpCase(S[i]);
    j:=ord(C)-ord('A')+10;
    if j>15 then exit;
    if j<10 then j:=ord(C)-ord('0');
    if j<0 then exit;
    result:=(result shl 4)+j;
  end;
end;

function PtrToStr(p:pointer):string;//douteux...
//!!! n'utiliser qu'avec StrToPtr, car inverse le sens (le quartet bas est dans buf[0])
var
  buf: array[0..31] of char;
begin
fillchar(buf,sizeof(buf),0);
  BinToHex(@p,@buf,sizeof(pointer));
  result:=buf;
end;

function StrToPtr(S:string):pointer;
begin
  HexToBin(PChar(S),@result,sizeof(pointer));
end;

function StrToPointer(S:string):pointer;
begin
  result:=pointer(StrToIntDef('$'+S,0));
end;

function PointerToStr(p:pointer):string;
begin
  result:=IntToHex(integer(p),k_textptrlen);//Format('%p',[p]);
end;

function LireStrTab(var S:string):string; //=getS
begin
  result:=LireEtOterStr0(S,k_TAB);
end;

function FinDeLigne(S:string):boolean;//true si S commence par CRLF
begin
  result:= (S='') or (Pos(k_CRLF,S) = 1);
end;

function getS(var S:string):string; //sp = TAB
begin
  result:=LireEtOterStr0(S,k_TAB);
end;
function SgetS(var S:string):string; //sp = 1 espace
begin
  result:=LireEtOterStr0(S,' ');
end;
function LgetS(var S:string):string; //sp = CRLF
begin
  result:=LigLireEtOter(S);
end;
function GgetS(var S:string):string; //sp = Groupe d'esp
begin
  result:=LireEtOterStr0(S,' ');
  S:=TrimLeft(S);
end;
function GgetNF(var S:string):string; //sp = Groupe d'esp, ou " si S commence par "
begin
  if Copy(S,1,1)='"' then begin
    delete(S,1,1);
    result:=LireEtOterStr0(S,'"');
  end else result:=LireEtOterStr0(S,' ');
  S:=TrimLeft(S);
end;

function getD(var S:string):double;
begin
  result:=StrToFloatDef(getS(S),0);
end;
function SgetD(var S:string):double;
begin
  result:=StrToFloatDef(SgetS(S),0);
end;
function LgetD(var S:string):double;
begin
  result:=StrToFloatDef(LgetS(S),0);
end;
function GgetD(var S:string):double;
begin
  result:=StrToFloatDef(GgetS(S),0);
end;

function getI(var S:string):integer;
begin
  result:=StrToIntDef(getS(S),0);
end;
function SgetI(var S:string):integer;
begin
  result:=StrToIntDef(SgetS(S),0);
end;
function LgetI(var S:string):integer;
begin
  result:=StrToIntDef(LgetS(S),0);
end;
function GgetI(var S:string):integer;
begin
  result:=StrToIntDef(GgetS(S),0);
end;

function getP(var S:string):pointer;
begin
  result:=StrToPointer(getS(S));
end;
function SgetP(var S:string):pointer;
begin
  result:=StrToPointer(SgetS(S));
end;
function LgetP(var S:string):pointer;
begin
  result:=StrToPointer(LgetS(S));
end;
function GgetP(var S:string):pointer;
begin
  result:=StrToPointer(GgetS(S));
end;

function getB(var S:string):boolean;
begin
  result:=UPPERCASE(getS(S))='T';
end;
function SgetB(var S:string):boolean;
begin
  result:=UPPERCASE(SgetS(S))='T';
end;
function LgetB(var S:string):boolean;
begin
  result:=UPPERCASE(LgetS(S))='T';
end;
function GgetB(var S:string):boolean;
begin
  result:=UPPERCASE(GgetS(S))='T';
end;

function LoCase(C:char):char;  //manque dans System..
begin
  if (C in ['A'..'Z']) then C:=chr(ord(C)-ord('A')+ord('a'));
  result:=C;
end;

procedure CoderDecoderTexte34(var clair,code:string;CD:char);
//clair est considr comme un flux de bits ; on rcupre 6 bits, on cale  G, et a fait un caractre cod
//la chaine code ne contient donc aucun car de contrle 
var
  i,ls,ld,nblc,n,pbys,pbyd: integer;
  c1,c2,c3,c4: byte;
begin
  if CD='C' then begin
    ls:=length(clair);
    nblc:=ls mod 3;
    if nblc<>0 then begin
      nblc:=3-nblc;
      clair:=clair+StringOfChar(chr($FF),nblc);
      inc(ls,nblc);
    end;
    n:=ls div 3;
    SetLength(code,n*4+1);//3 octets en feront 4
    code[1]:=chr(33+nblc);//le 1er car contient le nb de cars nuls en fin
    pbys:=1;
    pbyd:=2;
    for i:=1 to n do begin  //n=nb de blocs de 3
      c1:=ord(clair[pbys]);
      c2:=ord(clair[pbys+1]);
      c3:=ord(clair[pbys+2]);
      code[pbyd]:=chr( (c1 shl 2) ); //6 bits du 1er
      code[pbyd+1]:=chr( (((c1 and $C0) shr 4) or (c2 shl 4)) );//les 2 derniers + les 4 premiers
      code[pbyd+2]:=chr( (((c2 and $F0) shr 2) or (c3 shl 6)) );//les 4 derniers + les 2 premiers
      code[pbyd+3]:=chr( (c3 and $FC) );//ya juste  slectionner
      inc(pbys,3);
      inc(pbyd,4);
    end;
    exit;
  end;
  if CD='D' then begin
    ls:=length(code);
    if ls=0 then begin
      clair:='';
      exit;
    end;
    n:=(ls-1) div 4;
    ld:=n*3;
    SetLength(clair,ld);
    nblc:=ord(code[1])-33;
    pbys:=2;
    pbyd:=1;
    for i:=1 to n do begin  //n=nb de blocs de 4
      c1:=ord(code[pbys]);
      c2:=ord(code[pbys+1]);
      c3:=ord(code[pbys+2]);
      c4:=ord(code[pbys+3]);
      clair[pbyd]:=chr( (c1 shr 2) or (c2 shl 4) );// 6+2
      clair[pbyd+1]:=chr( ((c2 and $F0) shr 4) or (c3 shl 2) );//4+4
      clair[pbyd+2]:=chr( (c3 shr 6) or c4 );//2+6
      inc(pbys,4);
      inc(pbyd,3);
    end;
    SetLength(clair,ld-nblc);//supprime les cars en trop
    exit;
  end;
  raise exception.Create('paramtre CD faux dans l''appel  CoderDecoderTexte');
end;
function CoderDecoderTexte34(src:string;CD:char):string;
begin
  if CD='C' then CoderDecoderTexte34(src,result,CD) else CoderDecoderTexte12(result,src,CD)
end;

procedure CoderDecoderTexte12(var clair,code:string;CD:char);
//clair est considr comme un flux de bits ; on rcupre 4 bits, on ajoute 63, et a fait un caractre cod de A  ..
//la chaine code ne contient donc aucun car de contrle 
var
  i,ls,ld,pby: integer;
  c1,c2,c3,c4: byte;
begin       //showmessage(chr(65));
  if CD='C' then begin
    ls:=length(clair);
    SetLength(code,ls*2);
    pby:=1;
    for i:=1 to ls do begin  //n=nb de blocs de 3
      c1:=ord(clair[i]);
      code[pby]:=chr( (c1 and $0F)+65 ); //6 bits du 1er
      code[pby+1]:=chr( (c1 shr 4)+65 );//les 2 derniers + les 4 premiers
      inc(pby,2);
    end;
    exit;
  end;
  if CD='D' then begin
    ls:=length(code);
    if ls=0 then begin
      clair:='';
      exit;
    end;
    ld:=ls div 2;
    SetLength(clair,ld);
    pby:=1;
    for i:=1 to ld do begin  //n=nb de blocs de 4
      c1:=ord(code[pby])-65;
      c2:=ord(code[pby+1])-65;
      clair[i]:=chr( c1 or (c2 shl 4) );// 6+2
      inc(pby,2);
    end;
    exit;
  end;
  raise exception.Create('paramtre CD faux dans l''appel  CoderDecoderTexte');
end;
function CoderDecoderTexte12(src:string;CD:char):string;
begin
  if CD='C' then CoderDecoderTexte12(src,result,CD) else CoderDecoderTexte12(result,src,CD)
end;

procedure desaccentuer(var S:string);
  procedure remplacer(var a_traiter:string; interdits:string; rempl_par:string);
  var
    i: integer;
  begin
    for i:=1 to length(interdits) do
      a_traiter:=StringReplace(a_traiter,interdits[i],rempl_par,[rfReplaceAll]);
  end;
begin
  remplacer(S,'\/:*?"<>|','_');
  remplacer(S,'','a');
  remplacer(S,'','e');
  remplacer(S,'','i');
  remplacer(S,'','o');
  remplacer(S,'','u');
  remplacer(S,'','c');

  remplacer(S,'','A');
  remplacer(S,'','E');
  remplacer(S,'','I');
  remplacer(S,'','O');
  remplacer(S,'','U');
  remplacer(S,'','C');
end;
function StrDesaccentuer(S:string):string;
begin
  desaccentuer(S);
  result:=S;
end;

function TryOpen(PF:string):boolean;//vrifie si le fichier peut tre ouvert (teste ainsi s'il n'est pas ouvert dans une autre application)
var
F: file;
begin
  result:=true;
  try
  try
    AssignFile(F,PF);
    Reset(F);
  except
    result:=false;
  end;
  finally
    try CloseFile(F) except end;
  end;
end;

initialization
  if k_textptrlen<>sizeof(pointer)*2 then ShowMessage('StringUtils : la taille du type pointeur a chang (k_textptrlen)');
finalization
end.


