unit USignetsWord;
{
18/5/04 : gre les applications IDES : LireEcrireProprietesIDES(LEI:byte; SLprop:TStrings; var Comments:string; PF: string; prms: byte);
  Les extensions reconnues sont celles listes dans k_ExtAppsIDES ci-aprs

27/4/04 : viter l'usage des signets - la proprit COMMENTS permet de dfinir la prsentation
  L'usage standard de COMMENTS est le suivant :
  - si la ligne commence par *, c'est un texte explicatif qui s'affiche dans MmDocNouv
  - si elle commence par ;, c'est un commentaire filtr  la lecture (version StringList de LireCommentsWX)
  - sinon, si la ligne contient |, elle est analyse comme :
      <texte  afficher> | <nom de la proprit> | <liste de choix, sparateur |>
      l'ordre recommand est : 1-prop auto  2-prop normales  3-adresses

31/08/02 : un signet reprsente soit un signet Word, soit une proprit
 du document Word ou Excel.

NB:- les premiers caractres de chaque signet jusque y compris le caractre _ doubl
       ne sont pas affichs, pour permettre un tri par ordre alphabtique ;
       suggestion : commencer les noms de signets par a1__, a2__, a3__...
   - si le signet n'a pas d'autres caractres (ex a11__, a223__, ...), il gnre
       une ligne sparatrice

DE PREFERENCE :
  - envoyer les signets par position et non par dfinir, les signets doivent
      tre entrs comme a : [<esp><esp>]
  - le nom de signet dans Word ne peut avoir plus de 40 caractres
  - dans OrgIdes, les signets commenant par 'AUTO' ne sont pas affichs

OBSOLETE :
NON   - chaque groupe de 2 caractres _ (__) est remplac par un espace
NON   - un signet tel que a1___X (avec 3 _) est accept et affiche <espace>X
}
interface
uses classes, oleserver;

const
//implmente les noms de signets partags par les applications
  k_nsiDATEBORD = 'DATEBORD'; //MADOPRO
  k_nsiREFBORD = 'REFBORD'; //MADOPRO
  k_nsiNUMDOSS = 'NUMDOSS'; //MADOPRO
  k_nsiNOMDOSS1 = 'NOMDOSS1'; //MADOPRO  COURRIERS
  k_nsiNOMDOSS2 = 'NOMDOSS2'; //MADOPRO  COURRIERS
  k_nsiRESPDOSS = 'RESPDOSS'; //MADOPRO
  k_nsiNUMCOMMANDE = 'NUMCOMMANDE'; //MADOPRO
  k_nsiTBLDESTS = 'TBLDESTS'; //MADOPRO
  k_nsiTBLBORD = 'TBLBORD'; //MADOPRO
  k_nsiTBLOBS = 'TBLOBS'; //MADOPRO
  k_nsiCODEDOC = 'CODEDOC'; //MADOPRO COURRIERS
  k_nsiTBLHSTDOC = 'TBLHSTDOC'; //MADOPRO
  k_nsiDATEETAT = 'DATEETAT'; //MADOPRO
  k_nsiTBLETATDIFF = 'TBLETATDIFF'; //MADOPRO
  k_nsiTBLAUDITDIFF = 'TBLAUDITDIFF'; //MADOPRO
  k_nsiTBLETATDOCRECUS = 'TBLETATDOCRECUS'; //MADOPRO
  k_nsiTBLETATDOCEMIS = 'TBLETATDOCEMIS'; //MADOPRO
  k_nsiTBLHDRECUS = 'TBLHDRECUS'; //MADOPRO
  k_nsiTBLHDEMIS = 'TBLHDEMIS'; //MADOPRO
  k_nsiTBLHSTGLOB = 'TBLHSTGLOB'; //MADOPRO
  k_nsiREFCOURRIER = 'REFCOURRIER'; //COURRIERS
  k_nsiOBJCOURRIER = 'OBJCOURRIER'; //COURRIERS
  k_nsiATTCOURRIER = 'ATTCOURRIER';// l'attention de ...  COURRIERS
//  k_nsiADRESSE = 'ADRESSE';
  k_nsiTITRE = 'TITRE';//Monsieur, ...  COURRIERS
  k_nsiNUMCHRONO = 'NUMCHRONO';//numro chronologique COURRIERS
  k_nsiDATE = 'DATE'; //COURRIERS
  k_nsiSIGNATAIRE = 'SIGNATAIRE'; //COURRIERS
  k_nsiRAISON = 'RAISON'; //MADOPRO  COURRIERS
  k_nsiATTENTION = 'ATTENTION'; //MADOPRO
  k_nsiADR1 = 'ADR1'; //MADOPRO COURRIERS
  k_nsiADR2 = 'ADR2'; //MADOPRO COURRIERS
  k_nsiADR3 = 'ADR3'; //MADOPRO COURRIERS
  k_nsiCPVILLE = 'CPVILLE'; //MADOPRO  COURRIERS
  k_nsiPAYS = 'PAYS'; //MADOPRO COURRIERS
  k_nsiSERVICE = 'SERVICE'; //COURRIERS

  k_nsiINDICE = 'INDICE'; //BASE
  k_nsiINDICES = 'INDICES'; //WINCOPS  BASE
  k_nsiDEBUTLISTAGE = 'DEBUTLISTAGE'; //WINCOPS  BASE
  k_nsiLISTEFEUILLETS = 'LISTEFEUILLETS'; // BASE

  k_prjstdNUMDOSS  = 'prjstdNUMDOSS';
  k_prjstdNOMDOSS  = 'prjstdNOMDOSS';
  k_prjstdCODEDOC  = 'prjstdCODEDOC';
  k_prjstdTITREDOC = 'prjstdTITREDOC';

//noms auto
  k_nsiAUTODATE = 'AUTODATE';
//  AUTOREPxNomBouton affiche un bouton qui lance automatiquement l'application rpertoire
//  AUTORCTxNomChamp rcupre le champ du contact pour le bouton x (1..9)
//  AUTORSOxNomChamp rcupre le champ de la socit pour le bouton x
//  AUTORCSxNomChamp rcupre le champ contact, ou socit  dfaut, pour le bouton x
//  AUTORMLxNomChamp est comme AUTORCS, mais est destin  cumuler les adresses mel (sparateur ;)
//  k_nsi = '';
{  k_nsiAUTOREPADR = 'AUTOREPADR';
  k_nsiAUTOREPNOMCOLL = 'AUTOREPNOMCOLL';
  k_nsiAUTOREPTITRE = 'AUTOREPTITRE';
  k_nsiAUTOREPSOC = 'AUTOREPSOC';
  k_nsiAUTOREPFAXCOLL = 'AUTOREPFAXCOLL';//prendra fax soc par dfaut}

//application
  k_appWord = 1;
  k_appExcel = 2;
  k_appIDES =  3;
  k_appAcad = 4;

//  k_addProp = TRUE;
//  k_clrProp = FALSE;
  k_propAdd = 1;
  k_propNoms = 2;
  k_propValeurs = 4;
  k_propComm = 8;

  k_lire = 1;
  k_ecrire = 2;
  k_imprimer = 4;

  k_ExtAppsIDES2 : string = '.IMEL.COW.FLC.BRD.AHR.MCH';//val par dfaut, mais est normalement affecte  la lecture de orgides.iif

function NomCommunSignet(SignetWord:string):string;// ote les caractres de tri
    {le partage des valeurs entre les modles se fait sur la base des noms communs,
    ce qui permet des affichages diffrents selon les modles ;
    par ex, a1__code et b2__code partagent la mme valeur.
    a1 : chaine de tri
    __ : sparateur (_ doubl)
    code : nom commun du signet (partag entre les modles)
    }
function NomAffSignet(SignetWord:string):string;
// ote les caractres de tri et remplace les _ par un espace
procedure LireProprietesWX(SLprop: TStrings; app:TOleServer; WX:integer; prms:byte);
//WX = 1:Word  2:Excel
function IsAppIDES(ext:string):boolean; //ext contient le point et l'extension : .imel
procedure LireEcrireProprietesIDES(LEI:byte; SLprop:TStrings; var Comments:string; PF: string; prms: byte);
procedure OuvrirEtLireEcrireProprietesWXI(LEI:byte; SLprop:TStrings; var Comments:string; PF: string; prms: byte);
procedure EcrireProprietesWX(SLprop: TStrings; app:TOleServer; WX:integer);overload;
procedure EcrireProprietesWX(prop:string; app:TOleServer; WX:integer);overload;
//SLprop doit tre de la forme signet=valeur
procedure EcrireProprieteWX(Nom,Val:string; app:TOleServer; WX:integer);
function LireCommentsWX(app:TOleServer; WX:integer):string;overload;
function LireCommentsWX(app:TOleServer; WX:integer; var SL:TStringList):string;overload;
function LireNbPagesWX(app:TOleServer; WX:integer):integer;
//WX = 1:Word  2:Excel

implementation

uses controls, variants, sysutils, forms, utils, Word97, Excel97, Office97, ComObj,
 dialogs, CFileHeader, StringUtils;

function IsAppIDES(ext:string):boolean;
begin
  ext:=UpperCase(ext);
  result:= Pos(ext+'.',k_ExtAppsIDES2+'.')>0;//(ext='.IMEL') {or (ext='.xxx') or ...} ;
end;

procedure LireEcrireProprietesIDES(LEI:byte; SLprop:TStrings; var Comments:string; PF: string; prms: byte);
//SLprop peut tre nil
var
  FH: TFileHeader;
  i: integer;
  add,nms, vlrs: boolean;
  S: string;
begin
  if LEI=k_imprimer then exit;
  FH:=TFileHeader.Create(NIL);
  try
    if LEI=k_lire then begin
      FH.LoadFromFile(PF);
      if (prms and k_propComm)=0
        then Comments:=''
        else Comments:=FH.GetValeur('comments');
      if SLprop=nil then exit;
      add:=(prms and k_propAdd)<>0;
      nms:=(prms and k_propNoms)<>0;
      vlrs:=(prms and k_propValeurs)<>0;
      if (nms or vlrs) then begin
        if not add then SLprop.Clear;
        for i:=1 to FH.Strings.Count do begin
          S:=FH.Strings[i-1];
          if Pos('comments',S)=1 then S:=''
          else begin
            if nms then begin
              if not vlrs then S:=FH.Strings.Names[i-1];
            end else if vlrs then S:=FH.Strings.ValueFromIndex[i-1];
          end;
          S:=Trim(S);
          if S<>'' then SLprop.Add(S);
        end;
      end;
    end else begin //crire
      if SLprop=nil then exit;
      for i:=1 to SLProp.Count do FH.SetValeur(SLProp.Names[i-1],SLProp.ValueFromIndex[i-1]);
      FH.UpdateFile(PF);
    end;
  finally
    FH.Free;
  end;
end;

procedure LireProprietesWX(SLprop: TStrings; app:TOleServer; WX:integer; prms:byte);
//si k_propAdd prsent, ajoute  SLprop, sauf si existe ; sinon vide SLprop
//prms = k_propAdd k_propNoms k_propValeurs
//si ni noms ni valeurs, SLprop peut tre NIL
var
  cdp:OleVariant;
  i,j: integer;
  iov,n: OleVariant;
  S,Su: string;
  add,nms, vlrs: boolean;
label NOADD;
begin
  if SLprop=nil then exit;
  add:=(prms and k_propAdd)<>0;
  nms:=(prms and k_propNoms)<>0;
  vlrs:=(prms and k_propValeurs)<>0;
  if not (nms or vlrs) then exit;
  if not add then SLprop.Clear;
//  cdp:=Null;
  case WX of
    k_appWord:  with app as TWordApplication do cdp:=ActiveDocument.CustomDocumentProperties;
    k_appExcel: with app as TExcelApplication do cdp:=ActiveWorkBook.CustomDocumentProperties;
  end;
//  if cdp=Null then exit;
  n:=cdp.Count;
  for i:=1 to n do begin
    iov:=i;
    S:='';
    if nms then begin
      S:=cdp.Item[i].Name;
      Su:=UpperCase(S);
      if add then begin
        for j:=1 to SLprop.Count do if UpperCase(SLprop[j-1])=Su then goto NOADD; //vite doublon
      end;
      if vlrs then S:=S+'='+cdp.Item[i].Value;
    end else begin
      if vlrs then S:=cdp.Item[i].Value;
    end;
    if Trim(S)<>'' then SLprop.Add( S );
NOADD:
  end;
end;

procedure OuvrirEtLireEcrireProprietesWXI(LEI:byte; SLprop:TStrings; var Comments:string; PF: string; prms: byte);
(*
LEI=k_lire, k_ecrire, k_imprimer
prms= k_propAdd + k_propNoms + k_propValeurs + k_propComm
k_propComm : renvoie les commentaires
les autres : voir LireProprietesWX
*)
var
//  app:TOleServer;
  Wapp: TWordApplication;
  Wd: _Document;
  Xapp: TExcelApplication;
  WX,lcid:integer;
  add:boolean;
  DocName,
  ovMP,
  ovFmt, ovF, ovT : OleVariant;
  savcur: TCursor;
  S: string;        //SL:TStringList;
begin
  WX:=0;
  S:=UpperCase(ExtractFileExt(PF));
  if IsAppIDES(S) then begin
    LireEcrireProprietesIDES(LEI,SLprop,Comments,PF,prms);
    exit;
  end;
  if S='.DOC' then WX:=k_appWord;
  if S='.XLS' then WX:=k_appExcel;
  if (WX=0) or (PF='') then exit;
  Wapp:=NIL;
  Xapp:=NIL;
  try  //SL:=TStringList.Create;
    try
      DocName := PF;
      savcur:=Screen.Cursor;
      Screen.Cursor:=crHourGlass;
      ovF:=false;
      ovT:=true;
      case WX of
        k_appWord:begin
          Wapp:=TWordApplication.Create(Application.MainForm);
          Wapp.AutoConnect:=false;
          Wapp.AutoQuit:=true;
          Wapp.ConnectKind:=ckNewInstance; //ressay le 11/6/05
//          Wapp.ConnectKind:=ckNewInstance;  5/8/04 : remis  RunningOrNew (dfaut) pour tenter d'viter les messages d'enreg normal.dot
          ovFmt:=wdOpenFormatDocument;
          ovMP:='';
          Wd:=Wapp.Documents.Open(DocName,ovF,
                             ovF,ovF,
                             ovMP,ovMP,
                             ovF,ovMP,
                             ovMP,ovFmt);
    {    function  Open(var FileName: OleVariant; var ConfirmConversions: OleVariant;
                       var ReadOnly: OleVariant; var AddToRecentFiles: OleVariant;
                       var PasswordDocument: OleVariant; var PasswordTemplate: OleVariant;
                       var Revert: OleVariant; var WritePasswordDocument: OleVariant;
                       var WritePasswordTemplate: OleVariant; var Format: OleVariant): WordDocument; safecall;}
          if LEI=k_lire then begin
            LireProprietesWX(SLprop,Wapp,WX,prms);
            if (prms and k_propComm)=0
              then Comments:=''
              else Comments:=LireCommentsWX(Wapp,WX);
          end else begin //crire ou imprimer
            EcrireProprietesWX(SLprop,Wapp,WX);
//LireProprietesWX(SL,Wapp,WX,k_propNoms+k_propValeurs);
//            Wapp.Options.Set_UpdateFieldsAtPrint(true);
//            Wapp.ActiveDocument.Save;
//            ShowMsg(Wd.Path);
            Wd.Fields.Update;
            Wd.Fields.Update;
          end;
          if LEI=k_ecrire then begin
            Wd.saved:=false;
            Wd.Save;
{            ShowMsg(FT[Wd.saved=true]);
            while not Wd.Saved do Wd.Save;
            Wd.PrintPreview;
            ShowMsg(FT[Wd.saved=true]); }
//            Wapp.ActiveDocument.SaveAs(DocName,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
          end;
          if LEI=k_imprimer then Wd.PrintOut(ovF,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
//          Wapp.ActiveDocument.Close(ovF,ovF,ovF);
          Wd.Close(ovF,ovF,ovF);
          Wapp.Disconnect; //autoQuit
//////////////////          Wapp.Quit(ovF);
        end;
        k_appExcel:begin
          Xapp:=TExcelApplication.Create(Application.MainForm);
          lcid:=0;
          Xapp.WorkBooks.Open(PF,//Filename: WideString;
                         EmptyParam,//UpdateLinks: OleVariant;
                         EmptyParam,//ReadOnly: OleVariant;
                         EmptyParam,//Format: OleVariant;
                         EmptyParam,//Password: OleVariant;
                         EmptyParam,//WriteResPassword: OleVariant;
                         EmptyParam,//IgnoreReadOnlyRecommended: OleVariant;
                         EmptyParam,//Origin: OleVariant;
                         EmptyParam,//Delimiter: OleVariant;
                         EmptyParam,//Editable: OleVariant;
                         EmptyParam,//Notify: OleVariant;
                         EmptyParam,//Converter: OleVariant;
                         EmptyParam,//AddToMru: OleVariant;
                         lcid);//lcid: Integer): safecall;
/////////////////A FINALISER
          if LEI=k_lire then begin
            LireProprietesWX(SLprop,Xapp,WX,prms);
            if (prms and k_propComm)=0
              then Comments:=''
              else Comments:=LireCommentsWX(Xapp,WX);
          end else begin //crire
            EcrireProprietesWX(SLprop,Xapp,WX);
            Xapp.ActiveWorkbook.RefreshAll;
          end;
          if LEI=k_ecrire then begin
            Xapp.ActiveWorkbook.Save(lcid);
          end;
          if LEI=k_imprimer then begin
            try
              Xapp.Run('auto_open'); //met  jour les champs
            except
              on EOleSysError do ;
            end;
            Xapp.ActiveWorkbook.PrintOut(
             EmptyParam,//From: OleVariant;
             EmptyParam,//To_: OleVariant;
             EmptyParam,//Copies: OleVariant;
             EmptyParam,//Preview: OleVariant;
             EmptyParam,//ActivePrinter: OleVariant;
             EmptyParam,//PrintToFile: OleVariant;
             EmptyParam,//Collate: OleVariant;
             lcid);//lcid: Integer
          end;
          XApp.ActiveWorkbook.Close(ovF,EmptyParam,EmptyParam,lcid);
          Xapp.Disconnect; //autoQuit
        end;
      end;
    finally
      Wapp.Free;
      Xapp.Free;
      Screen.Cursor:=savcur;   //SL.Free;
    end;
  except
    on E:EOleSysError do ShowMsg(E.Message);
  end;
end;

procedure EcrireProprietesWX(SLprop: TStrings; app:TOleServer; WX:integer);
begin
  if (SLprop=nil) then exit;
  EcrireProprietesWX(SLprop.text,app,WX);
end;

procedure EcrireProprietesWX(prop:string; app:TOleServer; WX:integer);
var
  cdp:OleVariant;
//  i: integer;
  ovty,ovnm,ovva: OleVariant;
  S: string;
begin
//  cdp:=Null;
  prop:=Trim(prop);
  if prop='' then exit;
  case WX of
    k_appWord:  with app as TWordApplication do cdp:=ActiveDocument.CustomDocumentProperties;
    k_appExcel: with app as TExcelApplication do cdp:=ActiveWorkBook.CustomDocumentProperties;
  end;
//  if cdp=Null then exit;
  repeat
    S:=LigLireEtOter(prop);
    ovty:=msoPropertyTypeString;
    ovnm:=LireEtOterStr0(S,'=');//SLprop.Names[i-1];
    ovva:='_';//SLprop.Values[ovnm];
    try
      cdp.Add( ovnm , false , ovty , ovva , EmptyParam);
    except
      on exception do ;// ShowMessage('erreur  la cration du nom de proprit : '+ovnm);
    end;
//    S:=SLprop.ValueFromIndex[i-1];//ovva;
    if S='' then S:=' ';
    cdp.Item[ovnm].Value:=S;
  until prop='';
end;

procedure EcrireProprieteWX(Nom,Val:string; app:TOleServer; WX:integer);
var
  cdp:OleVariant;
  ovty,ovnm,ovva: OleVariant;
begin
//  cdp:=Null;
  case WX of
    k_appWord:  with app as TWordApplication do cdp:=ActiveDocument.CustomDocumentProperties;
    k_appExcel: with app as TExcelApplication do cdp:=ActiveWorkBook.CustomDocumentProperties;
  end;
//  if cdp=Null then exit;
  ovty:=msoPropertyTypeString;
  ovnm:=Nom;
//  if Val='' then Val:='.';//29/1/03
  ovva:='_';//Val;
  try
    cdp.Add( ovnm , false , ovty , ovva , EmptyParam);
  except
    on exception do;
  end;
  cdp.Item[ovnm].Value:=Val;//ovva;
end;

function NomCommunSignet(SignetWord:string):string;
// ote les caractres de tri - utilis par CSGsignets
var
  i,j,n_: integer;
begin
  i:=Pos('__',SignetWord);
  if i>0 then Delete(SignetWord,1,i+1);//i marque le 1er _
  result:=SignetWord;
end;

function NomAffSignet(SignetWord:string):string;
// ote les caractres de tri - utilis par CSGsignets
// remplace _ par ' '
begin
  result:=StringReplace(NomCommunSignet(SignetWord) ,
                        '_' ,
                        ' ' ,
                        [rfReplaceAll, rfIgnoreCase] );
end;

function LireCommentsWX(app:TOleServer; WX:integer):string;
//WX = 1:Word  2:Excel
var
  bdp:OleVariant;
begin
  case WX of
    k_appWord:  with app as TWordApplication do bdp:=ActiveDocument.BuiltinDocumentProperties;
    k_appExcel: with app as TExcelApplication do bdp:=ActiveWorkBook.BuiltinDocumentProperties;
  end;
  result:=bdp.Item['Comments'].Value;
end;

function LireCommentsWX(app:TOleServer; WX:integer; var SL:TStringList):string;
var
  i: integer;
begin
  result:=LireCommentsWX(app,WX);
  SL:=TStringlist.Create;
  SL.Text:=result;
  for i:= SL.Count downto 1 do if Copy(Trim(SL[i-1]),1,1)=';' then SL.Delete(i-1);//filtre les commentaires
end;

function LireNbPagesWX(app:TOleServer; WX:integer):integer;
//WX = 1:Word  2:Excel
var
  bdp:OleVariant;
  S: string;
begin
  case WX of
    k_appWord:  with app as TWordApplication do bdp:=ActiveDocument.BuiltinDocumentProperties;
    k_appExcel: with app as TExcelApplication do bdp:=ActiveWorkBook.BuiltinDocumentProperties;
  end;
  S:=bdp.Item[14].Value;
  result:=StrToInt( Trim(S) );
  //XL Nombre de pages (14)
  //W Number of Pages (14)
end;

end.
