unit Utils;
// le 5/6/04 : INITIALISE DECIMALSEPARATOR A "." !!!!!!!!!!!!!!!!!!!!!!
// le 29/8/05 : ajout Slog, AddLog, SaveLog
interface

uses WinTypes, WinProcs, Dialogs, Controls, ComCtrls, ExtCtrls, FileCtrl, Windows, Classes,  Forms, Graphics,
     ShellApi, Messages, SysUtils, UEdLigDlg, ActiveX, Menus, CheckLst;
type
  TTabByte = array[0..65519] of byte;
  TByteArray = array[0..Maxint-1] of byte;

  ArrayOfPointer = array of pointer;
  ArrayOfDouble = array of double;
  ArrayOfInteger = array of integer;

  TW32 = record
    Low,Hiw: word;
  end;
  TI64 = record
    LoI,HiI: cardinal;
  end;
  TfncMAJ = function(SL:TStringList;data:pointer):boolean;
  TfncMAJtxt = function(var txt:string;data:pointer):boolean;
  TSortCompare = function(p1,p2:pointer;croissant:boolean):Integer;// <0 si p1 est avant p2, =0 si gal, ..., utiliser Math.CompareValue(, SysUtils.CompareStr(

  EIdesError = class (Exception);

  TFileData = class   //voir FindFiles2
    Time: int64;
    Size: int64;
    Attr: int64;
    dwFileAttributes: DWORD;
    ftCreationTime,
    ftLastAccessTime,
    ftLastWriteTime,
    nFileSize: int64;
    constructor Create(SR: TSearchRec);
  end;

const
  PiSur2             = PI / 2 ;//1.570796;

  FT : array[boolean] of char = 'FT';
  NonOui : array[boolean] of char = 'NO';
{  gdG = 1;
  gdD = 2;
  gdGD = 3;}

  k_verrNomPC = 1;
  k_verrNomUtil = 2;

  k_peDrive = 0;
  k_peDir = 1;
  k_peNom = 2;
  k_peExt = 3;
  k_peNomExt = 4;
  k_peDrvDir = 5;

//pour OuvrirDoc
  k_odOuvrir = 1;
  k_odImprimer = 2;

  k_cidlen = 32; //lg CID de GetCID

(*#define FILE_ATTRIBUTE_READONLY             0x00000001
#define FILE_ATTRIBUTE_HIDDEN               0x00000002
#define FILE_ATTRIBUTE_SYSTEM               0x00000004
//OLD DOS VOLID                             0x00000008

#define FILE_ATTRIBUTE_DIRECTORY            0x00000010
#define FILE_ATTRIBUTE_ARCHIVE              0x00000020
#define FILE_ATTRIBUTE_DEVICE               0x00000040
#define FILE_ATTRIBUTE_NORMAL               0x00000080

#define FILE_ATTRIBUTE_TEMPORARY            0x00000100
#define FILE_ATTRIBUTE_SPARSE_FILE          0x00000200
#define FILE_ATTRIBUTE_REPARSE_POINT        0x00000400
#define FILE_ATTRIBUTE_COMPRESSED           0x00000800

#define FILE_ATTRIBUTE_OFFLINE              0x00001000
#define FILE_ATTRIBUTE_NOT_CONTENT_INDEXED  0x00002000
#define FILE_ATTRIBUTE_ENCRYPTED            0x00004000

#define FILE_ATTRIBUTE_VIRTUAL              0x00010000  *)

   faDEVICE = $40;
   faNORMAL = $80;
   faTEMPORARY = $100;
   faSPARSE_FILE = $200;
   faREPARSE_POINT = $400;
   faCOMPRESSED = $800;
   faOFFLINE = $1000;
   faNOT_CONTENT_INDEXED = $2000;
   faENCRYPTED = $4000;
   faVIRTUAL = $10000;

var
  CF_PREFERREDDROPEFFECT,
  CF_HTML: cardinal;

  ModeDebug: boolean = false; //activ  l'initialisation de l'unit, si le dpr est dans le rpertoire de l'exe


function egal(var V1,V2;taille:longint):boolean;
//function  Sign(i:longint):longint; 21/11/06 voir unit math
function  RSign(S,V:double):double;
{
remplac par Min et Max de l'unit MATH
function  Min(i1,i2:longint):longint;
function  Max(i1,i2:longint):longint;
function  LMin(i1,i2:longint):longint;
function  LMax(i1,i2:longint):longint;
function  RMin(R1,R2:double):double;
function  RMax(R1,R2:double):double;
}
procedure Swap(var A,B:smallint); overload;
procedure Swap(var A,B:integer); overload;
procedure Swap(var A,B:int64); overload;
procedure Swap(var A,B:single); overload;
procedure Swap(var A,B:double); overload;
procedure Swap(var A,B:extended); overload;
procedure Swap(var A,B:pointer); overload;
procedure Swap(var A,B; siz:integer); overload;

procedure SwapI(var i,j:longint);
procedure SwapLI(var i,j:longint);
procedure SwapW(var i,j:longint);
procedure SwapB(var i,j:byte);
procedure XCHG(var V1,V2;n:integer);
//function GenStr(n:longint;C:char):string; VOIR STRINGOFCHAR
function PosLast(Substr,S:string):integer;
procedure lire(var S,Sres:string; CarAdmis:string);
function lire_entier(var S:string;var li:longint):boolean;
function lire_longint(var S:string;var li:longint):boolean;
function lire_reel(var S:string;var r:double):boolean;
function lire_double(var S:string;var r:double):boolean;
function lireBY(var S:string;var by:byte):boolean;
function bit(b,pos:byte):boolean;
procedure SetBit(var b:byte;pos:byte;actif:boolean);
function Contient(elt,elts:integer):boolean;
function StrToFloatVP(S:string):extended;//accepte , ou .
function FloatToStrP(nd:integer;E:extended):string;//formate avec un .
procedure AfficheErreurES(msg:string;code:longint);
procedure ViderListe(L:TStrings);overload;
procedure ViderListe(L:TList);overload;
function CheckFileName(N:string;jok:boolean):boolean;//version noms longs
function TestFileName(N:string;jok:boolean):boolean;
function UNClong(PF:string):string;
procedure TextOutA(c: TCanvas; x,y: longint; a:double; s: string);
function StrDateToDays(D:string):string;
function BoolToStr(b:boolean):string;//renvoie T ou F
function StrToBool(S:string):boolean;//prend le 1er car non blanc ; false si erreur
function FormatIng(D:double;Ncar,Ndec:integer;fixmin:boolean=false):string; //passe en format E+03(6,9..) si ABS(D)>=10000 ou <1 ; si <1, reste fixe si fixmin
function FormatDate(D:string):string; overload;//met en forme sous jj/mm/aa ; renvoie '' si erreur
function FormatDate(DT:TDateTime):string; overload;
procedure DT2ASJ(DT: TDateTime; var A,S,JS:integer);
function ASJ2DT(A,S,Js:integer):TDateTime;  //Js=1 > lundi
function AASSJ(DT: TDateTime):string;
function DateOK(date:string):boolean;
function DateInt(DT: TDateTime): int64; //renvoie un DateTime au format entier
function UserName:string;
function ComputerName:string;
function FichierSelectionner(Titre,DirInitial,Filtre,ExtDefaut:string;multi:boolean):string;
function CopierFichier(S,D:string;ecraser:boolean):integer;overload;//copie aussi la date
function CopierFichier(S,D:string):integer;overload;//copie aussi la date, indice si besoin (2)...
procedure DaterFichier(PF:string;date:TDateTime);//si date=0, utilise Now
function CopierDir(S,D:string;ecraser:boolean=true):integer;//copie aussi la date des fichiers
function CheckPathLength(S:string;max:integer):string;//renvoie le path en erreur sinon ''
function PathsEnDefaut(S:string;max:integer):string;//renvoie les paths en erreur sinon ''
procedure EffacerFichiers(PF:string;AgeMiniEnJ:TDateTime=-1);//PF peut contenir des jokers
function EffacerDir(Dir:string;remove:boolean=true):boolean;
function DeplacerDirFic(S,D:string):integer;//dplace dir ou fichier
function FormatSysErrCode(ErrCode:integer):string;
function TxtShellErr(numer:integer):string;
procedure ShellErr(numer:integer);
procedure CheckErr(resfonc:boolean);
function RecToStr(p:pointer;size:integer):string;
function StrToRec(p:pointer;size:integer;S:string):boolean;
function NameExists(PF:string):boolean;//true si nom de rpertoire ou fichier trouv
function FileExistsDirs(SrchDir,NF:string):boolean; // ('...\','nom'), recherche parmi des sous-rpertoires
procedure GetMatchNames(SrchDir,NF:string;var SL: TStringList;adddir:boolean=true);
function FileTimeToInt64(FT:TFileTime):int64;
function Int64ToFileTime(i64:int64):TFileTime;
procedure FindFiles2(PF:string;attr_acceptes,attr_exiges:integer;var SL: TStringList; adddata:boolean=false; inclurepathdansresul:boolean=false);
procedure ClearFiles2(var SL: TStringList);
procedure FindFiles(PF:string;attr:integer;var SL: TStringList; attronly:boolean=false; inclurepathdansresul:boolean=false);overload;
procedure FindFiles(PF:string;attr:integer;var S:string; attronly:boolean=false; inclurepathdansresul:boolean=false);overload;
procedure FindFilesSub(PF:string;attr:integer;var Sres:string; attronly:boolean=false; inclurepathdansresul:boolean=false);
function FindContenuDir(dir:string;dirsonly,detail:boolean):string;
function DirVide(dir:string):boolean;
function FileIsReadOnly(PF:string):boolean;
//function FormaterNomDeVerrouillage(nom_brut: string):string;//cre un nom de verrouillage
function VerrouillerAccesAuFichier(nom_brut: string;mode:integer):boolean; //mode=k_verrNomPC, k_verrNomUtil
function FichierVerrouillePar(nom_brut: string):string;//renvoie '' si erreur ou pas de verrouillage
procedure DeverrouillerAccesAuFichier(nom_brut: string);

function DlgEditerLigne(Caption,Prompt:string;var Ligne:string; Aide:string):boolean;
function GetPathElt(path:string;elt:integer):string; //elt: 0:drive 1:dir 2:nom 3:ext
function MettreAJourFichier(PF:string;fncMAJ:TfncMAJ;data:pointer;redater:boolean):boolean;
function MettreAJourFichier2(PF:string;fncMAJ:TfncMAJtxt;data:pointer;redater:boolean):boolean;
procedure NormalizeTopJP;
procedure RestoreTopJP;
procedure ControlAtMouse(Ct:TControl); //place  l'endroit de la souris et recale dans l'cran si dpasse  droite ou en bas
procedure ShowMsg(S:string);//devant les TopMost
procedure ShowMessageMs(S:string);
function MessageDlgMs(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons): Integer;
function InputQueryTop(caption,prompt:string;var S:string):boolean;
function MessageDlgConf(msg:string):boolean;
procedure CheckNextCtrl(HF:HWND;var key:char);
function ClipboardFormats:string;
function ClipboardAsString(frmt:integer):string;
procedure StringToClipboard(frmt:integer;S:string);
procedure HTMLtoClipboard(S:string;deb:string='<HTML><BODY>';fin:string='</BODY></HTML>');
function ClipboardAsFilesNames:string; //renvoie une liste de chemins spars par des CRLF
function ClipboardDropEffect:cardinal;//renvoie DROPEFFECT_MOVE ou DROPEFFECT_COPY
function ListeCRLF_to_Liste00(listeCRLF:string):string;//transforme une liste de noms de fichier sp CRLF par la mme, sp #0, fin #0#0
procedure FilesNamesToClipboard(S:string;DropEffect : Cardinal);  //   DropEffect = DROPEFFECT_MOVE ou DROPEFFECT_COPY
function DateTimeToFileTime(DT:TDateTime):TFileTime;
function FileTimeToDateTime(FT:TFileTime):TDateTime;
function GetFileAttr(PF:string):integer;
procedure SetFileAttr(PF:string;attr:integer);
function GetFileTimes(PF:string; var creation,acces,ecriture:TFileTime):boolean;
function SetFileTimes(PF:string; creation,acces,ecriture:TFileTime):boolean;
function GetDirTimes(PD:string; var creation,acces,ecriture:TDateTime):boolean;
function SetDirTimes(PD:string; creation,acces,ecriture:TDateTime):boolean; // 0=inchang
function FileInfo(PF:string; var SR:TSearchRec):boolean; overload;
function FileInfo(PF:string):TSearchRec; overload;//renvoie Name='' si erreur
function FileSize(PF:string):int64;
function AryI2Str(ary:array of integer;nelts:integer):string;
procedure Str2AryI(var ary:array of integer;nelts:integer;S:string);
procedure OuvrirDoc(HW:HWND; dir,fic:string;OI:integer);
//function FindExec(ext:string):string;
function ModuleFileName(H:HWND):string;
function DirWin:string;
function DirWinSys:string;
function DirWinTemp:string;
function DirAppli:string;
function DirAppliExp:string;
function GetDirectoryHandle(PathDir:string):cardinal;
function GetDirPartage:string;
function PathTemp(ext:string):string; //ext doit contenir le point
procedure DeleteTempFiles(ext:string;AgeMiniEnJ:TDateTime=0);
procedure PushAffiCurs(curs:integer);
procedure PopCursor;
procedure CursorWait;
procedure CursorArrow;
procedure CursorPop;
procedure CursorPushAffi(curs:integer);
function ShFileOp(HW:HWND;s,d:string;op:UINT;flg:FILEOP_FLAGS):integer;
function ShRename(s,d:string):integer;
procedure LogInit(PF:string);
procedure LogAdd(S:string;save:boolean=false);
procedure LogDTAdd(S:string;save:boolean=false);
procedure LogSave;
function LogGet:string;
function GetCID:string;
procedure ShowMessageDbg(msg:string);
procedure SetEnvironmentVariable(const Name,Value: string);
function GetNextTabControl(F:TForm;CurControl:TWinControl):TWinControl;//28/4/7 : retrouve le contrle  focaliser, piqu sur twincontrol.findnextcontrol
function GetParentForm(C:TControl):TCustomForm;
function GetOwnerForm(C:TComponent):TCustomForm;
procedure EnableDisablePanel(Pn:TPanel;enable:boolean);
procedure FreeAndNil2(var Obj);
function SameValuePourCent(Vref,V2,pourcent:extended):boolean;
function GetShiftState:TShiftState;
function ToucheShift:boolean;
procedure GetMouseState(var dwFlags, dx, dy, dwData, dwExtraInfo: DWORD);
function GetMouseFlags:DWORD;
procedure Set_PageControl_TabControl_Index(PCTC:TCustomTabControl;ixpg:integer);

function ExisteFichiersAColler:boolean;
function FichiersAColler:string;

function PropidesLireProprietes(PF:string):string;
function PropidesLirePropriete(PF,Nom:string):string;
procedure PropidesDefinirPropriete(PF,Nom,Valeur:string);

function HostName:string;
function GetIPFromHost:string;
procedure NormaliserIP4(var ip:string);

function CalPtr(p:pointer;addsub:integer):pointer; //renvoie un pointeur dcal de addsub
function IntToInt64(L,H:integer):int64;
function W32(L,H:word):TW32;
function I64(L,H:cardinal):TI64;

procedure ColorToBW(var Cl:TColor);
procedure CreerSousMenu(MIp:TMenuItem; evClic:TNotifyEvent; Captions:string);
procedure CkLBx_checkuncheckall(CB:TCheckListBox; chk:boolean);

function Modulo(valeur,diviseur:double):double;

IMPLEMENTATION

USES DlphUtil, StrUtils, ShlObj, ClipBrd, StringUtils, Math, CFileHeader, Registry, WinSock;

var
  Slog, PFlog,
  PileCurs: string;


function RSign(S,V:double):double;
begin
  if S<0 then RSign:=-V else RSign:=V;
end;                            { de RSign }
{
-------------------------------------------------------------------------------

function Sign(i:longint):longint;
begin
  if i<0 then Sign:=-1 else Sign:=1;
end;
{
-------------------------------------------------------------------------------
}
procedure Swap(var A,B:smallint);
var C: integer;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B:integer);
var C: integer;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B:int64);
var C: int64;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B:single);
var C: single;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B:double);
var C: double;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B:extended);
var C: extended;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B:pointer);
var C: pointer;
begin
  C:=A; A:=B; B:=C;
end;                            { de Swap }
procedure Swap(var A,B; siz:integer);
var
C: byte;
i: integer;
begin
  for i:=0 to siz-1 do begin
    C:=TByteArray(A)[i];
    TByteArray(A)[i]:=TByteArray(B)[i];
    TByteArray(B)[i]:=C;
  end;
end;                            { de Swap }
{
-------------------------------------------------------------------------------
}
procedure SwapI(var i,j:longint);
var  k                  :longint;
begin
  k:=i;  i:=j;  j:=k;
end;                            { de SwapI }
{
-------------------------------------------------------------------------------
}
procedure SwapLI(var i,j:longint);
var  k                  :longint;
begin
  k:=i;   i:=j;  j:=k;
end;                            { de SwapLI }
{
-------------------------------------------------------------------------------
}
procedure SwapW(var i,j:longint);
var  k                  :longint;
begin
  k:=i;  i:=j;  j:=k;
end;                            { de SwapW }
{
-------------------------------------------------------------------------------
}
procedure SwapB(var i,j:byte);
var  k                  :byte;
begin
  k:=i;  i:=j;  j:=k;
end;                            { de SwapB }
{
-------------------------------------------------------------------------------
}
procedure XCHG(var V1,V2;n:integer);
var
  V: array of byte;
begin
  SetLength(V,n);
  move(V1,V[0],n);
  move(V2,V1,n);
  move(V[0],V2,n);
  V:=nil;
end;                            { de XCHG }
{
-------------------------------------------------------------------------------
}
{
-------------------------------------------------------------------------------
}
function egal(var V1,V2;taille:longint):boolean;
var
  i: longint;
begin
  Result:=false;
  for i:=0 to taille-1 do
   if TTabByte(V1)[i]<>TTabByte(V2)[i] then exit;
  Result:=true;
end;
{
-------------------------------------------------------------------------------
}
procedure lire(var S,Sres:string; CarAdmis:string);
var
  i: longint;
begin
  i:=1;
  repeat
    if (i>length(S)) or (Pos(S[i],CarAdmis)=0) then begin
      Sres:=Copy(S,1,i-1);
      delete(S,1,i-1);
      exit;
    end;
    inc(i);
  until false;
end;
{
-------------------------------------------------------------------------------
}
function lire_entier(var S:string;var li:longint):boolean;
var
  er                 :longint;
  S1                 :string;
begin
  lire_entier:=true;
  TrimLeft(S);//cadrer(S,gdG);
  S1:=S;
  val(S1,li,er);
  if er>0 then begin
    SetLength(S1,er-1);
    delete(S,1,er-1);
    if length(S1)>0 then val(S1,li,er) else begin
      li:=0;
      lire_entier:=false;
    end;
  end else S:='';
end;                            { de lire_entier }
{
-------------------------------------------------------------------------------
}
function lire_longint(var S:string;var li:longint):boolean;
var
  er                 :longint;
  S1                 :string;
begin
  lire_longint:=true;
  TrimLeft(S);
  S1:=S;
  val(S1,li,er);
  if er>0 then begin
    SetLength(S1,er-1);
    delete(S,1,er-1);
    if length(S1)>0 then val(S1,li,er) else begin
      li:=0;
      lire_longint:=false;
    end;
  end else S:='';
end;                            { de lire_longint }
{
-------------------------------------------------------------------------------
}
function lire_reel(var S:string;var r:double):boolean;
var
  er                 :longint;
  S1                 :string;
begin
  lire_reel:=true;
  TrimLeft(S);//cadrer(S,gdG);
  er:=Pos(',',S);
  if er>0 then S[er]:='.'; {accepte . et , indiffremment}
  S1:=S;
  val(S1,r,er);
  if er>0 then begin
    SetLength(S1,er-1);
    delete(S,1,er-1);
    if length(S1)>0 then val(S1,r,er) else begin
      r:=0;
      lire_reel:=false;
    end;
  end else S:='';
end;                            { de lire_reel }
{
-------------------------------------------------------------------------------
}
function lire_double(var S:string;var r:double):boolean;
var
  er                 :longint;
  S1                 :string;
begin
  lire_double:=true;
  TrimLeft(S);//cadrer(S,gdG);
  er:=Pos(',',S);
  if er>0 then S[er]:='.'; {accepte . et , indiffremment}
  S1:=S;
  val(S1,r,er);
  if er>0 then begin
    SetLength(S1,er-1);
    delete(S,1,er-1);
    if length(S1)>0 then val(S1,r,er) else begin
      r:=0;
      lire_double:=false;
    end;
  end else S:='';
end;                            { de lire_double }
{
-------------------------------------------------------------------------------
}
function lireBY(var S:string;var by:byte):boolean;
var
  li                 :longint;
begin
  lireBY:=false;
  if not lire_entier(S,li) then exit;
  if (li<0) or (li>255) then exit;
  by:=li;
  lireBY:=true;
end;                            { de lireBY }
{
-------------------------------------------------------------------------------
}
function StrToFloatVP(S:string):extended;
var
  FS: TFormatSettings;
begin
  FS.DecimalSeparator:='.';
  FS.ThousandSeparator:=' ';
  S:=Trim(AnsiReplaceStr(S,',','.'));
  if S='' then result:=0 else result:=StrToFloat( S,FS );
end;
{
-------------------------------------------------------------------------------
}
function FloatToStrP(nd:integer;E:extended):string;//formate avec un .
var
  FS: TFormatSettings;
begin
  FS.DecimalSeparator:='.';
  FS.ThousandSeparator:=' ';
  result:=Format('%.*f',[nd,E],FS);
end;
{
-------------------------------------------------------------------------------
}
function bit(b,pos:byte):boolean;
begin
  bit:= ( b and (1 shl pos) )<>0;
end;                            { de bit }
{
-------------------------------------------------------------------------------
}
procedure SetBit(var b:byte;pos:byte;actif:boolean);
var
  i: byte;
begin
  i:= 1 shl pos;
  if actif
  then b:=b or i
  else b:=b and not i;
end;                            { de bit }
{
-------------------------------------------------------------------------------
}
function Contient(elt,elts:integer):boolean;
begin
  result:=(elt and elts)<>0;
end;
{
-------------------------------------------------------------------------------
}
procedure AfficheErreurES(msg:string;code:longint);
var
  S: string;
begin
  case code of
    2:S:='fichier introuvable';
    3:S:='chemin introuvable';
    4:S:='trop de fichiers ouverts';
    5:S:='accs au fichier refus';
    6:S:='identificateur de fichier incorrect';
    12:S:='mode d''accs fichier incorrect';
    15:S:='unit de disque incorrecte';
    16:S:='le rpertoire ne peut tre supprim';
    17:S:='ne peut renommer de disque  disque';

    100:S:='erreur lecture disque';
    101:S:='erreur criture disque';
    102:S:='variable non fichier';
    103:S:='fichier ferm';
    104:S:='fichier non ouvert en lecture';
    105:S:='fichier non ouvert en criture';
    106:S:='format numrique incorrect';

    else S:='code inconnu:'+IntToStr(code)
  end;
  MessageDlg(msg+':'#13#10+S,mtError,[mbOK],0);
end;
{
-------------------------------------------------------------------------------
}
procedure ViderListe(L:TStrings);
var
  i: longint;
begin
  L.BeginUpdate;
  for i:=1 to L.Count do L.Objects[i-1].Free;
  L.Clear;
  L.EndUpdate;
{  while L.Count>0 do begin
    i:=L.Count-1;
    L.Objects[i].Free;
    L.Delete(i);
  end;  }
end;

procedure ViderListe(L:TList);
var
  i: longint;
begin
  for i:=1 to L.Count do TObject(L[i-1]).Free;
  L.Clear;
end;
{
-------------------------------------------------------------------------------
}
function CheckFileName(N:string;jok:boolean):boolean;//version noms longs
var
  i: integer;
  inter:string;

  function CarOK(C:char):boolean;
  begin
    result:=Pos(C,inter)=0;
  end;
begin
  result:=false;
  if (Trim(N)<>N) or (N='') or (N='.') or (N='..') then exit;
  inter:='\/:"<>|';
  if not jok then inter:=inter+'*?';
  for i:=1 to length(N) do if not CarOK(N[i]) then exit;
  result:=true;
end;

function TestFileName(N:string;jok:boolean):boolean;
  function TestNX(S:string):boolean;
  var
    i: longint;
  begin
    Result:=false;
    i:=pos('*',S);
    if i>0 then begin
      if (not jok) or (i<length(S)) then exit;{* doit tre en dernier}
    end;
    if (pos('?',S)>0) and (not jok) then exit;
    for i:=1 to length(S) do begin
      if not (Upcase(S[i]) in ['A'..'Z','0'..'9','$','&','#','~','%',
                     '''','(',')','-','_','@','^','{','}','!','*','?'  ])
      then exit;
    end;
    Result:=true;
  end;

var
  i: longint;
  X: string;
begin
  Result:=false;
{ N.X : spare N et X}
  i:=pos('.',N);
  if i>0 then begin
    X:=copy(N,i+1,255);
    if length(X)>3 then exit;
    if i=1 then exit;{rien dans N}
    SetLength(N,i-1);
  end else X:='';
  if length(N)>8 then exit;
  if not TestNX(N) then exit;
  if length(X)>0 then if not TestNX(X) then exit;
  Result:=true;
end;

function UNClong(PF:string):string;
const k_ul = '\\?\';
begin
  if Pos(k_ul,PF)<>1 then begin
    PF:=ExpandUNCFileName(PF);
    if PF[2]<>':' then begin
      delete(PF,1,2); //ote le "\\" de "\\pc334\.... pour renvoyer \\?\UNC\pc334\.... , sinon renvoie \\?\UNC\c:\..
      PF:='UNC\'+PF;
    end;
    PF:=k_ul+PF;
  end;
  result:=PF;
end;

{
-------------------------------------------------------------------------------
}
procedure TextOutA(c: TCanvas; x,y: longint; a:double; s: string);
{-----------------------------------------------------------
  PURPOSE
    To output rotated text in the same font as the font on
    the supplied canvas. The font must also be a scaleable
    font.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.
    x,y - The x,y screen coordinates you would normally
      supply the TextOut procedure.
    a - en radians
    s - The text to be output to the canvas.
  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}
var
  LogRec: TLOGFONT;     {* Storage area for font information *}
  OldFontHandle,        {* The old font handle *}
  NewFontHandle: HFONT; {* Temporary font handle *}

begin
  {* Get the current font information. We only want to modify the angle *}
  GetObject(c.Font.Handle, SizeOf(LogRec), Addr(LogRec));

  {* Modify the angle. "The angle, in tenths of a degrees, between the base
     line of a character and the x-axis." (Windows API Help file.)*}
  LogRec.lfEscapement := Round(a*1800/3.1416);

  {* Create a new font handle using the modified old font handle *}
  NewFontHandle := CreateFontIndirect(LogRec);

  {* Save the old font handle! We have to put it back when we are done! *}
  OldFontHandle := SelectObject(c.Handle,NewFontHandle);

  {* Finally. Output the text! *}
  c.TextOut(x,y,s);

  {* Put the font back the way we found it! *}
  NewFontHandle := SelectObject(c.Handle,OldFontHandle);

  {* Delete the temporary (NewFontHandle) that we created *}
  DeleteObject(NewFontHandle);

end; {* TextOutA *}
{
-------------------------------------------------------------------------------
}
function StrDateToDays(D:string):string;
begin
  Result:=IntToStr(Round(Double(StrToDate(D))));
end;
{
-------------------------------------------------------------------------------
}
function BoolToStr(b:boolean):string;//renvoie T ou F
begin
  if b then Result:='T' else Result:='F';
end;
{
-------------------------------------------------------------------------------
}
function StrToBool(S:string):boolean;//prend le 1er car non blanc ; false si erreur
begin
  S:=Copy(TrimLeft(S),1,1);
  Result:=UpperCase(S)='T';
end;
{
-------------------------------------------------------------------------------
}
function FormatIng(D:double;Ncar,Ndec:integer;fixmin:boolean=false):string;
//passe en format E+03(6,9..) si ABS(D)>=10000 ou <1 ; si fixmin, les valeurs<1 restent fixes
var
i,j: integer;
C: char;
dd: double;
begin
  dd:=ABS(D);
  if (dd=0) or ( (dd>=1) and (dd<10000) ) or ((dd<1) and fixmin) then result:=Format('%*.*f',[Ncar,Ndec,D])
  else begin //format sci
    dd:=Log10(dd);
    i:= Round( dd );
    if dd<0 then dec(i,2);
    j:= i div 3 ; //le nb de milliers
    j:=j*3;
    D:=D/Power(10,j);
    if j<0 then C:='-' else C:='+';
    result:=Format('%*.*f',[Max(0,Ncar-4),Ndec,D])+'E'+C+Format('%2.2d',[ABS(j)]);
  end;
end;
{
-------------------------------------------------------------------------------
}
function FormatDate(D:string):string;
var
  DT: TDateTime;
begin
  D:=compacter(D);
  if D='' then exit;
  try
    DT:=StrToDate(D);
  except
    on EConvertError do begin
      Result:='';
      exit;
    end;
  end;
//  D:=FormatDateTime('dd/mm/yy',DT);
  Result:=FormatDate(DT);
end;
{
-------------------------------------------------------------------------------
}
function FormatDate(DT:TDateTime):string;
begin
  Result:=FormatDateTime('dd/mm/yy',DT);
end;
{
-------------------------------------------------------------------------------
}
procedure DT2ASJ(DT: TDateTime; var A,S,JS:integer);
{  ISO 8601 : 1988 (E) paragraph 3.17:
  "week, calendar: A seven day period within a calendar year, starting
  on a Monday and identified by its ordinal number within the year;
  the first calendar week of the year is the one that includes the
  first Thursday of that year. In the Gregorian calendar, this is
  equivalent to the week which includes 4 January."
Function WeekNumber(InDate As Date) As Integer
  Dim DayNo As Integer
  Dim StartDays As Integer
  Dim StopDays As Integer
  Dim StartDay As Integer
  Dim StopDay As Integer
  Dim VNumber As Integer
  Dim ThurFlag As Boolean

  DayNo = Days(InDate)
  StartDay = Weekday(DateSerial(Year(InDate), 1, 1)) - 1
  StopDay = Weekday(DateSerial(Year(InDate), 12, 31)) - 1
  ' Number of days belonging to first calendar week
  StartDays = 7 - (StartDay - 1)
  ' Number of days belonging to last calendar week
  StopDays = 7 - (StopDay - 1)
  ' Test to see if the year will have 53 weeks or not
  If StartDay = 4 Or StopDay = 4 Then ThurFlag = True Else ThurFlag = False
  VNumber = (DayNo - StartDays - 4) / 7
  ' If first week has 4 or more days, it will be calendar week 1
  ' If first week has less than 4 days, it will belong to last year's
  ' last calendar week
  If StartDays >= 4 Then 
     WeekNumber = Fix(VNumber) + 2 
  Else 
     WeekNumber = Fix(VNumber) + 1
  End If
  ' Handle years whose last days will belong to coming year's first
  ' calendar week
  If WeekNumber > 52 And ThurFlag = False Then WeekNumber = 1
  ' Handle years whose first days will belong to the last year's 
  ' last calendar week
  If WeekNumber = 0 Then
     WeekNumber = WeekNumber(DateSerial(Year(InDate) - 1, 12, 31))
  End If
End Function

}

var
  DT0101,DT3112: TDateTime;
  y,m,d: word;
  nj,i,StartDays,StopDays,StartDay,StopDay,DayNo,VNumber: integer;
  ThurFlag: boolean;
  r: double;
begin
  DecodeDate(DT,y,m,d);
  A:=y;
  DT0101:=EncodeDate(A,1,1);
  DT3112:=EncodeDate(A,12,31);
  DayNo:=Round(DT)-Round(DT0101)+1;//depuis le 1/1
  StartDay:= DayOfWeek(DT0101)-1;//lundi=1
  StopDay:= DayOfWeek(DT3112)-1;
  JS:=(DayOfWeek(DT)+5) mod 7 + 1;
// Number of days belonging to first calendar week
  StartDays:=7-(StartDay-1);
// Number of days belonging to last calendar week
  StopDays:=7-(StopDay-1);
// Test to see if the year will have 53 weeks or not
  If (StartDay=4) Or (StopDay=4) Then ThurFlag:=True Else ThurFlag:=False;
  r:=(DayNo-StartDays-4)/7;
// If first week has 4 or more days, it will be calendar week 1
// If first week has less than 4 days, it will belong to last year's last calendar week
  S:=Round(r)+1;//+1;
  If StartDays>=4 Then inc(S);
// Handle years whose last days will belong to coming year's first calendar week
  If (S>52) And (ThurFlag=False) Then begin
    inc(A);
    S:=1;
  end;
// Handle years whose first days will belong to the last year's last calendar week
  If S=0 Then begin
    dec(A);
    DT:=EncodeDate(A,12,31);
    DT2ASJ(DT,A,S,i);
  End;
end;
{
-------------------------------------------------------------------------------
}
function ASJ2DT(A,S,Js:integer):TDateTime;  //Js=1 > lundi
var
  DT: TDateTime;
  i,nbj: integer;
begin
  nbj:=(S-1)*7+Js;
// ajouter ou soustraire nb jours de la 1ere semaine
  DT:=EncodeDate(A,1,1);
  i:=DayOfWeek(DT)-1; //i=1 le lundi
  if i>4 then nbj:=nbj+(i-4) //ces jours font partie d'une semaine de l'an pass
    else nbj:=nbj-(i-1); // ote les jours de l'an pass compts dans la semaine
  result:=DT+nbj-1;
end;
{
-------------------------------------------------------------------------------
}
function AASSJ(DT: TDateTime):string;
var
  a,j,s: integer;
begin
  DT2ASJ(DT,a,s,j);
  a:=a mod 100;
  result:=Format('%2.2d%2.2d%1.1d',[a,s,j]);
end;
{
-------------------------------------------------------------------------------
}
function DateOK(date:string):boolean;
begin
  result:=false;
  try
    StrToDate(date);
    result:=true;
  except
    on EConvertError do;
  end;
end;
{
-------------------------------------------------------------------------------
}
function DateInt(DT: TDateTime): int64; //renvoie un DateTime au format entier
var
  d: double;
  i: int64 absolute d;
begin
  d:=DT;
  result:=i;
end;
{
-------------------------------------------------------------------------------
}
function UserName:string;
var          
  Size: DWORD;
  UN: array [0..255] of char;
  i: integer;
begin
  result:='';
  Size := Sizeof(UN);  // Win95 is hypersensitive to size
  if not GetUserName(UN, Size) then begin
    i:=GetLastError;
    ShowMessage(SysErrorMessage(i));
    exit;
  end;
  result:=UpperCase(UN);
end;
{
-------------------------------------------------------------------------------
}
function ComputerName:string;
var
  Size: DWORD;
  UN: array [0..255] of char;
  i: integer;
begin
  result:='';
  Size := Sizeof(UN);  // Win95 is hypersensitive to size
  if not GetComputerName(
    UN,	// address of name buffer
    Size 	// address of size of name buffer
   ) then begin
    i:=GetLastError;
    ShowMessage(SysErrorMessage(i));
    exit;
  end;
  result:=UpperCase(UN);
end;
{
-------------------------------------------------------------------------------
}
function GetFileAttr(PF:string):integer;
begin
  PF:=PF+#0;
  result:=Windows.GetFileAttributes(@PF[1]);
end;
procedure SetFileAttr(PF:string;attr:integer);
begin
  PF:=PF+#0;
  Windows.SetFileAttributes(@PF[1],attr);
end;

function GetFileTimes(PF:string; var creation,acces,ecriture:TFileTime):boolean;
//9/4/2008 : 10 essais avant d'abandonner
var
  H,i: integer;
begin
  result:=false;
  for i:=1 to 10 do begin
    H:=FileOpen(PF,fmOpenRead);
    if H=-1 then begin wait(100); continue; end;
    GetFileTime(H,@creation,@acces,@ecriture);
    FileClose(H);
    result:=true;
    exit;
  end;
end;
function SetFileTimes(PF:string; creation,acces,ecriture:TFileTime):boolean;
//9/4/2008 : 10 essais avant d'abandonner
var
  H,i: integer;
begin
  result:=false;
  for i:=1 to 10 do begin
    H:=FileOpen(PF,fmOpenReadWrite);
    if H=-1 then begin wait(100); continue; end;
    SetFileTime(H,@creation,@acces,@ecriture);
    FileClose(H);
    result:=true;
    exit;
  end;
end;

function GetDirTimes(PD:string; var creation,acces,ecriture:TDateTime):boolean; //int64 vaut pour TFileTime
var
H: integer;
creation_,acces_,ecriture_: TFileTime;
begin
  result:=false;
  creation:=0; acces:=0; ecriture:=0;
  H:=GetDirectoryHandle(PD);
  if H=-1 then exit;
  result:=GetFileTime(H,@creation_,@acces_,@ecriture_);
  if result then begin
    creation:=FileTimeToDateTime(creation_);
    acces:=FileTimeToDateTime(acces_);
    ecriture:=FileTimeToDateTime(ecriture_);
  end;
  CloseHandle(H);
end;

function SetDirTimes(PD:string; creation,acces,ecriture:TDateTime):boolean;
var
H: integer;
creation_,acces_,ecriture_: TFileTime;
begin
  result:=false;
  H:=GetDirectoryHandle(PD);
  if H=-1 then exit;
  creation_:=DateTimeToFileTime(creation);
  acces_:=DateTimeToFileTime(acces);
  ecriture_:=DateTimeToFileTime(ecriture);
  result:=SetFileTime(H,@creation_,@acces_,@ecriture_);
//tests  CheckErr( result );
  CloseHandle(H);
end;

function FileTimeToInt64(FT:TFileTime):int64;
(*type
  Ti64DW = record
   L,H:DWORD;
  end;
var
  i64: Ti64DW; *)
begin
  Move(FT,result,sizeof(result));
(*  i64.L:=FT.dwLowDateTime;
  i64.H:=FT.dwHighDateTime;
  result:=int64(i64);*)
//  result:=FT.dwHighDateTime*MAXDWORD+FT.dwLowDateTime;
end;
function Int64ToFileTime(i64:int64):TFileTime;
(*type
  Ti64DW = record
   L,H:DWORD;
  end;     *)
begin
  Move(i64,result,sizeof(result));
(*  result.dwLowDateTime:=Ti64DW(i).L;
  result.dwHighDateTime:=Ti64DW(i).H;*)
end;

function FileTimeToDateTime(FT:TFileTime):TDateTime;
var
ST:TSystemTime;
begin
  FileTimeToSystemTime(FT,ST);
  result:=SystemTimeToDateTime(ST);
end;

function DateTimeToFileTime(DT:TDateTime):TFileTime;
var
ST:TSystemTime;
begin
  DateTimeToSystemTime(DT,ST);
  SystemTimeToFileTime(ST,result);
end;
{
-------------------------------------------------------------------------------
}
function CopierFichier(S,D:string;ecraser:boolean):integer;//copie aussi la date
var
  H,flags: integer;
  C,A,W: TFileTime;
  Sp,Dp: PAnsiChar;
begin
{  flags:=FOF_NOCONFIRMATION+FOF_NOCONFIRMMKDIR+FOF_SILENT;
  if not ecraser then inc(flags,FOF_RENAMEONCOLLISION);
  result:=ShFileOp(0,S,D,FO_COPY,flags); }
  Sp:=PChar(S);
  Dp:=PChar(D);
  if not CopyFile(Sp,Dp,not ecraser) then begin//modifi le 5/7/10 cause erreur de cast ; pourtant avant a marchait!!
//  if not CopyFile(PChar(S),PChar(D),not ecraser) then begin
    result:=GetLastError;
  end else begin
    result:=0;
// le 22/6/03 : copie la date
    if not GetFileTimes(S,C,A,W) then exit;
    H:=FileOpen(D,fmOpenReadWrite+fmShareExclusive);
    if H=-1 then exit;
    SetFileTime(H,@C,@A,@W);
    FileClose(H);
  end;
end;
{
-------------------------------------------------------------------------------
}
function CopierFichier(S,D:string):integer;//copie aussi la date
begin
  if FileExists(D) then D:=NomFichierUnique(D,'(','');
  result:=CopierFichier(S,D,false);
end;
{
-------------------------------------------------------------------------------
}
procedure DaterFichier(PF:string;date:TDateTime);//si date=0, utilise Now
var
  i: integer;
begin
  if date=0 then date:=Now;
  try
    i:=FileOpen(PF,fmOpenReadWrite);
    if i>0 then begin
      FileSetDate(i,DateTimeToFileDate(date));
      FileClose(i);
    end;
  except
    on Exception do;
  end;
end;
{
-------------------------------------------------------------------------------
}
function CopierDir(S,D:string;ecraser:boolean=true):integer;//copie aussi la date des fichiers
// S et D sont des chemins complets, se terminant sans \
// 21/9/05 : NON : D ne doit pas exister // si D existe, il est cras
// si D existe, il est complt, les fichiers contenus sont crass selon la valeur de ecraser
var
  i,err: integer;
  S1: string;
  SR: TSearchRec;
begin
  result:=ERROR_CANNOT_MAKE;//The directory or file cannot be created.
  if not DirectoryExists(D) then begin
    if not CreateDir(D) then exit;
  end;
  Application.ProcessMessages;
  err:=0;
  i:=sysutils.FindFirst(S+'\*.*',faAnyFile,SR);
  try
    while i=0 do begin
      S1:=SR.FindData.cFileName; //8/4/03ExtractFileName(SR.Name);
      if ((SR.Attr and faDirectory)<>0) then begin
        if (S1<>'.') and (S1<>'..')
        then err:=CopierDir(S+'\'+S1,D+'\'+S1,ecraser);
      end else err:=CopierFichier(S+'\'+S1,D+'\'+S1,ecraser);
//if err<>0 then showmessage(S+'\'+S1);
      if err<>0 then exit;

      i:=sysutils.FindNext(SR);
    end;
  finally
    sysutils.FindClose(SR);
    result:=err;
  end;
end;
{
-------------------------------------------------------------------------------
}
var pathsdefaut: string;
procedure CheckPaths(S:string;max:integer;arretau1er:boolean);
var
  i: integer;
  S1,S2: string;
  SR: TSearchRec;
begin
  if length(S)>max then begin
    pathsdefaut:=pathsdefaut+S+k_CRLF;
    if arretau1er then exit;
  end;
  i:=sysutils.FindFirst(S+'\*.*',faAnyFile,SR);
  try
    while i=0 do begin
      S1:=SR.FindData.cFileName; //8/4/03ExtractFileName(SR.Name);
      S2:=S+'\'+S1;
      if ((SR.Attr and faDirectory)<>0) then begin
        if (S1<>'.') and (S1<>'..') then begin
          CheckPaths(S2,max,arretau1er);
          if (pathsdefaut<>'') and arretau1er then exit;
        end;
      end else if length(S2)>max then begin
        pathsdefaut:=pathsdefaut+S2+k_CRLF;
        if arretau1er then exit;
      end;
      i:=sysutils.FindNext(SR);
    end;
  finally
    sysutils.FindClose(SR);
  end;
end;
function CheckPathLength(S:string;max:integer):string;//renvoie le path en erreur sinon ''
begin
  pathsdefaut:='';
  checkpaths(S,max,true);
  result:=pathsdefaut;
end;
function PathsEnDefaut(S:string;max:integer):string;//renvoie les paths en erreur sinon ''
begin
  pathsdefaut:='';
  checkpaths(S,max,false);
  result:=pathsdefaut;
end;

{
-------------------------------------------------------------------------------
}
procedure EffacerFichiers(PF:string;AgeMiniEnJ:TDateTime=-1);//PF peut contenir des jokers
//-1 le 16/9/2010 pour tre sur de tout effacer
var
  i,Age: integer;
  S,DF,fics: string;
  SR: TSearchRec;
begin
  Age:=DateTimeToFileDate(Now-AgeMiniEnJ);
  PF:=ExpandUNCFileName(PF);
  DF:=ExtractFileDir(PF); //ote le \ final
  fics:='';
  i:=sysutils.FindFirst(PF,faAnyFile,SR);
  try
    while i=0 do begin
      S:=SR.FindData.cFileName;
      if (S<>'.') and (S<>'..') and ((SR.Attr and faDirectory)=0) and (SR.Time<Age) then fics:=fics+S+k_TAB;//
      i:=sysutils.FindNext(SR);
    end;
  finally
    sysutils.FindClose(SR);
  end;
  repeat
    S:=getS(fics);
    if S='' then break;
    SysUtils.DeleteFile(DF+'\'+S);
  until false;
end;
{
-------------------------------------------------------------------------------
}
function EffacerDir(Dir:string;remove:boolean=true):boolean;
// Dir est un chemin complet, se terminant sans \
// Dir doit exister
var
  i: integer;
  S1: string;
  SR: TSearchRec;
begin
  result:=false;
  i:=sysutils.FindFirst(Dir+'\*.*',faAnyFile,SR);
  try
    while i=0 do begin
      S1:=SR.FindData.cFileName; //8/4/03ExtractFileName(SR.Name);
      if ((SR.Attr and faDirectory)<>0) then begin
        if (S1='.') or (S1='..')
        then result:=true
        else result:=EffacerDir(Dir+'\'+S1);
      end else result:=SysUtils.DeleteFile(Dir+'\'+S1);

      if not result then exit;

      i:=sysutils.FindNext(SR);
    end;
  finally
    sysutils.FindClose(SR);
  end;
  if remove then result:=RemoveDir(Dir) else result:=true;
end;
{
-------------------------------------------------------------------------------
}
function DeplacerDirFic(S,D:string):integer;//dplace dir ou fichier
begin
  if not MoveFile(PChar(S),PChar(D)) then begin
    result:=GetLastError;
  end else result:=0;
end;
{
-------------------------------------------------------------------------------
}
function FormatSysErrCode(ErrCode:integer):string;
var
  msg: array[0..255] of char;
begin
//function FormatMessageW(dwFlags: DWORD; lpSource: Pointer; dwMessageId: DWORD; dwLanguageId: DWORD;
//  lpBuffer: PWideChar; nSize: DWORD; Arguments: Pointer): DWORD; stdcall;
  FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM,
    NIL, ErrCode, 0, PChar(@msg), 255, NIL ); //langid=0 >> langue par dfaut
  result:=Trim(Pchar(@msg[0]))+' ('+IntToStr(ErrCode)+')';
// Free the buffer.
//  LocalFree( P );
end;
{
-------------------------------------------------------------------------------
}
function TxtShellErr(numer:integer):string;
begin
  case numer of
    SE_ERR_ACCESSDENIED:result:='accs refus';//	The operating system denied access to the specified file.
    SE_ERR_ASSOCINCOMPLETE:result:='association incomplte ou invalide';//	The filename association is incomplete or invalid.
    SE_ERR_DDEBUSY:result:='DDE occup';//	The DDE transaction could not be completed because other DDE transactions were being processed.
    SE_ERR_DDEFAIL:result:='erreur DDE';//	The DDE transaction failed.
    SE_ERR_DDETIMEOUT:result:='requte DDE : dlai de rponse dpass';//	The DDE transaction could not be completed because the request timed out.
    SE_ERR_DLLNOTFOUND:result:='une bibliothque ncessaire est introuvable';//	The specified dynamic-link library was not found.
    SE_ERR_FNF:result:='pas trouv le fichier spcifi';//	The specified file was not found.
    SE_ERR_NOASSOC:result:='aucune application associe  cette extension';//	There is no application associated with the given filename extension.
    SE_ERR_OOM:result:='pas assez de mmoire pour effectuer l''opration';//	There was not enough memory to complete the operation.
    SE_ERR_PNF:result:='chemin pas trouv';//	The specified path was not found.
    SE_ERR_SHARE:result:='violation de partage';//	A sharing violation occurred.
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure ShellErr(numer:integer);
begin
  ShowMessage(TxtShellErr(numer));
end;
{
-------------------------------------------------------------------------------
}
function RecToStr(p:pointer;size:integer):string;
//traduit le record en chaine
var
  i: integer;
  b: byte;
begin
  result:='';   // showmessage(inttostr(integer(p))+' '+inttostr(size));
  for i:=1 to size do begin
    b:=TTABBYTE(p^)[i-1];
    result:=result+ chr( ord('a')+(b and $0F) ) + chr( ord('a')+(b shr 4) );
  end;
end;
{
-------------------------------------------------------------------------------
}
function StrToRec(p:pointer;size:integer;S:string):boolean;
//traduit S en record
//rsultat faux si S n'a pas une taille compatible avec p^
var
  i,j: integer;
  C: char;
  b1,b2: byte;
begin
  result:= (length(S)=size*2);
  if not result then exit;
  j:=1;
  for i:=1 to size do begin
    C:=S[j];
    b1:= ord(C)-ord('a');
    C:=S[j+1];
    b2:= ord(C)-ord('a');
    TTABBYTE(p^)[i-1]:=b1 or (b2 shl 4);
    inc(j,2);
  end;
end;
{
-------------------------------------------------------------------------------
}
function NameExists(PF:string):boolean;//true si nom de rpertoire ou fichier trouv
var
  SR: TSearchRec;
  i: integer;
begin
  i:=sysutils.FindFirst(PF,faAnyFile,SR);
  result:= i=0;
  sysutils.FindClose(SR);
end;
{
-------------------------------------------------------------------------------
}
function FileExistsDirs(SrchDir,NF:string):boolean;
var
  SR: TSearchRec;
  i: integer;
  S1: string;
begin
  result:=true;
  if (Pos('?',NF)>0) or (Pos('*',NF)>0) then begin
    i:=sysutils.FindFirst(SrchDir+NF,faArchive,SR);
    try
      if i=0 then exit;
    finally
      sysutils.FindClose(SR);
    end;
  end else if FileExists(SrchDir+NF) then exit;
  i:=sysutils.FindFirst(SrchDir+'*.*',faDirectory,SR);
  try
    while i=0 do begin
      S1:=SR.FindData.cFileName; //8/4/03ExtractFileName(SR.Name);
      if ((SR.Attr and faDirectory)<>0) then begin
        if (S1[1]<>'.') then begin  //sous-rpertoire
          result:=FileExistsDirs(SrchDir+S1+'\',NF);
          if result then exit;//trouv
        end;
      end;
      i:=sysutils.FindNext(SR);
    end;
  finally
    sysutils.FindClose(SR);
  end;
  result:=false;
end;
{
-------------------------------------------------------------------------------
}
procedure GetMatchNames(SrchDir,NF:string;var SL: TStringList;adddir:boolean=true);
//liste tous les fichiers compatibles (path) dans les sous-rp  - cre SL, mais ne supprime pas
//le 20/5/03 : force les majuscules
  procedure AddMatchesInDir(dir: string);
  var
    SR: TSearchRec;
    i: integer;
    S1: string;
  begin
//les fichiers
    i:=sysutils.FindFirst(dir+NF,faReadOnly+faHidden+faArchive,SR);
    try
      while i=0 do begin
        S1:=SR.FindData.cFileName; //8/4/03ExtractFileName(SR.Name);
        if adddir then S1:=dir+S1;
        SL.Add(UpperCase(S1));
        i:=sysutils.FindNext(SR);
      end;
    finally
      sysutils.FindClose(SR);
    end;
//puis les sous-rep
    i:=sysutils.FindFirst(dir+'*.*',faDirectory,SR);
    try
      while i=0 do begin
        S1:=SR.FindData.cFileName; //8/4/03ExtractFileName(SR.Name);
        if ((SR.Attr and faDirectory)<>0) then begin
          if (S1[1]<>'.') then AddMatchesInDir(dir+S1+'\');  //sous-rpertoire
        end;
        i:=sysutils.FindNext(SR);
      end;
    finally
      sysutils.FindClose(SR);
    end;
  end;
begin
  SL:=TStringList.Create;
  AddMatchesInDir(SrchDir);
end;
{
-------------------------------------------------------------------------------
}

constructor TFileData.Create(SR: TSearchRec);
begin
  Time:=SR.Time;
  Size:=SR.Size;
  Attr:=SR.Attr;
  dwFileAttributes:=SR.FindData.dwFileAttributes;
  ftCreationTime:=FileTimeToInt64(SR.FindData.ftCreationTime);
  ftLastAccessTime:=FileTimeToInt64(SR.FindData.ftLastAccessTime);
  ftLastWriteTime:=FileTimeToInt64(SR.FindData.ftLastWriteTime);
  nFileSize:=SR.FindData.nFileSizeHigh * MAXDWORD + SR.FindData.nFileSizeLow;
end;

procedure FindFiles2(PF:string;attr_acceptes,attr_exiges:integer;var SL: TStringList; adddata:boolean=false; inclurepathdansresul:boolean=false);
//liste tous les fichiers/rpertoires compatibles (path) - cre SL, mais ne supprime pas
//le rsultat contient uniquement le nom de l'lment, sans chemin
//4/2/09 : ajout contrle de l'extension, car marche comme si il y avait joker * en bout du nom
var
  SR: TSearchRec;
  i: integer;
  S1,ext,dir: string;
  joker: boolean;
begin
  SL:=TStringList.Create;
  CursorWait;
  ext:=UpperCase(ExtractFileExt(PF));
  dir:=GetPathElt(PF,k_peDrvDir);//ExtractFileDir(PF);
  joker:= (Pos('?',ext)+Pos('*',ext))>0;
  i:=sysutils.FindFirst(PF,attr_acceptes,SR);
  try
    while i=0 do begin
      S1:=SR.FindData.cFileName;
      if (S1<>'.')
       and (S1<>'..')
       and ( joker or (ext=UpperCase(ExtractFileExt(S1))))
       and ( (SR.Attr and attr_exiges)=attr_exiges )
      then begin
        if inclurepathdansresul then S1:=dir+S1;
        if adddata
        then SL.AddObject(S1,TFileData.Create(SR))
        else SL.Add(S1);
      end;
      i:=sysutils.FindNext(SR);
    end;
  finally
    sysutils.FindClose(SR);
    PopCursor;
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure ClearFiles2(var SL: TStringList);
var
  i: integer;
begin
  for i:=1 to SL.Count do if Assigned(SL.Objects[i-1]) then TFileData(SL.Objects[i-1]).Free;
  SL.Free;
  SL:=nil;
end;
{
-------------------------------------------------------------------------------
}
procedure FindFiles(PF:string;attr:integer;var SL: TStringList;
                    attronly:boolean=false; inclurepathdansresul:boolean=false);
//liste tous les fichiers/rpertoires compatibles (path) - cre SL, mais ne supprime pas
//le rsultat contient uniquement le nom de l'lment, sans chemin
//si attronly, ne renvoie que les lments contenant explicitement attr
var
  attr_x: integer;
begin
  if attronly then attr_x:=attr else attr_x:=0;
  FindFiles2(PF,attr,attr_x,SL,attronly,inclurepathdansresul);
end;
{
-------------------------------------------------------------------------------
}
procedure FindFiles(PF:string;attr:integer;var S:string; attronly:boolean=false; inclurepathdansresul:boolean=false);
var
  SL: TStringList;
begin
  FindFiles(PF,attr,SL,attronly,inclurepathdansresul);
  try
    S:=Trim(SL.Text);
  finally
    SL.Free;
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure FindFilesSub(PF:string;attr:integer;var Sres:string; attronly:boolean=false; inclurepathdansresul:boolean=false);
//recherche dans les  sous rpertoires mais ne les liste pas
var
  nf: string;
  attr_acceptes,attr_exiges:integer;

  procedure Find(dir:string); //contient le dernier \
  var
    SR: TSearchRec;
    i: integer;
    S1: string;
  begin
    CursorWait;
    try
      i:=sysutils.FindFirst(dir+nf,attr_acceptes,SR);
      try
        while i=0 do begin
          S1:=SR.FindData.cFileName;
          if (S1<>'.') and (S1<>'..') then begin
            if ( (SR.Attr and attr_exiges)=attr_exiges ) then begin
              if inclurepathdansresul then S1:=dir+S1;
              Sres:=Sres+k_CRLF+S1;
            end;
          end;
          i:=sysutils.FindNext(SR);
        end;
      finally
        sysutils.FindClose(SR);
      end;
      i:=sysutils.FindFirst(dir+'*.*',faDirectory,SR);
      try
        while i=0 do begin
          S1:=SR.FindData.cFileName;
          if (S1<>'.') and (S1<>'..') then begin
            if (SR.Attr and faDirectory)<>0 then Find(dir+S1+'\');  //SS rep
          end;
          i:=sysutils.FindNext(SR);
        end;
      finally
        sysutils.FindClose(SR);
      end;
    finally
      PopCursor;
    end;
  end;
var
  df: string;
begin
  Sres:='';
  df:=ExtractFileDir(PF);
  df:=ExcludeTrailingBackslash(df)+'\';
  nf:=Copy(PF,length(df)+1,maxint);
  attr_acceptes:=attr;
  if attronly then attr_exiges:=attr else attr_exiges:=0;
  Find(df);
  delete(Sres,1,2); //le 1er CRLF
end;
{
-------------------------------------------------------------------------------
}
function FichierSelectionner(Titre,DirInitial,Filtre,ExtDefaut:string;multi:boolean):string;
var
OD: TOpenDialog;
i: integer;
begin
  OD:= TOpenDialog.Create(nil);
  with OD do try
    DefaultExt:=ExtDefaut;
    Filter:=Filtre;
    InitialDir:=DirInitial;
    Options:=[ofHideReadOnly,ofFileMustExist,ofEnableSizing];
    if multi then Options:=Options+[ofAllowMultiSelect];
    Title:=Titre;
    result:='';
    if Execute then for i:=1 to Files.Count do result:=result+Files[i-1]+k_CRLF;
    result:=Trim(result);
  finally
    OD.Free;
  end;
end;
{
-------------------------------------------------------------------------------
}
function FindContenuDir(dir:string;dirsonly,detail:boolean):string;
//renvoie une liste de lignes:
// >dddd : dddd est un rpertoire list  suivre
// < : fin du rpertoire   (<< si non vide de fichiers)
// fff : nom de fichier
  procedure AddNiv(dirparent:string; var vide:boolean);
  var
  S,S1: string;
  SR: TSearchRec;
  ssdir,ok,ssvide,iszip: boolean;
  i: integer;
  begin
    vide:=true;
    i:=sysutils.FindFirst(dirparent+'\*.*',faAnyFile,SR);
    try
      while i=0 do begin
        S:=SR.FindData.cFileName;
        ok:= (S<>'.') and (S<>'..');
        if ok then begin
          ssdir:= (SR.Attr and faDirectory)<>0;
          if not ssdir then vide:=false; //au moins 1 fichier, peut-tre un zip..
          iszip:=((SR.Attr and faCOMPRESSED)<>0) and (lowercase(Copy(S,length(S)-3,4))='.zip');
  ssdir:= ssdir or iszip;
          if dirsonly then begin
            ok:= ssdir or iszip;
          end;
        end;
        if ok then begin
          if ssdir then S1:='>' else S1:='';
          S1:=S1+S;
          if detail then S1:=S1+
                 IntToStr(SR.Time)+k_TAB+IntToStr(SR.Size)+k_TAB+IntToStr(SR.Attr)+k_TAB+IntToStr(SR.FindData.dwFileAttributes)+k_TAB+
                 IntToStr(FileTimeToInt64(SR.FindData.ftCreationTime))+k_TAB+
                 IntToStr(FileTimeToInt64(SR.FindData.ftLastAccessTime))+k_TAB+
                 IntToStr(FileTimeToInt64(SR.FindData.ftLastWriteTime))+k_TAB+
                 IntToStr(SR.FindData.nFileSizeHigh * MAXDWORD + SR.FindData.nFileSizeLow);
          result:=result+S1+k_CRLF;
          if ssdir then begin
            AddNiv(dirparent+'\'+S,ssvide);
            vide:=vide and ssvide;
            result:=result+'<'+k_CRLF;
          end;
        end;
        i:=sysutils.FindNext(SR);
      end;
    finally
      sysutils.FindClose(SR);
      if not vide then result:=result+'<';//marqueur "non vide"
    end;
  end;
var
b: boolean;
begin
  result:='';
  if dir='' then exit;
  AddNiv(dir,b);
end;
{
-------------------------------------------------------------------------------
}
function DirVide(dir:string):boolean;
var
  S: string;
begin
  FindFiles(dir+'\*.*',faAnyFile,S);
  result:= S='';
end;
{
-------------------------------------------------------------------------------
}
function FileIsReadOnly(PF:string):boolean;
begin
  result:= (FileGetAttr(PF) and faReadOnly) <> 0
end;
{
-------------------------------------------------------------------------------
}
var
  SLFichiersVerrouilles: TStringList;
  BufVerr: string[64];

function FormaterNomDeVerrouillage(nom_brut: string):string;//cre un nom de verrouillage
var
  S,nom: string;
begin
  result:='';
  nom:=Trim(nom_brut);
  if nom='' then exit;
  S:=ExtractFileExt(nom);
  SetLength(nom,length(nom)-length(S));
  if S='' then S:='.~' else Insert('~',S,2);
  Result:=LowerCase(ExpandUNCFileName(nom+S));
end;
{
-------------------------------------------------------------------------------
}
function VerrouillerAccesAuFichier(nom_brut: string;mode:integer):boolean; //mode=k_verrNomPC, k_verrNomUtil
var
  H,cpt: integer;
  nom: string;
  svcur: TCursor;
begin
  Result:=false;
  if Trim(nom_brut)='' then exit;
  nom:=FormaterNomDeVerrouillage(nom_brut);
  svcur:=Screen.Cursor;
  Screen.Cursor:=crHourglass;
  try
    try
      for cpt:=1 to 10 do begin
        if FileExists(nom) then SysUtils.DeleteFile(nom); //tente d'effacer
        if not FileExists(nom) then begin
          H:=FileCreate(nom);
          FileClose(H);
          break;
        end;
        if cpt=10 then exit; //erreur, accs impossible
        Wait(250);//modifi le 24/6/10 car dlai trop long *cpt);
      end;
      H:=FileOpen(nom,fmOpenWrite+fmShareDenyWrite);//modif 15/9/02Exclusive);//verrouille
      case mode of
        k_verrNomPC: BufVerr:=ComputerName;
        k_verrNomUtil: BufVerr:=UserName;
        else ShowMessage('err.conception:VerrouillerAccesAuFichier, mode doit tre 1 ou 2');
      end;
      FileWrite(H,BufVerr[0],sizeof(BufVerr));
      SLFichiersVerrouilles.AddObject(nom, pointer(H)); //nom avec ~
      result:=true;
    except
      on EInOutError do;
    end;
  finally
    Screen.Cursor:=svcur;
  end;
end;
{
-------------------------------------------------------------------------------
}
function FichierVerrouillePar(nom_brut: string):string;//renvoie '' si erreur ou pas de verrouillage
var
  H: integer;
  nom: string;
begin
  Result:='';
  if Trim(nom_brut)='' then exit;
  nom:=FormaterNomDeVerrouillage(nom_brut);
  if not FileExists(nom) then exit;
  try
    H:=FileOpen(nom,{fmOpenWrite+}fmOpenRead+fmShareDenyNone);
    FileRead(H,BufVerr[0],sizeof(BufVerr));
    FileClose(H);
    Result:=BufVerr;
  except
    on EInOutError do;
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure DeverrouillerAccesAuFichier_(nom: string;Hfichier:integer);
begin
  try
    FileClose(Hfichier);
    DeleteFile(PChar(nom));
  except
    on Exception do;
  end;
end;
{
-------------------------------------------------------------------------------
}
procedure DeverrouillerAccesAuFichier(nom_brut: string);
var
  i: integer;
  nom: string;
begin
  nom:=FormaterNomDeVerrouillage(nom_brut);
  i:=SLFichiersVerrouilles.IndexOf(nom);
  if i=-1 then exit;
  DeverrouillerAccesAuFichier_(nom,integer(SLFichiersVerrouilles.Objects[i]));
  SLFichiersVerrouilles.Objects[i]:=NIL;
  SLFichiersVerrouilles.Delete(i);
end;
{
-------------------------------------------------------------------------------
}
procedure DeverrouillerFichiersVerrouilles;
var
  i: integer;
begin
  for i:=SLFichiersVerrouilles.Count downto 1 do
    DeverrouillerAccesAuFichier_(SLFichiersVerrouilles[i-1],
                                 integer(SLFichiersVerrouilles.Objects[i-1]));
end;
{
-------------------------------------------------------------------------------
}
function DlgEditerLigne(Caption,Prompt:string;var Ligne:string; Aide:string):boolean;
//dans Prompt, sauts  la ligne par #13#10
begin
  Application.CreateForm(TFEdLigDlg, FEdLigDlg);
  try
    result:=FEdLigDlg.exec(Caption,Prompt,Ligne,Aide);
  finally
    FEdLigDlg.Free;
  end;
end;
{
-------------------------------------------------------------------------------
}
function PosLast(Substr,S:string):integer;
// trouve la derniere occurence - pas optimis
var
  lg: integer;
  P,Pr,Ps: PChar;
begin
  result:=0;
//  Pr:=Nil;
  S:=S+#0;
  lg:=length(Substr);
  Substr:=Substr+#0;
  Pr:=PChar(S);
  Ps:=PChar(Substr);
  repeat
    P:=AnsiStrPos(Pr,Ps);
    if P<>Nil then Pr:=P+lg;
  until P=Nil;
  if Pr=Nil then exit;
  result:=Pr-PChar(S)-lg+1;
end;
{
-------------------------------------------------------------------------------
}
function GetPathElt(path:string;elt:integer):string; //elt: 0:drive 1:dir\ 2:nom 3:.ext 4:nom+ext 5:drive+dir
var
  Sl,Sd,Sn,Se: string;
begin
  path:=ExcludeTrailingBackslash(path);
  Sl:=ExtractFileDrive(path);
  delete(path,1,length(Sl));
  Sn:=ExtractFileName(path);
  Sd:=Copy(path, 1, length(path)-length(Sn) );
  Se:=ExtractFileExt(Sn);
  DecLength(Sn,length(Se));
  case elt of
    k_peDrive :result:=Sl;
    k_peDir   :result:=Sd;
    k_peNom   :result:=Sn;
    k_peExt   :result:=Se;
    k_peNomExt:result:=Sn+Se;
    k_peDrvDir   :result:=Sl+Sd;
  end;
end;
{
-------------------------------------------------------------------------------
}
function MettreAJourFichier(PF:string;fncMAJ:TfncMAJ;data:pointer;redater:boolean):boolean;
//le 3/10/03 : augmente la date DOS d'au moins 2 sec
//le 8/10/03 : ne change pas la date si redater est F, sinon ajoute au moins 2 s  la date
var
  SL: TStringList;
  TF: TextFile;
  essais: integer;
  DTF: TDateTime;
  verrou: string;
begin
  result:=false;
  SL:=TStringList.Create;
  try
    if not FileExists(PF) then SL.SaveToFile(PF); //cre vide
    DTF:=FileDateToDateTime(FileAge(PF));
    for essais:=1 to 3 do begin
      try
        verrou:=FormaterNomDeVerrouillage(PF);
        AssignFile(TF,verrou);    //nom.~ext
        Rewrite(TF);
        try
          SL.LoadFromFile(PF);
          if fncMAJ(SL,data) then begin
            SL.SaveToFile(PF);
            result:=true;
          end;
          if redater and result then begin
            if DTF<Now then DTF:=Now else DTF:=DTF+2/(24*60*60);//ajoute 2 sec
            DaterFichier(PF,DTF);
          end;
        finally
          CloseFile(TF);
          SysUtils.DeleteFile(verrou);
        end;
        break; //enregistr
      except
        on EInOutError do if essais=3 then begin
          ShowMessage('impossible d''enregistrer, recommencez');
          exit;
        end else sleep(essais*500);
      end;
    end;
  finally
    SL.Free;
  end;
end;

function MettreAJourFichier2(PF:string;fncMAJ:TfncMAJtxt;data:pointer;redater:boolean):boolean;
//le 3/10/03 : augmente la date DOS d'au moins 2 sec
//le 8/10/03 : ne change pas la date si redater est F, sinon ajoute au moins 2 s  la date
var
  TF: TextFile;
  essais: integer;
  DTF: TDateTime;
  verrou,src: string;
begin
  result:=false;
  if not FileExists(PF) then StringToFile('',PF); //cre vide
  DTF:=FileDateToDateTime(FileAge(PF));
  for essais:=1 to 3 do begin
    try
      verrou:=FormaterNomDeVerrouillage(PF);
      AssignFile(TF,verrou);    //nom.~ext
      Rewrite(TF);
      try
        StringFromFile(PF);
        if fncMAJ(src,data) then begin
          StringToFile(src,PF);
          result:=true;
        end;
        if redater and result then begin
          if DTF<Now then DTF:=Now else DTF:=DTF+2/(24*60*60);//ajoute 2 sec
          DaterFichier(PF,DTF);
        end;
      finally
        CloseFile(TF);
        SysUtils.DeleteFile(verrou);
      end;
      break; //enregistr
    except
      on EInOutError do if essais=3 then begin
        ShowMessage('impossible d''enregistrer, recommencez');
        exit;
      end else sleep(essais*500);
    end;
  end;
end;

procedure NormalizeTopJP;
var
  i: integer;
  C: TComponent;
begin    exit;
  for i:=1 to Application.ComponentCount do begin
    C:=Application.Components[i-1];
    if (C is TForm) and (TForm(C).FormStyle=fsStayOnTop)
     then SetWindowPos(TForm(C).Handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE+SWP_NOOWNERZORDER);
  end;
end;

procedure RestoreTopJP;
var
  i: integer;
  C: TComponent;
begin    exit;
  for i:=1 to Application.ComponentCount do begin
    C:=Application.Components[i-1];
    if (C is TForm) and (TForm(C).FormStyle=fsStayOnTop)
     then SetWindowPos(TForm(C).Handle,HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE+SWP_NOOWNERZORDER);
  end;
end;

procedure ShowMsg(S:string);
begin
  NormalizeTopJP; //Application.ProcessMessages;
  ShowMessage(S);
  RestoreTopJP;
end;

procedure ShowMessageMs(S:string);
begin
  MessageDlgMs(S , mtCustom, [mbOK]);
end;

function MessageDlgMs(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons): Integer;
var
p: TPoint;
begin
  p:=Mouse.CursorPos;
  with CreateMessageDialog(Msg, DlgType, Buttons) do
    try
      CursorArrow;
      Left := MIN( p.X, Screen.Width-Width);
      Top := MIN( p.Y , Screen.Height-Height);
      Result := ShowModal;
    finally
      Free;
      PopCursor;
    end;
end;

function InputQueryTop(caption,prompt:string;var S:string):boolean;
begin
  NormalizeTopJP;//Application.NormalizeTopMosts;
  result:=InputQuery(caption,prompt,S);
  RestoreTopJP;//Application.RestoreTopMosts;
end;

function MessageDlgConf(msg:string):boolean;
begin
  NormalizeTopJP;
  result:=MessageDlg(msg,mtConfirmation,[mbYes,mbNo],0)=mrYes;
  RestoreTopJP;
end;

procedure CheckNextCtrl(HF:HWND;var key:char);
(*douteux, utiliser de prfrence
procedure TFEditType.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key=VK_RETURN then PostMessage(Handle,wm_NextDlgCtl,0,0);
end;
*) 
begin
  if key=#13 then begin
    key:=chr(0);
    PostMessage(HF,wm_NextDlgCtl,0,0);
  end;
end;

function ClipboardAsString(frmt:integer):string;
var
  S,entete,mkdeb,mkfin: string;
  Pc: PChar;
  H: HGLOBAL;
begin
  result:='';
  if OpenClipboard(0) then try
    H:=GetClipboardData(frmt);
    if H=0 then exit;
    Pc:=GlobalLock(H);
    try
      result:=Pc;
    finally
      GlobalUnlock(H);
    end;
  finally
    CloseClipboard;
  end;
end;

procedure StringToClipboard(frmt:integer;S:string);
var
  Data: THandle;
  DataPtr: Pointer;
  size: integer;
begin
  S:=S+#0;
  size:=length(S);//+1;
  Clipboard.Clear;
  Clipboard.Open;
  try
    Data := GlobalAlloc(GMEM_MOVEABLE+GMEM_DDESHARE, size);
    try
      DataPtr := GlobalLock(Data);
      try
        Move(S[1], DataPtr^, size);
     //   SetClipboardData(frmt, Data);
        Clipboard.SetAsHandle(frmt,Data);
      finally
        GlobalUnlock(Data);
      end;
    except
      GlobalFree(Data);
      raise;
    end;
  finally
    Clipboard.Close;
  end;
end;

procedure HTMLtoClipboard(S:string;deb:string='<HTML><BODY>';fin:string='</BODY></HTML>');
var
  Sd1,Sd2,Sf1,cb: string;
  dfds,fffs: integer;
begin
  Sd1:='Version:1.0'#13#10+               //13
           'StartHTML:000000000a'#13#10+  //22
             'EndHTML:000000000b'#13#10+  //20
       'StartFragment:000000000c'#13#10+  //26
         'EndFragment:000000000d'#13#10+  //24
      'StartSelection:000000000e'#13#10+
        'EndSelection:000000000f'#13#10;
  Sd2:=deb+'<!-- StartFragment-->';
  Sf1:='<!-- EndFragment-->'+fin;
  cb:=Sd1+Sd2+S+Sf1;
  dfds:=length(Sd1+Sd2);
  fffs:=length(Sd1+Sd2+S);
  cb:=StringReplace(cb,'000000000a',Format('%10.10d',[length(Sd1)]),[]); //start HTML
  cb:=StringReplace(cb,'000000000b',Format('%10.10d',[length(cb)]),[]); //end HTML
  cb:=StringReplace(cb,'000000000c',Format('%10.10d',[dfds]),[]);//start frag
  cb:=StringReplace(cb,'000000000d',Format('%10.10d',[fffs]),[]); //end frag
  cb:=StringReplace(cb,'000000000e',Format('%10.10d',[dfds]),[]);//start sel
  cb:=StringReplace(cb,'000000000f',Format('%10.10d',[fffs]),[]); //end sel
  StringToClipboard(CF_HTML,ANSItoUTF8(cb));
end;

function ClipboardFormats:string;
var
  i,j: integer;
  buf: array[0..1023] of char;
begin
  result:='';
  for i:=1 to clipboard.FormatCount do begin
    j:=clipboard.Formats[i-1];
    GetClipboardFormatName(j,@buf[0],1023);
    result:=result+IntToStr(j)+#9+strpas(@buf[0])+#13#10;
  end;
end;

function ClipboardAsFilesNames:string; //renvoie une liste de chemins spars par des CRLF
var
  hdrop: THandle;
  i,nbf,nc: integer;
  buf: string;
begin
  Clipboard.Open;
  hdrop:=ClipBoard.GetAsHandle(CF_HDROP);
  result:='';
  nbf:=DragQueryFile(hdrop,$FFFFFFFF,nil,0);
  for i:=1 to nbf do begin
    nc:=DragQueryFile(hdrop,i-1,nil,0);
    SetLength(buf,nc+1);
    DragQueryFile(hdrop,i-1,@buf[1],nc+1);
    DecStr(buf,1);//ote #0 final
    result:=result+k_CRLF+buf;
  end;
  delete(result,1,2);
  Clipboard.Close;
end;

function ClipboardDropEffect:cardinal;//renvoie DROPEFFECT_MOVE ou DROPEFFECT_COPY
var
  hGlobalDropEffect: cardinal;
  lpGlobalDropEffect: pointer;
begin
  Clipboard.Open;
  hGlobalDropEffect:=ClipBoard.GetAsHandle(CF_PREFERREDDROPEFFECT);
  if hGlobalDropEffect<>0 then begin
    lpGlobalDropEffect := GlobalLock(hGlobalDropEffect);
    if Assigned( lpGlobalDropEffect )
     then result:=Cardinal(lpGlobalDropEffect^)
     else result:=DROPEFFECT_NONE;
    GlobalUnlock(hGlobalDropEffect);
  end else result:=DROPEFFECT_NONE;
  Clipboard.Close;
end;

function ListeCRLF_to_Liste00(listeCRLF:string):string;//transforme une liste de noms de fichier sp CRLF par la mme, sp #0, fin #0#0
begin
  ListeCRLF:=Trim(ListeCRLF);//ote les CRLF en bouts
  result:=StringReplace(ListeCRLF , k_CRLF , #0 , [rfReplaceAll]) + #0#0;
end;

procedure FilesNamesToClipboard(S:string;DropEffect : Cardinal);   //   DropEffect = DROPEFFECT_MOVE ou DROPEFFECT_COPY
//S contient une liste de path spars par CRLF, ou par #0 avec double #0 final
//ncessite ShlObj, ActiveX
{To set the file names on the clipboard, first clear the clipboard using Clipboard.Clear.
Then open the clipboard for API use with OpenClipboard.
Next build a string containing the file names.
Put a vbNullChar between the names and end the string with two vbNullChar characters.
Now initialize a DROPFILES structure and put it in global memory.
Set the pFiles field to the size of the DROPFILES structure.
This gives the offset from the beginning of the structure to the location of the file name string.
Use GlobalAlloc to get a chunk of global memory big enough to hold the structure and the string.
Use GlobalLock to lock the memory and get a pointer to it.
Then use CopyMem to copy the DROPFILES structure and the file name string into the memory.
Now unlock the memory and use it to set the clipboard's data with the SetClipboardData API function.
Finally, close the clipboard with CloseClipboard.
}
var
  drop_files: DROPFILES;
  hGlobalDropEffect, memory_handle: cardinal;
  lpGlobalDropEffect: pointer;
  memory_pointer: pchar;//autorise les oprations
  i,sizdf: integer;
//  p: pchar;//autorise les oprations
begin
  Clipboard.Open;
  Clipboard.Clear;
  hGlobalDropEffect := GlobalAlloc(GHND, SizeOf(Cardinal));
  If hGlobalDropEffect <> 0 Then Begin
    lpGlobalDropEffect := GlobalLock(hGlobalDropEffect);
    Cardinal(lpGlobalDropEffect^) := DropEffect;
    GlobalUnlock(hGlobalDropEffect);
    Clipboard.SetAsHandle( CF_PREFERREDDROPEFFECT, hGlobalDropEffect );
  end;
// Build a null-terminated list of file names.
  if Pos(#0,S)=0 then S:=ListeCRLF_to_Liste00(S); //c'est des CRLF
// Initialize the DROPFILES structure.
  sizdf:=SizeOf(drop_files);
  drop_files.pFiles := sizdf;
  drop_files.fWide := false ;// ANSI characters.
  drop_files.fNC := false ;//  Client coordinates.
// Get global memory to hold the DROPFILES structure and the file list string.
  memory_handle := GlobalAlloc(GHND, sizdf + Length(S));
  If memory_handle<>0 then begin
// Lock the memory while we initialize it.
    memory_pointer := GlobalLock(memory_handle);
// Copy the DROPFILES structure and the file string into the global memory.
    CopyMemory(memory_pointer , @drop_files , sizdf);
    inc(memory_pointer, sizdf);
    CopyMemory(memory_pointer , @S[1] , Length(S));
    GlobalUnlock( memory_handle );
// Copy the data to the clipboard.
    Clipboard.SetAsHandle( CF_HDROP, memory_handle );
  end;
// Close the clipboard.
  Clipboard.Close;
end;
 {
Function CopyDropFilesToClipBoard(FilesPath : TStrings;DropEffect : Cardinal = DropCopy) : Bool;
// Copie un fichier dans le presse-papiers au format de l'explorateur
Var
  Data : CharArray;
  hGlobalDropEffect, hGlobalDrop, hGlobalFileName : Cardinal;
  lpGlobalDropEffect, lpGlobalDrop, lpGlobalFileName : Pointer;
  df : TDROPFILES;
Begin
  Result := False;
  ZeroMemory(@Data, Length(Data));
  // Ouvre et vide le presse-papiers
  If OpenClipboard(0) Then
  Try
    Begin
      EmptyClipboard;
      // Alloue un pointer  la mmoire globale pour DropEffect
      hGlobalDropEffect := GlobalAlloc(GHND, SizeOf(Cardinal));
      If hGlobalDropEffect <> 0 Then
      Begin
        lpGlobalDropEffect := GlobalLock(hGlobalDropEffect);
        Cardinal(lpGlobalDropEffect^) := DropEffect;
        GlobalUnlock(hGlobalDropEffect);
        // Construit une chane avec un double zro
        Data := StrTo2NullTerminateChars(FilesPath);
        // Alloue un pointer  la mmoire globale pour le Drop
        hGlobalDrop := GlobalAlloc(GHND, Length(Data) + SizeOf(df));
        If hGlobalDrop <> 0 Then
        Begin
          lpGlobalDrop := GlobalLock(hGlobalDrop);
          Df.pFiles := SizeOf(df);
          Df.fWide :=False;
          // Copie de la structure df de type HDROP
          CopyMemory(lpGlobalDrop, @df, SizeOf(df));
          Inc(PChar(lpGlobalDrop), SizeOf(df));
          // Copie de la chane Data
          CopyMemory(lpGlobalDrop, Pointer(Data), Length(Data));
          GlobalUnlock(hGlobalDrop);
          // Alloue un pointer  la mmoire globale pour les noms de fichier
          hGlobalFileName := GlobalAlloc(GHND, Length(Data));
          If hGlobalFileName <> 0 Then
          Begin
            lpGlobalFileName := GlobalLock(hGlobalFileName);
            CopyMemory(lpGlobalFileName, Pointer(Data), Length(Data));
            GlobalUnlock(hGlobalFileName);
          End;
          // Copie dans le presse-papiers
          If (SetClipboardData(CF_PREFERREDDROPEFFECT, hGlobalDropEffect) <> 0) And
            (SetClipboardData(CF_HDROP, hGlobalDrop) <> 0) And
            (SetClipboardData(CF_FILENAME, hGlobalFileName) <> 0) Then Result := True;
        End;
      End;
    End;
    // Ferme le presse-papiers
  Finally
    CloseClipboard;
  End;
End;
   }
function GetClipboardFormat(hfrmt:integer):string;
var
MyHandle: THandle;
TextPtr: PChar;
begin
  MyHandle := Clipboard.GetAsHandle(hfrmt);
  TextPtr := GlobalLock(MyHandle);
  result:=TextPtr;
  GlobalUnlock(MyHandle);
end;

function FileInfo(PF:string; var SR:TSearchRec):boolean;
begin
  result:=SysUtils.FindFirst(PF,faArchive,SR)=0;
  SysUtils.FindClose(SR);
end;

function ModuleFileName(H:HWND):string;
var
  buf: array[0..1023] of char;
begin
  if Windows.GetModuleFileName(H,@buf,1023)=0 then result:=strpas(@buf[0]) else result:='';
end;

function FileInfo(PF:string):TSearchRec; //renvoie Name='' si erreur
begin
  if SysUtils.FindFirst(PF,faArchive,result)<>0 then result.Name:='';
  SysUtils.FindClose(result);
end;

function FileSize(PF:string):int64;
var SR:TSearchRec;
begin
  SR:=FileInfo(PF);
  if SR.Name='' then result:=0 else begin
    Int64Rec(result).Hi:=SR.FindData.nFileSizeHigh;
    Int64Rec(result).Lo:=SR.FindData.nFileSizeLow;
  end;
end;

function AryI2Str(ary:array of integer;nelts:integer):string;
var
  i:integer;
begin
  result:='';
  for i:=1 to nelts do result:=result+' '+IntToStr(ary[i-1]);
  delete(result,1,1);
end;

procedure Str2AryI(var ary:array of integer;nelts:integer;S:string);
//S contient le nombre exact de valeurs spares par 1 espace
var
  i: integer;
begin
  for i:=0 to nelts-1 do ary[i]:=StrToIntDef(LireEtOterStr0(S,' '),0);
end;

procedure OuvrirDoc(HW:HWND; dir,fic:string; OI:integer);
const
  op: array[1..2] of string = ('open','print');
var
  i: integer;
  fic_,
  dir_: array[0..1023] of char;
begin
  if fic='' then begin
    fic:=ExtractFileName(dir);
    dir:=ExtractFilePath(dir);
  end;
  dir:=ExcludeTrailingBackslash(dir);
  StrPCopy(@dir_,dir);
  StrPCopy(@fic_,fic);
  i:=ShellExecute(HW, PChar(op[OI]) , @fic_, NIL, @dir_, SW_SHOWNORMAL);
  if i<33 then ShowMsg(dir+'\'+fic+' :'#13+TxtShellErr(i));
end;

{function FindExec(ext:string):string;  marche pas
var
  exe_,
  fic_,
  dir_: array[0..1023] of char;
begin
//  StrPCopy(@dir_,ExtractFilePath(PF));
  StrPCopy(@fic_,'x.'+ext);
  if FindExecutable(fic_,nil,exe_)>32 then result:=exe_ else result:='';
end;                                              }

function DWS(WST:byte):string;
var
  buf: array of char;
  pc: pchar;
  i,sz: integer;
begin
  sz:=MAX_PATH;
  repeat
    SetLength(buf,sz);
    pc:=@buf[0];
    case WST of
    0: i:=GetWindowsDirectory(pc,sz);
    1: i:=GetSystemDirectory(pc,sz);
    2: i:=GetTempPath(sz,pc);
    end;
    if i<=sz then begin
      if i=0 then result:='' else result:=pc;
      exit;
    end;
    sz:=i+16;
  until false;
end;

function DirWin:string;
begin
  result:=DWS(0);
end;

function DirWinSys:string;
begin
  result:=DWS(1);
end;

function DirWinTemp:string;
begin
  result:=DWS(2);
end;

function DirAppli:string;  //comprend le \ ou : final
begin
  result:=ExtractFilePath(Application.ExeName);
end;

function DirAppliExp:string;  //comprend le \ ou : final
begin
  result:=ExtractFilePath(ExpandUNCFileName(Application.ExeName));;
end;

function PathTemp(ext:string):string; //ext doit contenir le point
begin
  result:=DirWinTemp+GetCID+ext;
end;

procedure DeleteTempFiles(ext:string;AgeMiniEnJ:TDateTime=0);
begin
  EffacerFichiers(DirWinTemp+'*'+ext,AgeMiniEnJ);
end;

procedure PushAffiCurs(curs:integer);
begin
  PileCurs:=IntToStr(Screen.Cursor)+' '+PileCurs;
  Screen.Cursor:=curs;
  Application.ProcessMessages;
end;

procedure PopCursor;
var
  i: integer;
begin
  try
    i:= StrToIntDef(LireEtOterStr0(PileCurs,' '),0 );
    Screen.Cursor:=i;
    Application.ProcessMessages;
  except end;
end;

procedure CursorWait;
begin
  PushAffiCurs(crHourGlass);
end;

procedure CursorArrow;
begin
  PushAffiCurs(crArrow);
end;

procedure CursorPop;
begin
  PopCursor;
end;

procedure CursorPushAffi(curs:integer);
begin
  PushAffiCurs(curs);
end;

function ShFileOp(HW:HWND;s,d:string;op:UINT;flg:FILEOP_FLAGS):integer;
{op:
FO_COPY FO_DELETE FO_MOVE FO_RENAME

Multiple names must be null-separated. : s et d : nom #0 nom #0 ... #0 dernier_nom #0#0

flg :
FOF_ALLOWUNDO	Preserves undo information, if possible.
FOF_CONFIRMMOUSE	Not implemented.
FOF_FILESONLY	Performs the operation only on files if a wildcard filename (*.*) is specified.
FOF_MULTIDESTFILES	Indicates that the pTo member specifies multiple destination files (one for each source file) rather than one directory where all source files are to be deposited.
FOF_NOCONFIRMATION	Responds with "yes to all" for any dialog box that is displayed.
FOF_NOCONFIRMMKDIR	Does not confirm the creation of a new directory if the operation requires one to be created.
FOF_RENAMEONCOLLISION	Gives the file being operated on a new name (such as "Copy #1 of...") in a move, copy, or rename operation if a file of the target name already exists.
FOF_SILENT	Does not display a progress dialog box.
FOF_SIMPLEPROGRESS	Displays a progress dialog box, but does not show the filenames.
FOF_WANTMAPPINGHANDLE Fills in the hNameMappings member. The handle must be freed by using the SHFreeNameMappings function.

dplacer : er:=ShFileOp(Handle,src,dst,FO_MOVE,FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR or FOF_SILENT)
renommer : er:=ShFileOp(Handle,src,dst,FO_RENAME,FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR or FOF_SILENT)
contrle : if er<>0 then ShowMessage( SysErrorMessage(er) ); //sysutils
}
var
  FO: TSHFileOpStruct;
begin
  s:=s+#0#0; //The list of names must be double null-terminated.
  d:=d+#0#0;
  FO.Wnd:=HW;
  FO.wFunc:=op;//FO_MOVE;
  FO.pFrom:=@s[1];
  FO.pTo:=@d[1];
  FO.fFlags:=flg;//FOF_NOCONFIRMATION+FOF_NOCONFIRMMKDIR;
  FO.hNameMappings:=NIL;
  FO.lpszProgressTitle:=NIL;
//  OleCheck(SHFileOperation(FO));
  result:=SHFileOperation(FO);
  SHChangeNotify(SHCNE_ALLEVENTS,0,NIL,NIL);
end;

function ShRename(s,d:string):integer;
begin
  result:=ShFileOp(Application.MainForm.Handle,s,d,FO_RENAME,FOF_NOCONFIRMATION+FOF_SILENT);
end;
//function ConcatLong(S1,S2: string):string;
//var
procedure LogInit(PF:string);
begin
  Slog:='';
  PFlog:=PF;
end;

procedure LogAdd(S:string;save:boolean=false);
begin
  if PFlog='' then exit;
  Slog:=Slog+S+#13#10;
  if save then LogSave;
end;

procedure LogDTAdd(S:string;save:boolean=false);
begin
  if PFlog='' then exit;
  Slog:=Slog+DateTimeToStr(Now)+' : '+S+#13#10;     // showmessage(S);
  if save then LogSave;
end;

function LogGet:string;
begin
  result:=Slog;
end;

procedure LogSave;
begin
  if PFlog='' then exit;
  StringToFile(Slog,PFlog);
end;

function GetCID:string;   //32 chiffres
var
  GUID: TGUID;
begin
  CreateGUID(GUID);
  result:=Format('%.8x%.4x%.4x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x',   // do not localize
    [GUID.D1, GUID.D2, GUID.D3, GUID.D4[0], GUID.D4[1], GUID.D4[2], GUID.D4[3],
    GUID.D4[4], GUID.D4[5], GUID.D4[6], GUID.D4[7]]);
end;

procedure ShowMessageDbg(msg:string);
begin
  if ModeDebug then ShowMessage(msg);
end;

procedure SetEnvironmentVariable(const Name,Value: string);
begin
  Windows.SetEnvironmentVariable(pchar(Name),pchar(Value));
end;

function GetNextTabControl(F:TForm;CurControl:TWinControl):TWinControl;
var
  I, StartIndex: Integer;
  List: TList;

begin
  Result := nil;
  List := TList.Create;
  try
    F.GetTabOrderList(List);
    if List.Count > 0 then begin
      StartIndex := List.IndexOf(CurControl);
      if StartIndex = -1 then StartIndex := List.Count - 1 ;
      I := StartIndex;
      repeat
        Inc(I);
        if I = List.Count then I := 0;
        CurControl := List[I];
        if CurControl.CanFocus and CurControl.TabStop then Result := CurControl;
      until (Result <> nil) or (I = StartIndex);
    end;
  finally
    List.Free;
  end;
end;

function GetParentForm(C:TControl):TCustomForm;
begin
  repeat
    C:=C.Parent;
  until (C=nil) or (C is TCustomForm);
  result:=TCustomForm(C);
end;

function GetOwnerForm(C:TComponent):TCustomForm;
begin
  repeat
    C:=C.Owner;
  until (C=nil) or (C is TCustomForm);
  result:=TCustomForm(C);
end;

procedure EnableDisablePanel(Pn:TPanel;enable:boolean);
  procedure EnDiComp(C:TWinControl);
  var
    i: integer;
  begin
    for i:=1 to C.ControlCount do if (C.Controls[i-1] is TWinControl) then EnDiComp(TWinControl(C.Controls[i-1]));
    C.Enabled:=enable;
  end;
begin
  EnDiComp(Pn);
end;

procedure FreeAndNil2(var Obj);
var
  Temp: TObject;
begin
  Temp := TObject(Obj);
  if Temp=nil then exit;
  Pointer(Obj) := nil;
  Temp.Free;
end;

function SameValuePourCent(Vref,V2,pourcent:extended):boolean;
begin
  result:=SameValue(Vref,V2,ABS(Vref*pourcent/100));
end;

function GetShiftState:TShiftState;
begin
  Result := [];
  if GetKeyState(VK_SHIFT) < 0 then Include(Result, ssShift);
  if GetKeyState(VK_CONTROL) < 0 then Include(Result, ssCtrl);
  if GetKeyState(VK_MENU) < 0 then Include(Result, ssAlt);
end;
function ToucheShift:boolean;
begin
  result:= GetKeyState(VK_SHIFT) < 0 ;
end;

procedure GetMouseState(var dwFlags, dx, dy, dwData, dwExtraInfo: DWORD);
begin
  mouse_event(dwFlags, dx, dy, dwData, dwExtraInfo);
end;
function GetMouseFlags:DWORD;
var
dx, dy, dwData, dwExtraInfo: DWORD;
begin
  mouse_event(result, dx, dy, dwData, dwExtraInfo);
end;

function ExisteFichiersAColler:boolean;
var
  hdrop: THandle;
begin
  hdrop:=ClipBoard.GetAsHandle(CF_HDROP);
  result:= DragQueryFile(hdrop,$FFFFFFFF,nil,0) > 0 ;
end;

function FichiersAColler:string;
var
  hdrop: THandle;
  i,nbf,nc: integer;
  buf: string;
begin
  hdrop:=ClipBoard.GetAsHandle(CF_HDROP);
  nbf:=DragQueryFile(hdrop,$FFFFFFFF,nil,0);
  result:='';
  for i:=1 to nbf do begin
    nc:=DragQueryFile(hdrop,i-1,nil,0);
    SetLength(buf,nc+1);
    DragQueryFile(hdrop,i-1,@buf[1],nc+1);
    DecStr(buf,1);//ote #0 final
    result:=k_CRLF+buf;
  end;
  delete(result,1,2);
end;

procedure Set_PageControl_TabControl_Index(PCTC:TCustomTabControl;ixpg:integer);
var
  allowchange: boolean;
begin
  with TTabControl(PCTC) do begin //les evts de TCustomTabControl ne sont pas visibles
    if Assigned( OnChanging ) then begin
      allowchange:=true;
      OnChanging(PCTC,allowchange);
      if not allowchange then exit;
    end;
    if PCTC is TPageControl then TPageControl(PCTC).ActivePageIndex:=ixpg;
    if PCTC is TTabControl then TTabControl(PCTC).TabIndex:=ixpg;
    if Assigned( OnChange ) then OnChange(PCTC);
  end;
end;

function PropidesLireProprietes(PF:string):string;
var
  FS: TFileStream;
  FH: TFileHeader;
begin
  if not FileExists(PF) then exit;
  FH:= TFileHeader.Create(nil);
  try
    FS:= TFileStream.Create(PF,fmOpenRead or fmShareDenyNone);
    try
      FH.LoadFromStream(FS,NIL);
    finally
      FS.Free;//ferme
    end;
    result:=FH.Strings.Text;
  finally
    FH.Free;
  end;
end;

function PropidesLirePropriete(PF,Nom:string):string;
var
  FS: TFileStream;
  FH: TFileHeader;
begin
  if not FileExists(PF) then exit;
  FH:= TFileHeader.Create(nil);
  try
    FS:= TFileStream.Create(PF,fmOpenRead or fmShareDenyNone);
    try
      FH.LoadFromStream(FS,NIL);
    finally
      FS.Free;//ferme
    end;
    result:=FH.GetValeur(Nom);
  finally
    FH.Free;
  end;
end;

procedure PropidesDefinirPropriete(PF,Nom,Valeur:string);
var
  FS: TFileStream;
  buf: AnsiString;//8 bit par car
  FH: TFileHeader;
  n: Longint;
begin
  if not FileExists(PF) then exit;
  FH:= TFileHeader.Create(nil);
  try
    FS:= TFileStream.Create(PF,fmOpenRead or fmShareDenyNone);
    try
      FH.LoadFromStream(FS,NIL);
//sauve le contenu
      n:=FS.Size-FS.Position;
      SetLength(buf,n);//6/6 supprim +1
      n:=FS.Read(buf[1],n);
    finally
      FS.Free;//ferme
    end;
//modifie header
    FH.SetValeur(Nom,Valeur);
//rcrit
    DeleteFile(PF);
    FS:= TFileStream.Create(PF,fmCreate or fmShareExclusive);
    try
      FH.SaveToStream(FS,NIL);
      FS.Write(buf[1],n);
    finally
      FS.Free;
    end;
  finally
    FH.Free;
  end;
end;

function GetDirPartage:string;
{tout programme destin  tre rang dans IDES avec des paramtres rangs ailleurs (serveur, par ex) devrait appeler la
  fonction Utils.GetDirPartage, qui renvoie le rpertoire pris dans le registre, ou  dfaut le rpertoire de l'appli}
var
  nomapp,S: string;
  R: TRegistry;
begin
  S:=Application.ExeName;
  nomapp:=lowercase(GetPathElt(S,k_peNomExt));  // showmessage(nomapp);
  R:=TRegistry.Create;
  R.RootKey:=HKEY_CLASSES_ROOT;
  R.OpenKey('\Applications\'+nomapp,false);
    result:=R.ReadString('dirpartage');    //showmessage(result);
  R.CloseKey;
  R.Free;
  if result='' then begin //dfaut
    S:=GetPathElt(S,k_peDrvDir);
    result:=ExcludeTrailingBackSlash(S);//dfaut = dir de l'appli
  end;
end;

function CalPtr(p:pointer;addsub:integer):pointer; //renvoie un pointeur dcal de addsub
begin
  result:=pointer( integer(p)+addsub );
end;

function HostName:string;
var
  Name: array[0..100] of Char;
  WSAData: TWSAData;
begin
  result := '';
  if WSAStartup($0101, WSAData) <> 0 then exit;
  if GetHostName(@Name[0], SizeOf(Name)) = 0 then result := StrPas(@Name);
  WSACleanup;
end;

function GetIPFromHost:string;
var
  Name: array[0..100] of Char;
  HEnt: pHostEnt;
  addr: in_addr;
  WSAData: TWSAData;
  i: Integer;
  S: string;
begin
  result := '';
  if WSAStartup($0101, WSAData) <> 0 then exit;
  if GetHostName(@Name[0], SizeOf(Name)) = 0 then begin
//    HostName := StrPas(@Name);
    HEnt := GetHostByName(@Name[0]);
//    S:=PChar( HEnt^.h_addr_list^[0] );
    addr.S_addr:=integer( HEnt^.h_addr_list^[0] );
//    for i := 0 to HEnt^.h_length - 1 do result:='.'+ Format('%3.3d',[Ord(HEnt^.h_addr_list^[i])]);
    result:=inet_ntoa(addr);
//    delete(result,1,1);
  end;
  WSACleanup;
end;

procedure NormaliserIP4(var ip:string);
//force 4 groupes de 3 chiffres
var
  S,S1: string;
begin
  S:='';
  ip:=Trim(ip);
  while ip<>'' do begin
    S1:=LireEtOterStr0(ip,'.');
    S:=S+'.'+StringOfChar('0',3-length(S1))+S1;
  end;
  delete(S,1,1);
  ip:=S;
end;

function IntToInt64(L,H:integer):int64;
begin
  TI64(result).LoI:=L;
  TI64(result).HiI:=H;
end;
function W32(L,H:word):TW32;
begin
  result.Low:=L; result.Hiw:=H;
end;
function I64(L,H:cardinal):TI64;
begin
  result.LoI:=L; result.HiI:=H;
end;

procedure ControlAtMouse(Ct:TControl); //place  l'endroit de la souris et recale dans l'cran si dpasse  droite ou en bas
var
p: TPoint;
begin
  p:=Mouse.CursorPos;
  p.X:=Min(p.X,Screen.Width-Ct.Width);
  p.Y:=Min(p.Y,Screen.Height-Ct.Height);
  if Assigned(Ct.Parent) then p:=Ct.Parent.ScreenToClient(p);
  Ct.Left:=p.X;
  Ct.Top:=p.Y;
  Application.ProcessMessages;
end;

procedure ColorToBW(var Cl:TColor);
var
bytes: array[1..4] of byte absolute Cl;
i,bw: integer;
begin
  bw:=0;
  for i:=1 to 3 do bw:=bw+bytes[i];
  bw:=bw div 3;
  for i:=1 to 3 do bytes[i]:=bw;
end;

procedure CheckErr(resfonc:boolean);
begin
  if resfonc then exit;
  ShowMessage(SysErrorMessage(GetLastError));
end;

function GetDirectoryHandle(PathDir:string):cardinal;
var
PD: AnsiString;
begin
  PD:=PathDir+#0;
  result := CreateFile (
    @PD[1],
    GENERIC_READ + GENERIC_WRITE,
    FILE_SHARE_READ + FILE_SHARE_DELETE,
    0,
    OPEN_EXISTING,
    FILE_FLAG_BACKUP_SEMANTICS,
    0
    );
end;

procedure CreerSousMenu(MIp:TMenuItem; evClic:TNotifyEvent; Captions:string);
var
Mi: TMenuItem;
S: string;
n: integer;
begin
  MIp.Clear;
  n:=1;
  repeat
    S:=LgetS(Captions);
    if S='' then exit;
    Mi:=TMenuItem.Create(MIp.Owner);
    Mi.Caption:=S;
    Mi.Name:=MIp.Name+'ssmenu'+IntToStr(n);
    Mi.Tag := n;
    Mi.OnClick:=evClic;
    MIp.Add(Mi);
    inc(n);
  until false;
end;

procedure CkLBx_checkuncheckall(CB:TCheckListBox; chk:boolean);
var
i: integer;
begin
  for i:=0 to CB.Items.Count-1 do CB.Checked[i]:=chk;
end;

function Modulo(valeur,diviseur:double):double;
begin
  result:= Frac(valeur/diviseur)*diviseur;
end;

initialization
  CF_HTML:=RegisterClipboardFormat('HTML Format');
  CF_PREFERREDDROPEFFECT := RegisterClipboardFormat(CFSTR_PREFERREDDROPEFFECT);
  ModeDebug := FileExists( ChangeFileExt( ParamStr(0) , '.dpr' ) );
  SLFichiersVerrouilles:=TStringList.Create;
  DecimalSeparator:='.';
  PileCurs:='';
  Slog:='';
finalization
  DeverrouillerFichiersVerrouilles;
  SLFichiersVerrouilles.Free;
end.

(*








Version:1.0''StartHTML:0000000111''EndHTML:0000000174''StartFragment:0000000138'
'EndFragment:0000000312''<HTML><BODY><!-- StartFragment-->azertyuiop
<!-- EndFragment--></BODY>'
