unit UH2D;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CwinReg, OleServer, Word97;

type
  TForm3 = class(TForm)
    BtGO: TButton;
    WR: TWinReg;
    OD: TOpenDialog;
    wdhtm: TWordDocument;
    LBx: TListBox;
    mmohlp: TMemo;
    Lb1: TLabel;
    LbDir: TLabel;
    BtChDir: TButton;
    procedure BtGOClick(Sender: TObject);
    procedure WRChargeReg;
    procedure WRRangeReg;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure BtChDirClick(Sender: TObject);
  private
    { Dclarations prives }
    DF: string;
    init: boolean;
    procedure ChDir;
    procedure Check;
  public
    { Dclarations publiques }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

uses Utils, StringUtils, WordUtils, StrUtils;

procedure TForm3.ChDir;
begin
  if not OD.Execute then exit;
  DF:=ExtractFileDir( OD.FileName )+'\';
end;

procedure TForm3.Check;
begin
  LbDir.Caption:=DF;
  BtGO.Enabled:= DF<>'';
end;

procedure TForm3.BtGOClick(Sender: TObject);
  procedure gotoFin;
  var
  ovUnit,ovCount: OleVariant;
  begin
    ovUnit:=wdStory; ovCount:=1;
    WinWord.WAP.Selection.Move(ovUnit,ovCount);
  end;
  function extrairebalise(var S:string):string;//efface S
  begin
    StrLireEtOterStr0(S,'<');
    result:=StrLireEtOterStr0(S,'>');
  end;
  function lienvalide(lien:string; var liens:string):boolean;
  begin
    result:=Pos(k_TAB+LowerCase(lien)+k_TAB , liens) > 0 ;
  end;
var
liste,S,TxtName,TmpName,Shtm,S1,S2,S3,liens,liensremp,rapport,liensappeles,liensenregistres,NFhtm: string;
ovUnit,ovCount,OvExtend,
DocName, DocDocName, ovBlk,
ovFmt, ovF,ovT : OleVariant;
docdoc,dochtm: _document;
begin
  if DF='' then exit;
  TxtName:= DF+'htm2doc.txt';
  if not FileExists(TxtName) then begin
    ShowMessage('Manquant : '+TxtName);
    exit;
  end;
//ouvrir le fichier de commande
  liste:=StringPurgerComm( StringFromFile(TxtName) , true );
//lire le nom du modle
  S:=LgetS(liste);
  DocName:= DF+S;//'base.doc';
  if not FileExists(DocName) then begin
    ShowMessage('Manquant : '+DocName);
    exit;
  end;
//lire le nom de destination
  S:=LgetS(liste);
  DocDocName:= DF+S;//'base.doc';
//initialisations
  TmpName:=DF+GetCID+'.htm';
  ovF:=false;
  ovT:=true;
  ovFmt:=wdOpenFormatAuto;//Document;
  ovBlk:='';
  rapport:='Translation des liens href :'+k_CRLF;
  liensappeles:=k_TAB+k_TAB;
  liensenregistres:=k_TAB;
  CreateWinWord;
  try
    docdoc:=WinWord.WAP.Documents.Open(DocName,ovF,
                       ovF,ovF,
                       ovBlk,ovBlk,
                       ovF,ovBlk,
                       ovBlk,ovFmt);
//aller en fin
    gotoFin;
//traiter la liste des commandes
    repeat
      S:=LgetS(liste);
      if S='' then break;
      LBx.Items.Add(S);
      SendMessage(LBx.Handle, LB_SETTOPINDEX , LBx.Count-1 , 0);
      Application.ProcessMessages;
      if S[1]=';' then Continue;
      if S[1]='*' then begin //c'est un titre
        Delete(S,1,1);
        WinWord.TypeText_(S);
        WinWord.SetStyle_('Titre 1');
        WinWord.TypeParagraph_;
//pages
      end else begin //c'est un fichier
        NFhtm:=Lowercase(S);
        rapport:=rapport+'>> fichier : '+NFhtm+k_CRLF;
        liensenregistres:=liensenregistres+NFhtm+k_TAB;
        DocName:= DF+NFhtm;
//transforme les liens .htm en liens internes (#nom)
        Shtm:=StringFromFile(DocName);
        S1:=Shtm;
        S1:=StringReplace(S1,' ','',[rfReplaceAll]);
        S1:=StringReplace(S1,k_CRLF,'',[rfReplaceAll]);
        S1:=StringReplace(S1,k_TAB,'',[rfReplaceAll]);
//vrifie la prsence de la balise Name
        S2:=GetPathElt(NFhtm , k_peNom); //ote le .htm final
        if Pos('<ANAME="'+UpperCase(S2)+'">' , UpperCase(S1) )=0
          then rapport:=rapport + k_TAB + 'manque balise Name' + k_CRLF;
        liens:='';  liensremp:='';
        repeat
          S2:=Compacter( extrairebalise(S1) );
          if S2='' then break;
          if Pos('AHREF="' , UpperCase(S2) )=1 then begin //recenser
            S2:=Trim( ExtraireStr(1,S2,'"') );
            if (S2<>'') and
               (Pos('://',S2)=0) and     //prserve les liens http://www
               (S2[1]<>'#') then begin
              if Pos('#',S2)=0
               then begin
                 if not lienvalide(S2,liensappeles) then liensappeles:=liensappeles+S2+k_TAB+' -> '+NFhtm+k_TAB;
                 S3:=GetPathElt(S2 , k_peNom); //ote le .htm final
               end else S3:=ExtraireStr(1,S2,'#');   //ote le nom de fichier initial
              liens:=liens+k_TAB+S2;
              liensremp:=liensremp+k_TAB+'#'+S3;
              rapport:=rapport+k_TAB+S2+' ==> '+S3+k_CRLF;
            end;
          end;
        until false;
        //liens contient la liste des liens href
        while liens<>'' do begin
          S1:=getS(liens);
          S2:=getS(liensremp);
          if S1<>'' then Shtm:=StringReplace(Shtm,'"'+S1+'"','"'+S2+'"',[rfReplaceAll]);
        end;
        StringToFile(Shtm,TmpName);
        DocName:=TmpName;
        dochtm:=WinWord.WAP.Documents.Open(DocName,ovF,
                           ovF,ovF,
                           ovBlk,ovBlk,
                           ovF,ovBlk,
                           ovBlk,ovFmt);
        ovUnit:=wdLine; ovCount:=1; OvExtend:=wdExtend;
        WinWord.WAP.Selection.MoveDown(ovUnit,ovCount,OvExtend);
        WinWord.SetStyle_('Titre 2');
        WinWord.SaveAs(dochtm , DF+'temp.doc');
        WinWord.CloseDoc(dochtm,false);
        DocName:=DF+'temp.doc';
        WinWord.WAP.Selection.InsertFile(DocName , ovBlk , ovF , ovF , ovF );//FileName:="SPEC DXF.DOC", Range:="", _        ConfirmConversions:=False, Link:=False, Attachment:=False
      end;
      WinWord.InsertBreak_(wdPageBreak);
      gotoFin;
    until false;
//enregistrer le rsultat
    docdoc.Fields.Update;
    WinWord.SaveAs(docdoc,DocDocName);//DF+'_resultat.doc');
//vrifier les liens
    S1:='';
    while liensappeles<>'' do begin
      S2:=getS(liensappeles);
      NFhtm:=getS(liensappeles);// la suite
      if S2<>'' then begin
        if not lienvalide(S2,liensenregistres) then S1:=S1+S2+NFhtm+k_CRLF;
      end;
    end;
    if S1<>'' then rapport:='liens inconnus :'+k_CRLF+S1+'*******************'+k_CRLF+rapport;
    StringToFile(rapport,DF+'rapport.log');
    LBx.Items.Add('** termin **');
  finally
    FreeWinWord;
    try
      DeleteFile(TmpName);
      DeleteFile(DF+'temp.doc');
    except end;
  end;
end;

procedure TForm3.WRChargeReg;
begin
  DF:=WR.GetStr('dirtrv');
  Check;
end;

procedure TForm3.WRRangeReg;
begin
  WR.PutStr('dirtrv',DF);
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WR.RangeReg;
end;

procedure TForm3.FormActivate(Sender: TObject);
begin
  if not init then begin
    init:=true;
    WR.ChargeReg;
  end;
end;

procedure TForm3.BtChDirClick(Sender: TObject);
begin
  ChDir;
  Check;
end;

end.




(*
;ce fichier est autodocument
;si vous l'ditez par le bloc-notes (recommand!), dsactivez Format|Retour  la ligne automatique
;une ligne commenant par ; est une ligne commentaire
;les lignes blanches sont ignores

;ce fichier dfinit le contenu du fichier rsultat ; chaque ligne contient soit :
; + le nom d'un fichier htm (ex : noeuds.htm) : le fichier est ajout avec un saut de page, sa premire ligne est formate en TITRE 2,
; + ; commentaire : la ligne est ignore,
; + *titre : le titre est ajout comme un TITRE 1

*GENERALITES
histomodifs.htm
nouveautes.htm
credits.htm
index_aide.htm
*LE FONCTIONNEMENT
le_fonctionnement_wincops.htm
les_fichiers_wincops.htm
les_commandes.htm
La_programmation.htm
le_flambement.htm
la_superposition.htm
nouvelle_etude.htm
comment_faire.htm
ca_marche_pas.htm
*LES PRINCIPAUX ECRANS
les_ecrans_wincops.htm
fenetre_wincops.htm
fenetre_config.htm
fenetre_deflist.htm
fenetre_defunit.htm
fenetre_dessin.htm
fenetre_importDXF.htm
fenetre_infobarre.htm
fenetre_infochargement.htm
fenetre_infonoeud.htm
fenetre_listages.htm
fenetre_paramdessin.htm
fenetre_rendu3D.htm
fenetre_seltyp.htm
fenetre_sorttrv.htm
fenetre_versec.htm
*LES ENTITES
les_listes.htm
Les_numros_de_reprage.htm
Le_reperage de type.htm
La_syntaxe.htm
syntaxe_noms.htm
les_expressions.htm
les_fonctions.htm
les_variables.htm
relaxations_abregees.htm
*LES COMMANDES
convtypo.htm
cde_a.htm
cde_ab.htm
cde_allera.htm
cde_angle.htm
cde_arc.htm
cde_assou.htm
cde_b.htm
cde_barres.htm
cde_barres_exemples.htm
cde_bielles.htm
cde_caldyn.htm
cde_calnonlin.htm
cde_calsis.htm
cde_carmat.htm
cde_cas.htm
cde_cas_exemples.htm
cde_casdyn.htm
cde_cassis.htm
cde_cat.htm
cde_charges.htm
cde_coef.htm
cde_combi.htm
cde_comment.htm
cde_comp.htm
cde_cop.htm
cde_cor.htm
cde_cos.htm
cde_couche.htm
cde_couleur.htm
cde_d.htm
cde_debug.htm
cde_decouper.htm
cde_defcoo.htm
cde_defiprop.htm
cde_dl.htm
cde_dot.htm
cde_etatsactifs.htm
cde_exec.htm
cde_fgroupe.htm
cde_fibres.htm
cde_fin.htm
cde_flist.htm
cde_fonction.htm
cde_fso.htm
cde_g.htm
cde_groupe.htm
cde_ignore.htm
cde_ind.htm
cde_interpolce.htm
cde_jarret.htm
cde_joint.htm
cde_lfd.htm
cde_liaisons.htm
cde_list.htm
cde_listvar.htm
cde_m.htm
cde_maillages.htm
cde_masses.htm
cde_mat.htm
cde_maxi.htm
cde_message.htm
cde_ml.htm
cde_mu.htm
cde_n.htm
cde_nbtron.htm
cde_nbtrondef.htm
cde_noeuds.htm
cde_noeuds_exemples.htm
cde_nul.htm
cde_obs.htm
cde_options.htm
cde_ori.htm
cde_p.htm
cde_pap.htm
cde_parois.htm
cde_pervar.htm
cde_pour.htm
cde_prec.htm
cde_projdef.htm
cde_prs.htm
cde_quitter.htm
cde_r.htm
cde_rec.htm
cde_redef.htm
cde_redef.htm
cde_refdoc.htm
cde_regles.htm
cde_relax.htm
cde_rep.htm
cde_rond.htm
cde_rot.htm
cde_s.htm
cde_sa.htm
cde_selch.htm
cde_si.htm
cde_so.htm
cde_sp.htm
cde_sstitre.htm
cde_t.htm
cde_tantque.htm
cde_test.htm
cde_titre.htm
cde_type.htm
cde_unites.htm
cde_xri.htm



