Unit WordUtils;
{
170907 :
appeler CreateWinword pour crer la fentre en dbut d'appli, elle sera automatiquement dtruite  la fin de l'appli
appeler CreateWinword puis FreeWinword pour crer puis dtruire
ATTENTION : cette unit ne doit plus tre instancie par le projet
***************
!!! cette unit doit tre incluse dans le projet pour que le DPR l'instancie
viter d'utiliser les champs dfinir, prfrer des signets normaux en texte masqu ou blanc
14/10/02 utiliser les PROPRIETES plutt que les SIGNETS

OBSOLETE :
 chaque utilisation de l'objet WAP doit tre incluse dans un couple
 d'appels WAP.Connect WAP.Disconnect pour viter les ennuis lis
  l'arrt de Word par l'oprateur
 ex :
procedure TForm1.Button1Click(Sender: TObject);
begin
  WAP.Connect;
  WAP.Documents.Add(EmptyParam,EmptyParam);

//ces lignes pour voir et accder  Word :
  WAP.Application.Visible:=true;
  WAP.Application.Activate;
  showmessage('cliquez ici pour continuer');

//toujours :
  WAP.Disconnect;
end;

Autre possibilit :
    ...
    SaveAs(WAP.ActiveDocument,NF);
    ok:=true;
  finally
    WAP.Disconnect;
  end;
  if ok then ShellExOpen(handle,NF);//visu hors serveur

- AutoQuit doit tre  TRUE
- ConnectKind doit tre  ckNewInstance
- l'vnement OnQuit doit tre implment avec WAP.Disconnect :
procedure TForm1.WAPQuit(Sender: TObject);
begin
  wap.disconnect;
end;


}
interface

uses classes, forms, WordXP, word97, OleServer, Controls, StdCtrls, Buttons,
  CwinReg;

const
  k_noStyle = '';
  k_CR = true;
  k_noCR = false;
  k_wdPreview = true;
  k_wdNoPreview = false;

//redclaration
  wdCollapseStart_ = wdCollapseStart;
  wdCollapseEnd_ = wdCollapseEnd;
  wdMaximumNumberOfColumns_ = wdMaximumNumberOfColumns;
  wdMaximumNumberOfRows_ = wdMaximumNumberOfRows;
  wdStory_ = wdStory;
  wdExtend_ = wdExtend;
  wdCharacter_ = wdCharacter;
  wdCell_ = wdCell;
  wdFieldMergeField_ = wdFieldMergeField;

  wdFormatHTML = 8; //pour SaveAs
  
type
  TWinWord = class(TForm)
    Txt: TLabel;
    BBAnn: TBitBtn;
    WAP: TWordApplication;
    WR: TWinReg;
    procedure WAPQuit(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations private }
    constructor CreateLocal(AOwner: TComponent);
  public
    { Dclarations public }
    DocActif: WordDocument;
    constructor Create(AOwner: TComponent); override;
    procedure NouveauDoc;
    // commandes directes de Word 8
    function ColumnsCount_:longint;
    function ExisteChamp(typeChamp:longint):boolean;
    //function ExisteChampFusion:boolean;
    function ExisteSignet_(nomS:string):boolean;
    procedure FieldsAddSet_(signet,valeur:string);
    procedure SupprimerChampsDefinir; //viter d'utiliser les champs dfinir
    procedure Goto_(What,Which,Count:integer);
    function GotoSignet_(nomS:string;msg:boolean=true):boolean;
    procedure MAJSignet(nomS,valS:string;msg:boolean=true);
    function Information_(quoi:longint):longint;
    procedure InsertAfter_(S:string);
    procedure InsertParagraph_;
    procedure InsertParagraphAfter_;
    procedure InsertBreak_(typebrk:longint);
    procedure MergeCells_;
    procedure MoveRight_(U,Nb,X:longint);//MoveRight de Word
    function NbDocs_: longint;
    function NbSignets_: longint;
    function NomSignet_(i1:longint): string;
    procedure RunMacro_(macro:string);
    procedure SelectionCollapse_(sens: longint);
    procedure SelectionDelete_;
    procedure SelectionEndKey_(unit_,extend:longint);
    procedure SelectionPaste_;
    procedure InsertRows_(count_:longint);
    procedure SelectRow_;
    procedure SetRange_(d,f: longint);
    procedure SelectionMoveStart_(unit_:longint);
    procedure SelectionMoveRight_(unit_,count_,extend_:longint);
    procedure SetStyle_(NomStyle:string);
    procedure SetStyleGSI(GSIgsi:string);
    procedure TypeParagraph_;
    procedure TypeText_(S:string);
    procedure TypeTextNoGuill(S:string);
    procedure TypeTextFmt(data:string); //texte format, voir ci-aprs
    procedure InsertSymbol(CharacterNumber:integer;Unicode:boolean=true;Bias:integer=0);
    // routines
    //procedure InitWord(TitreFen:string);
    procedure AddPicture(NF:string;Wmm,Hmm:longint);
    procedure AffecterSignet(nomS,valS:string);
    procedure ReduireSelectionSignet;
    function ChargerFondDePage(TitreFen,PF:string):boolean;
    function ChargerDocument(TitreFen,PF:string):boolean;
    procedure EnvoyerLignesTbl(SL: TStringList; Ncol,NLig: longint; const k_sep:char); overload;
    procedure EnvoyerLignesTbl(data:string); overload;
    procedure FieldsDelete;
    procedure ImpLig(S,style:string;CR:boolean);//style='' => pas de style
    procedure LireSignets(SL: TStrings);//List);
    procedure MergeCells(nbcells:longint;nomstyle:string);
    procedure Parachever;//active la macro PARACHEVER
    procedure SauterPage;
    procedure VoirWord(preview:boolean);
    procedure PrintAndQuit(quit:boolean);
    procedure WRight(n:longint);//MoveRight de Word
    procedure DefOptionsAccel(Spell,Gramm,Draft,Updat:boolean);
    procedure CreerSourceDonnees(data:string);
    procedure Fusionner;
    procedure CloseDoc(Doc:WordDocument;svg:boolean);
    procedure SaveAs(Doc:WordDocument;FileName : String);
    procedure SaveAsHTML(Doc:WordDocument;FileName : String);
    procedure Save;
    procedure AffichagePage;
  end;

const
  WinWord: TWinWord = nil;
  CF_RTF: word = 0;

procedure CreateWinWord;
procedure FreeWinWord;
function DotToDoc(dot:string):string;

implementation

{$R *.DFM}

uses Windows, SysUtils, ComObj, Variants, Dialogs, Uinfo, StringUtils, Utils, USignetsWord;

procedure CreateWinWord;
begin
  WinWord:= TWinWord.CreateLocal(nil);//Application);
  WinWord.WR.ChargeFenReg;
//  Application.CreateForm(TWinWord,WinWord);
end;

procedure FreeWinWord;
begin
  if WinWord=nil then exit;
  WinWord.WR.RangeFenReg;
  FreeAndNil(WinWord);
end;

constructor TWinWord.Create(AOwner: TComponent);
begin
  ShowMessage('FWinWord ne peut tre instancie directement');
  halt;
end;

constructor TWinWord.CreateLocal(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TWinWord.NouveauDoc;
begin
  DocActif:=WAP.Documents.Add(EmptyParam,EmptyParam)
end;

function TWinWord.NbDocs_: longint;
begin
  Result:=WAP.Documents.Count;
end;

function TWinWord.NbSignets_: longint;
begin
  Result:=WAP.ActiveDocument.Bookmarks.Count;
end;

function TWinWord.NomSignet_(i1:longint): string;
var
  ov: OleVariant;
begin
  ov:=i1;
  Result:=WAP.ActiveDocument.Bookmarks.Item(ov).Name;
end;

//rcupr de UQual (OrgIdes)

function CodeDoc(NF:string):string;
var
  i: integer;
begin
  i:=Pos('.',NF)-6; //150407
  if i<=0 then result:='' else result:=Copy(NF,i,6);
end;

function Indice(NF:string):string;
var
  H,M,S,MS: word;
begin
  result:='erreur';
  if not FileExists(NF) then exit;
  DecodeTime( FileDateToDateTime(FileAge(NF)),H,M,S,MS);
  case H of
   0:result:='prim';
   1:result:='0';
   2..27:result:=chr( ord('A')+H-2 );
  end;
end;
//
//********************************************************************************
//
procedure TWinWord.LireSignets(SL: TStrings);//090403 List);
var
  i: longint;
begin
//  if not WordOk then exit;
  for i:=1 to NbSignets_ do SL.Add(NomSignet_(i));
end;

function TWinWord.ChargerFondDePage(TitreFen,PF:string):boolean;
var
  DocName, ovMP, ovFmt, ovF,OvT : OleVariant;
  DocTemplate, NewTemplate : OleVariant;
  savcur: TCursor;
begin
  Result:=false;
  if WAP=NIL then exit;
  PF:=ExpandUNCFileName(PF);
  if (PF<>'') and (not FileExists(PF)) then exit;
  if UpperCase(ExtractFileExt(PF))='.DOC' then begin // 23/11/03 : traite le document comme un modle
    with WAP do try
      Caption := '';
      Visible := false;//True;//false; //
      DocName := PF;
      OvF:=false;
      OvT:=true;
      savcur:=Screen.Cursor;
      Screen.Cursor:=crHourGlass;
      try
        ovF:=false;
        ovFmt:=wdOpenFormatDocument;
        ovMP:='';
  //showmessage('open');
        DocActif:=WAP.Documents.Open(DocName,ovF,
                           ovT,ovF,
                           ovMP,ovMP,
                           ovF,ovMP,
                           ovMP,ovFmt);
  {    function  Open(var FileName: OleVariant; var ConfirmConversions: OleVariant;
                     var ReadOnly: OleVariant; var AddToRecentFiles: OleVariant;
                     var PasswordDocument: OleVariant; var PasswordTemplate: OleVariant;
                     var Revert: OleVariant; var WritePasswordDocument: OleVariant;
                     var WritePasswordTemplate: OleVariant; var Format: OleVariant): WordDocument; safecall;}
        Result:=true;
      finally
        Screen.Cursor:=savcur;
      end;
    except
      on E:EOleSysError do ShowMessage(E.Message);
    end;
    exit;
  end;
//ancienne version pour .DOT
  with WAP do try
    while NbDocs_>0 do CloseDoc(WAP.ActiveDocument,false);
    Caption := '';
    Visible := false;//True;//false; //
//12052001      while NbDocs_>0 do CloseDoc(false);//Application.Documents.Item(ov).Close(ovSC,ovOF,ovRD);
    DocTemplate := PF;
    NewTemplate := False;
    savcur:=Screen.Cursor;
    Screen.Cursor:=crHourGlass;
    try
      WAP.Documents.Add(DocTemplate,NewTemplate);
      EcrireProprieteWX('AUTOCode_enr',CodeDoc(PF)+'-'+Indice(PF),WAP,k_appWord);
    finally
      Screen.Cursor:=savcur;
    end;
    Result:=true;
  except
    on E:EOleSysError do ShowMessage(E.Message);
  end;
end;

function TWinWord.ChargerDocument(TitreFen,PF:string):boolean;
var
  DocName,
  ovMP,
  ovFmt, ovF : OleVariant;
  savcur: TCursor;
begin
  Result:=false;
  if WAP=NIL then exit;
  PF:=ExpandUNCFileName(PF);
  if (PF<>'') and (not FileExists(PF)) then exit;
  with WAP do try
//    while NbDocs_>0 do CloseDoc(WAP.ActiveDocument,false);  le 250303 car demande enreg barre_boutons_devis.dot
    Caption := '';
    Visible := false;//True;//false; //
//12052001      while NbDocs_>0 do CloseDoc(false);//Application.Documents.Item(ov).Close(ovSC,ovOF,ovRD);
    DocName := PF;
    savcur:=Screen.Cursor;
    Screen.Cursor:=crHourGlass;
    try
      ovF:=false;
      ovFmt:=wdOpenFormatDocument;
      ovMP:='';
//showmessage('open');
      DocActif:=WAP.Documents.Open(DocName,ovF,
                         ovF,ovF,
                         ovMP,ovMP,
                         ovF,ovMP,
                         ovMP,ovFmt);
{    function  Open(var FileName: OleVariant; var ConfirmConversions: OleVariant;
                   var ReadOnly: OleVariant; var AddToRecentFiles: OleVariant;
                   var PasswordDocument: OleVariant; var PasswordTemplate: OleVariant;
                   var Revert: OleVariant; var WritePasswordDocument: OleVariant;
                   var WritePasswordTemplate: OleVariant; var Format: OleVariant): WordDocument; safecall;}
      Result:=true;
    finally
      Screen.Cursor:=savcur;
    end;
  except
    on E:EOleSysError do ShowMessage(E.Message);
  end;
end;

procedure TWinWord.FieldsDelete;
begin
  with WAP.ActiveDocument do
       while MailMerge.Fields.Count>0 do MailMerge.Fields.Item(1).Delete;
end;

procedure TWinWord.SupprimerChampsDefinir;
var
  i,n: longint;
begin
  with WAP.ActiveDocument.MailMerge do begin
    n:=Fields.Count;
    for i:=n downto 1 do if Fields.Item(i).Type_=wdFieldSet then Fields.Item(i).Delete;
  end;
end;

procedure TWinWord.FieldsAddSet_(signet,valeur:string);
var
  ovTyp,ovTxt,ovPF: OleVariant;
begin
//  valeur:=StringReplace(valeur,'"','''',rfReplaceAll);
  valeur:=AnsiQuotedStr(valeur,'"');

//  ovTyp:=wdFieldEmpty;
//  ovTxt:='DEFINIR '+signet+' '+valeur;
  ovTyp:=wdFieldSet;
  ovTxt:=signet+' '+valeur;
  ovPF:=true;//prserver format
  with WAP,ActiveDocument do
       Fields.Add(Selection.Range,ovTyp,ovTxt,ovPF);
end;

function TWinWord.Information_(quoi:longint):longint;
begin
  Result:=WAP.Selection.Information[quoi];
end;

function TWinWord.ExisteChamp(typeChamp:longint):boolean;
var
  i,n: longint;
begin
  Result:=true;
  with WAP.ActiveDocument.MailMerge do begin
    n:=Fields.Count;
    for i:=1 to n do if Fields.Item(i).Type_=typeChamp then exit;
  end;
  Result:=false;
end;

function TWinWord.ExisteSignet_(nomS:string):boolean;
begin
  Result:=WAP.ActiveDocument.Bookmarks.Exists(nomS);
end;

procedure TWinWord.Goto_(What,Which,Count:integer);
var
  ovWhat,ovWhich,ovCount,ovName: OleVariant;
begin
  ovWhat:=What;
  ovWhich:=Which;
  ovCount:=Count;
  ovName:='';
  WAP.ActiveDocument.Goto_(ovWhat,ovWhich,ovCount,ovName);
end;

function TWinWord.GotoSignet_(nomS:string;msg:boolean=true):boolean;
var
  ov1,ov2: OleVariant;
begin
  result:=false;
  if not ExisteSignet_(nomS) then begin
    if msg then ShowMessage(nomS+' : signet introuvable');
    exit;
  end;
  ov1:=nomS;
  WAP.ActiveDocument.Bookmarks.Item(ov1).Select;
  result:=true;
{  ov1:=nomS;
  ov2:=wdGoToBookMark;
  WAP.Selection.GoTo_(ov2,EmptyParam,EmptyParam,ov1);}
end;

procedure TWinWord.AffecterSignet(nomS,valS:string);
begin
      SetRange_(0,0);
      FieldsAddSet_(nomS,valS);
       {  ov:=valS;
  with WAP, ActiveDocument do begin
    Selection.SetRange(0,0);
    MailMerge.Fields.AddSet(Selection.Range,nomS,ov,ov);
  end;}
end;

procedure TWinWord.MAJSignet(nomS,valS:string;msg:boolean=true);
begin
  if not WinWord.GotoSignet_(nomS,msg)then exit;
  WinWord.ReduireSelectionSignet;     //conserve un caractre  chaque extrmit
  WinWord.TypeText_(valS);
end;

procedure TWinWord.MoveRight_(U,Nb,X:longint);//MoveRight de Word
var
  U_,Nb_,X_: OleVariant;
begin
  U_:=U;//wdCell;
  Nb_:=Nb;//n;
  X_:=X;//wdMove;
  WAP.Selection.MoveRight(U_,Nb_,X_);
end;

procedure TWinWord.ReduireSelectionSignet;
var
  U_,Nb_: OleVariant;
begin
  U_:=wdCharacter;
  Nb_:=1;
  WAP.Selection.MoveStart(U_,Nb_);
  Nb_:=-1;
  WAP.Selection.MoveEnd(U_,Nb_);
end;

procedure TWinWord.SetStyle_(NomStyle:string);
var
  ovS: OleVariant;
begin
  ovS:=NomStyle;
  WAP.Selection.Set_Style(ovS);
end;

procedure TWinWord.SetStyleGSI(GSIgsi:string);
begin
  while GSIgsi<>'' do begin
    case GSIgsi[1] of
    'G':WAP.Selection.Font.Bold:=$FFFFFFFF;//msotrue;
    'g':WAP.Selection.Font.Bold:=$00000000;//msofalse;
    'I':WAP.Selection.Font.Italic:=$FFFFFFFF;//msotrue;
    'i':WAP.Selection.Font.Italic:=$00000000;//msofalse;
    'S':WAP.Selection.Font.Underline:=$FFFFFFFF;//msotrue;
    's':WAP.Selection.Font.Underline:=$00000000;//msofalse;
    end;
    Delete(GSIgsi,1,1);
  end;
end;

procedure TWinWord.TypeText_(S:string);
begin
  WAP.Selection.TypeText(S);
end;

procedure TWinWord.TypeTextNoGuill(S:string);
begin
  WAP.Selection.TypeText( StringReplace(S,'"','',[rfReplaceAll]) );
end;

procedure TWinWord.InsertSymbol(CharacterNumber:integer;Unicode:boolean=true;Bias:integer=0);
var
  Unicode_,Bias_: OleVariant;
begin
  Bias_:=Bias;
  Unicode_:=Unicode;
  WAP.Selection.InsertSymbol(CharacterNumber,EmptyParam,Unicode_,Bias_);
end;

procedure TWinWord.InsertAfter_(S:string);
begin
  WAP.Selection.InsertAfter(S);
end;

procedure TWinWord.InsertParagraph_;
begin
  WAP.Selection.InsertParagraph;
end;

procedure TWinWord.InsertParagraphAfter_;
begin
  WAP.Selection.InsertParagraphAfter;
end;

procedure TWinWord.SelectionCollapse_(sens: longint);
var
  ovS: OleVariant;
begin
  ovS:=sens;
  WAP.Selection.Collapse(ovS);
end;

procedure TWinWord.SelectionPaste_;
begin
  WAP.Selection.Paste;
end;

procedure TWinWord.SelectionDelete_;
begin
  WAP.Selection.Delete(EmptyParam,EmptyParam);
end;

procedure TWinWord.SelectionEndKey_(unit_,extend:longint);
var
  ovU,ovX: OleVariant;
begin
  ovU:=unit_;
  ovX:=extend;
  WAP.Selection.EndKey(ovU,ovX);
end;

procedure TWinWord.SelectionMoveStart_(unit_:longint);
var
  ovU: OleVariant;
begin
  ovU:=unit_;
  WAP.Selection.MoveStart(ovU,EmptyParam);
end;

procedure TWinWord.SelectionMoveRight_(unit_,count_,extend_:longint);
var
  ovU, ovC, ovX: OleVariant;
begin
  ovU:=unit_;
  ovC:=count_;
  ovX:=extend_;
  WAP.Selection.MoveRight(ovU,ovC,ovX);
end;

procedure TWinWord.SetRange_(d,f: longint);
begin
  WAP.Selection.SetRange(d,f);
end;

procedure TWinWord.TypeParagraph_;
begin
  WAP.Selection.TypeParagraph;
end;

procedure TWinWord.InsertBreak_(typebrk:longint);
var
  ov: OleVariant;
begin
  ov:=typebrk;
  WAP.Selection.InsertBreak(ov);
end;

procedure TWinWord.MergeCells_;
begin
  WAP.Selection.Cells.Merge;
end;

procedure TWinWord.RunMacro_(macro:string);
begin
  try
    WAP.Run(macro);
  except
    on EOleSysError do ;
{ DONE : 24/9/00:n'affiche plus d'erreur ShowMessage('macro '+macro+' introuvable'); }
  end;
end;

procedure TWinWord.InsertRows_(count_:longint);
var
  ov: OleVariant;
begin
  ov:=count_;
  WAP.Selection.InsertRows(ov);
end;

procedure TWinWord.SelectRow_;
begin
  WAP.Selection.SelectRow;
end;

function TWinWord.ColumnsCount_:longint;
begin
  Result:=WAP.Selection.Columns.Count;
end;

///
///*****************************************************************************
///

procedure TWinWord.WRight(n:longint);//MoveRight de Word
begin
  MoveRight_(wdCell,n,wdMove);
end;

procedure TWinWord.MergeCells(nbcells:longint;nomstyle:string);
begin
  MoveRight_(wdCharacter,nbcells,wdExtend);
  MergeCells_;
  if nomstyle<>''then SetStyle_(nomstyle);
end;

procedure TWinWord.ImpLig(S,style:string;CR:boolean);
begin
  if style='' then TypeText_(S)
  else begin
    SelectionCollapse_(wdCollapseStart);
    InsertAfter_(S);
    SetStyle_(style);
    SelectionCollapse_(wdCollapseEnd);
  end;
  if CR then TypeParagraph_;
end;

procedure TWinWord.EnvoyerLignesTbl(SL: TStringList; Ncol,NLig: longint; const k_sep:char);
//cal pour MADO, ne pas toucher
var
  i,j: longint;
  S,S1: string;
begin
  for i:=1 to NLig do begin
    if i>1 then WRight(1);//nv
    if i>SL.Count then S:='' else S:=SL[i-1];
    for j:=1 to NCol-1 do begin
      S1:=ExtraireStr(j-1,S,k_sep);
      TypeText_(S1);
      WRight(1);
    end;
    TypeText_(ExtraireStr(NCol-1,S,k_sep));
  end;
end;

procedure TWinWord.EnvoyerLignesTbl(data:string);
//lignes spares par CRLF, colonnes par TAB
var
  Sl,Sc: string;
begin
  if data='' then exit;
  repeat
    Sl:=LigLireEtOter(data);
    repeat
      Sc:=LireEtOterStr0(Sl,#9);
      TypeText_(Sc);
      if Sl='' then break;
      WRight(1);
    until false;
    if data='' then break;
    WRight(1);
  until false;
end;

procedure TWinWord.SauterPage;
begin
  InsertBreak_(wdPageBreak);
//saute la fin de para insre par InsertBreak : utile dans les tableaux
  MoveRight_(wdCharacter,1,wdMove);
end;

procedure TWinWord.AddPicture(NF:string;Wmm,Hmm:longint);
var
  ovLtf, ovSwd, ovAnc,ovL,ovT,ovW,ovH,ovInlSh: OleVariant;
begin
  ovLtf:=false;//link
  ovSwd:=true;//save with
  ovL:=0;
  ovT:=0;
  with WAP,ActiveDocument do begin
    ovW:=MillimetersToPoints(Wmm);
    ovH:=MillimetersToPoints(Hmm);
    ovAnc:=Selection.Range;
    SelectionCollapse_(wdCollapseEnd_);
    ovInlSh:=InlineShapes.AddPicture(NF,ovLtf,ovSwd,ovAnc);
    ovInlSh.LockAspectRatio:=true;//18/2/10
    ovInlSh.Height:=ovH;
    ovInlSh.Width:=ovW;
  end;
end;

procedure TWinWord.Parachever;
begin
  RunMacro_('PARACHEVER');
end;

{
procedure TWinWord.VoirWord(App:TApplication;WAP:TWordApplication;preview:boolean);
var
  savOQ: TNotifyEvent;
  FI: TFInfo;
begin
  WordQuit:=false;
  FI:=TFInfo.Create;
  try
    with WAP do begin
      @savOQ:=@OnQuit;
      @OnQuit:=@WAPQuit;
      FI.Debut(0,0,fiNoTop,'Word',0,false,true,true);//bouton annuler
      FI.MAJ(0,'fermez Word ou cliquez sur Annuler');
      App.Minimize;
      Visible:=true;
      Activate;
      if preview then ActiveDocument.PrintPreview;
      repeat
        App.ProcessMessages;
        if FI.TestAbandon then exit;
      until WordQuit;
      savOQ;
  //    showmessage('cliquez ici pour continuer');
    end;
  finally
    App.Restore;
    FI.Free;
    @WAP.OnQuit:=@savOQ;
  end;
end;
}

procedure TWinWord.VoirWord(preview:boolean);
begin
  try
    if preview then WAP.ActiveDocument.PrintPreview;
    Txt.Caption:='fermez Word ou cliquez ici pour continuer';
    ShowModal;
//      showmessage('fermez Word ou cliquez ici pour continuer');
  finally
    Application.Restore;
  end;
end;

procedure TWinWord.PrintAndQuit(quit:boolean);
var
  ov: OleVariant;
begin
  try
    ov:=false;
    WAP.PrintOut(ov,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
{    WAP.Quit(ov);
    repeat
      App.ProcessMessages;
    until  (WAP.BackgroundPrintingStatus=0);}
  finally
    ov:=wdDoNotSaveChanges;
    if quit then WAP.Quit(ov);
  end;
end;

procedure TWinWord.DefOptionsAccel(Spell,Gramm,Draft,Updat:boolean);
begin
  with WAP do begin
    Options.CheckSpellingAsYouType := Spell;
    Options.CheckGrammarAsYouType := Gramm;
    ActiveWindow.View.Draft:=Draft;
    ScreenUpdating:=Updat;
  end;
end;

procedure TWinWord.CreerSourceDonnees(data:string);
var
  ovSep, ovNF, ovFrm: OleVariant;
begin
  ovSep:=wdSeparateByTabs;
  ovNF:='c:\fusion.doc';
  ovFrm:=wdFormatDocument;
  with WAP do begin
    Documents.Add(EmptyParam,EmptyParam);
    Selection.InsertAfter(data);
    Selection.ConvertToTable(ovSep,EmptyParam,   //var Separator: OleVariant; var NumRows: OleVariant;
                             EmptyParam,EmptyParam, //var NumColumns: OleVariant; var InitialColumnWidth: OleVariant;
                             EmptyParam,EmptyParam, //var Format: OleVariant; var ApplyBorders: OleVariant;
                             EmptyParam,EmptyParam, //var ApplyShading: OleVariant; var ApplyFont: OleVariant;
                             EmptyParam,EmptyParam, //var ApplyColor: OleVariant; var ApplyHeadingRows: OleVariant;
                             EmptyParam,EmptyParam, //var ApplyLastRow: OleVariant; var ApplyFirstColumn: OleVariant;
                             EmptyParam,EmptyParam); //var ApplyLastColumn: OleVariant; var AutoFit: OleVariant): Table; safecall;
    ActiveDocument.SaveAs(ovNF,ovFrm, //var FileName: OleVariant; var FileFormat: OleVariant;
             EmptyParam,EmptyParam, //var LockComments: OleVariant; var Password: OleVariant;
             EmptyParam,EmptyParam, //var AddToRecentFiles: OleVariant; var WritePassword: OleVariant;
             EmptyParam,EmptyParam, //var ReadOnlyRecommended: OleVariant; var EmbedTrueTypeFonts: OleVariant;
             EmptyParam,EmptyParam, //var SaveNativePictureFormat: OleVariant; var SaveFormsData: OleVariant;
             EmptyParam); //var SaveAsAOCELetter: OleVariant); safecall;
    ActiveDocument.Close(EmptyParam,EmptyParam,EmptyParam);
  end;
end;

procedure TWinWord.Fusionner;
var
  ovT, ovF, ovFrmt, ovBlk: OleVariant;
  PF: string;
begin
  ovT:=true; ovF:=false; ovBlk:='';
  ovFrmt:=wdOpenFormatDocument;
  PF:='c:\fusion.doc';
  with WAP.ActiveDocument do begin
    MailMerge.MainDocumentType:=wdFormLetters;
    MailMerge.OpenDataSource(PF,ovFrmt,              //const Name: WideString; var Format: OleVariant;
                             ovF,ovT,                //var ConfirmConversions: OleVariant; var ReadOnly: OleVariant;
                             ovT,ovF,                //var LinkToSource: OleVariant; var AddToRecentFiles: OleVariant;
                             ovBlk,ovBlk,            //var PasswordDocument: OleVariant; var PasswordTemplate: OleVariant;
                             ovF,ovBlk,              //var Revert: OleVariant; var WritePasswordDocument: OleVariant;
                             ovBlk,ovBlk,            //var WritePasswordTemplate: OleVariant; var Connection: OleVariant;
                             ovBlk,ovBlk);           //var SQLStatement: OleVariant; var SQLStatement1: OleVariant
    MailMerge.Destination:=wdSendToNewDocument;
    MailMerge.Execute(ovF);
  end;
end;

procedure TWinWord.CloseDoc(Doc:WordDocument;svg:boolean);
var
  SaveChanges,
  OriginalFormat,
  RouteDocument  : OleVariant;
begin
//  at:=Doc.Get_AttachedTemplate;//
//  at.Saved:=true;
//  if svg then Doc.Save;
  SaveChanges := svg;//WdDoNotSaveChanges;
  OriginalFormat := UnAssigned;
  RouteDocument := UnAssigned;
  Doc.Close(SaveChanges,OriginalFormat,RouteDocument);
end;

procedure TWinWord.SaveAsHTML(Doc:WordDocument;FileName : String);
var
  ov1,ov2: OleVariant;
begin
  ov1:=FileName;
  ov2:=wdFormatHTML;
  Doc.SaveAs(ov1,ov2,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
end;

procedure TWinWord.SaveAs(Doc:WordDocument;FileName : String);
var
  ov: OleVariant;
begin
  ov:=FileName;
  Doc.SaveAs(ov,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
{  SaveAs(FileName, FileFormat, LockComments, Password, AddToRecentFiles, WritePassword, ReadOnlyRecommended, EmbedTrueTypeFonts, SaveNativePictureFormat, SaveFormsData, SaveAsAOCELetter)
FileName   Argument de type Variant facultatif. Nom  affecter au document. Il s'agit
           par dfaut du dossier et du nom de fichier courants. Si le document n'a pas
           encore t enregistr, le nom par dfaut est utilis (par exemple, Doc1.doc).
           Si cet argument a dj t spcifi pour un document, celui-ci est cras
           sans que l'utilisateur n'en soit averti.
FileFormat   Argument de type Variant facultatif. Format sous lequel le document est enregistr.
             Il peut s'agir de l'une des constantes WdSaveFormat suivantes:
             wdFormatDocument, wdFormatDOSText, wdFormatDOSTextLineBreaks, wdFormatRTF,
             wdFormatTemplate, wdFormatText, wdFormatTextLineBreaks ou wdFormatUnicodeText.
             Pour enregistrer un document sous un format diffrent, spcifiez la
             valeur approprie pour la proprit SaveFormat de l'objet FileConverter.
LockComments   Argument de type Variant facultatif. Affectez-lui la valeur True pour
             protger le document contre l'insertion de commentaires.
Password   Argument de type Variant facultatif. Chane du mot de passe permettant l'ouverture du document.
AddToRecentFiles   Argument de type Variant facultatif. Affectez-lui la valeur True
             pour ajouter le document  la liste des derniers fichiers utiliss qui
             s'affiche en bas du menu Fichier.
WritePassword   Argument de type Variant facultatif. Chane du mot de passe permettant
             l'enregistrement des modifications apportes au document.
ReadOnlyRecommended   Argument de type Variant facultatif. Affectez-lui la valeur True
             pour que Word propose le mode lecture seule  chaque ouverture du document.
EmbedTrueTypeFonts   Argument de type Variant facultatif. Affectez-lui la valeur True
             pour enregistrer les polices TrueType avec le document.
SaveNativePictureFormat   Argument de type Variant facultatif. Si des graphiques
             ont t imports d'une autre plateforme (Macintosh), affectez-lui la
             valeur True pour enregistrer uniquement la version Windows des graphiques imports.
SaveFormsData   Argument de type Variant facultatif. Affectez-lui la valeur True
             pour enregistrer les donnes saisies dans un formulaire par un utilisateur
             comme un enregistrement de donnes.
SaveAsAOCELetter   Argument de type Variant facultatif. Si le document a un bordereau
             d'expdition attach, affectez-lui la valeur True pour enregistrer le
             document sous le forme d'une lettre AOCE (le bordereau d'expdition est enregistr).
}
end;

procedure TWinWord.Save;
begin
  WAP.ActiveDocument.Save;
end;

procedure TWinWord.WAPQuit(Sender: TObject);
begin
  try
    WAP.Disconnect;
    ModalResult:=mrOK;
  except
    on exception do;
  end;
end;

procedure TWinWord.TypeTextFmt(data:string); //texte format, voir ci-aprs
{la proc assure les remplacements suivants :
#12 (FF) : saut de page
envoi de texte grec : &&\texte& affiche <texte> avec la police greekc
 (texte ne peut pas commencer avec &,#)
dfinition de police  : &&#nom_police& (fin par &),
                        &&%taille_police&
dfinitions de styles : &&@xxx& (fin par &), (il peut n'y avoir qu'un seul x)
                        o x=G,g,I,i,S,s G=gras I=italique S=soulign
                          la majuscule active le style, la minuscule dsactive
                        ou x=Cy : dfinition de couleur, y=N (noir), Vert, Bleu, Rouge, Jaune
                        &&@GSCR& est admis
}
var
  S,Sf,Sprm: string;
begin
  repeat
    S:=StrLireEtOterStr0(data,'&&');  //atteint &&
    TypeText_(S); //et imprime
    S:=LireEtOterDebutStr(data,1)+' '; // && est parti, lit car svt
    Sprm:=StrLireEtOterStr0(data,'&');
    case S[1] of
      ' ':;
      '@':if (Sprm+' ')[1]<>'C' then SetStyleGSI(Sprm); //style (couleur ignore)
      '#':WAP.Selection.Font.Name:=Sprm; //police
      '\':begin //txt grec
        Sf:=WAP.Selection.Font.Name;
        WAP.Selection.Font.Name:='greekc';
        TypeText_(Sprm); //et imprime le texte
        WAP.Selection.Font.Name:=Sf;
       end;
       '%':WAP.Selection.Font.Size:=StrToInt(Sprm);
    end;
  until data='';
end;

procedure TWinWord.FormShow(Sender: TObject);
begin
//  Application.Minimize;  19/11/01 sinon l'appli n'a plus la main
  WAP.Visible:=true;
  WAP.Activate;
end;

procedure TWinWord.AffichagePage;
begin
  if WAP.ActiveWindow.View.SplitSpecial = wdPaneNone
   then WAP.ActiveWindow.ActivePane.View.Type_ := wdPrintView
   else WAP.ActiveWindow.View.Type_ := wdPrintView;
end;

function DotToDoc(dot:string):string;
begin
  result:=dot;
  if UpperCase(ExtractFileExt(dot))='.DOT' then result[length(result)]:='c';
end;

initialization
  CF_RTF:=RegisterClipboardFormat('Rich Text Format');
finalization
  FreeWinWord;
end.




















(*
  procedure envoi_signet(sig,val:string);
  begin
//    WinWord.AffecterSignet(sig,val);   //va avec ESdocNouv.ParValeur=true
    WinWord.GotoSignet_(sig);
    WinWord.ReduireSelectionSignet;     //conserve un caractre  chaque extrmit
    WinWord.TypeText_(val);
  end;

procedure TWinWord.InitWord(TitreFen:string);
var
  FI: TWinWord;
begin
  begin
    FI:=TWinWord.Create(Nil);
    try
      FI.Debut(0,0,false,TitreFen,0,false,true,false);
      FI.MAJ(0,'chargement de Word ...');
      WordObj := TWordObject.Create;
    finally
      FI.Free;
    end;
  end;
end;


